# Embedded file name: /usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/plugin.py
from . import _
from __init__ import _
from Components.ActionMap import ActionMap, NumberActionMap
from Components.Button import Button
from Components.config import config, ConfigSet, ConfigClock, ConfigSubsection, ConfigYesNo, ConfigInteger, ConfigSelection, getConfigListEntry
from Components.ConfigList import ConfigListScreen
from Components.GUIComponent import GUIComponent
from Components.HTMLComponent import HTMLComponent
from Components.MultiContent import MultiContentEntryText, MultiContentEntryPixmapAlphaTest, MultiContentEntryPixmapAlphaBlend
from Components.Pixmap import Pixmap
from Components.Renderer.CoolPico import findCoolPicon, CoolAlternative
from Components.ScrollLabel import ScrollLabel
from Components.ServiceEventTracker import ServiceEventTracker
from Components.Sources.Event import Event
from Components.Sources.ServiceEvent import ServiceEvent
from Components.TimerList import TimerList
from enigma import eTimer, eServiceCenter, eServiceReference, eEPGCache, eListbox, eListboxPythonMultiContent, ePicLoad, iPlayableService, getDesktop, gFont, loadPNG, RT_HALIGN_LEFT, RT_HALIGN_RIGHT, RT_HALIGN_CENTER, RT_VALIGN_CENTER, RT_WRAP, eRect
from Plugins.Plugin import PluginDescriptor
from RecordTimer import RecordTimerEntry, parseEvent
from Screens.ChoiceBox import ChoiceBox
from Screens.InfoBarGenerics import InfoBarPlugins, SimpleServicelist
from Screens.MessageBox import MessageBox
from Screens.Screen import Screen
from Screens.TimeDateInput import TimeDateInput
from Screens.TimerEdit import TimerEditList, TimerSanityConflict
from Screens.TimerEntry import TimerEntry
from Screens.VirtualKeyBoard import VirtualKeyBoard
from ServiceReference import ServiceReference
from skin import parseColor, parseFont
from datetime import datetime, timedelta
from time import localtime, time, strftime, mktime
from Tools.Directories import fileExists, resolveFilename
from Tools.NumericalTextInput import NumericalTextInput
import NavigationInstance
import os
hcgsf = None
obyqg = None
vtewf = None
hrwhs = False
uhghe = None
if fileExists('/usr/lib/enigma2/python/Plugins/Extensions/SeriesPlugin/plugin.pyo'):
    nabim = True
else:
    nabim = False
if fileExists('/usr/lib/enigma2/python/Plugins/Extensions/TheTVDB/plugin.pyo'):
    ktssu = True
else:
    ktssu = False
if fileExists('/usr/lib/enigma2/python/Plugins/Extensions/IMDb/plugin.pyo'):
    kasgg = True
else:
    kasgg = False
if fileExists('/usr/lib/enigma2/python/Plugins/Extensions/TMDb/plugin.pyo'):
    anzhl = True
else:
    anzhl = False
if fileExists('/usr/lib/enigma2/python/Plugins/Extensions/OFDb/plugin.pyo'):
    ljoja = True
else:
    ljoja = False
xdooe = None
cixoa = None
suphf = None
fkqeh = None
zgrqf = None
yltlg = None
vtwsp = False
shuhr = '124'
xxdtq = '57698'
baaaj = '75242679732282'
fqmck = '48035276213968'
yacuo = '97836241547864'
xyaoy = '21012021097821'
mohdd = '85369741673792'
tzwbc = '3271569319294619'
cqujw = '38710248675294'
tefzi = '6429532564383862'
ijafg = '54918573642583'
wjtzs = 'V7.6.0'
Po = '\n   - - -  C o o l  T V  G u i d e  ' + wjtzs + "  - - -\n\nIf you like this plugin and you want to support it,\nor if you just want to say ''thanks''\n\n\nplease donate via PayPal \n\nPayPal account: cooltvguide@gmail.com\n\nThanks a lot !\n\n\n\nInformation & Support: http://www.CoolTVGuide.com \n(c) 2017 by Coolman"
ktyve = '   Cool TV Guide ' + '.\n   (c) 2017 by Coolman\n\n   New Version Is Now Available ,\n   Please upgrade it at: \n\n   http://www.CoolTVGuide.com'
cefiv = []
owggg = [('Zap', _('Zap')),
 ('Zap + Exit', _('Zap + Exit')),
 ('CoolSearch', _('CoolSearch')),
 ('CoolInfoBox', _('CoolInfoBox')),
 ('GuideSwitch', _('GuideSwitch')),
 ('Cool Info Guide', _('Cool Info Guide')),
 ('Timer', _('Timer')),
 ('QuickRec', _('QuickRec')),
 ('AutoTimer', _('AutoTimer')),
 ('PrimeTime', _('PrimeTime')),
 ('EPG Select', _('EPG Select')),
 ('Bouquet +', _('Bouquet +')),
 ('Bouquet -', _('Bouquet -')),
 ('Bouquetlist', _('Bouquetlist')),
 ('...', _('...'))]
eatzq = [('0', _('None')),
 ('1', _('Cool Info Guide')),
 ('2', _('Cool Single Guide')),
 ('3', _('Cool Easy Guide')),
 ('4', _('Cool Channel Guide')),
 ('5', _('Cool TV Guide')),
 ('6', _('Cool Tiny Guide')),
 ('7', _('Cool Multi Guide')),
 ('8', _('Cool Nice Guide')),
 ('9', _('Prime Time')),
 ('10', _('Cool Search')),
 ('11', _('Timer List'))]
config.CTVG = ConfigSubsection()
config.CTVG.C10 = ConfigSet(choices=[])
config.CTVG.C11 = ConfigYesNo(default=True)
config.CTVG.C28 = ConfigYesNo(default=True)
config.CTVG.C12 = ConfigSelection(default='EPG Select', choices=owggg)
config.CTVG.C13 = ConfigSelection(default='Zap + Exit', choices=owggg)
config.CTVG.C14 = ConfigSelection(default='Timer', choices=owggg)
config.CTVG.C15 = ConfigSelection(default='AutoTimer', choices=owggg)
config.CTVG.C16 = ConfigSelection(default='GuideSwitch', choices=owggg)
config.CTVG.C17 = ConfigSelection(default='Bouquetlist', choices=owggg)
config.CTVG.C18 = ConfigSelection(default='CoolSearch', choices=owggg)
config.CTVG.C19 = ConfigSelection(default='CoolInfoBox', choices=owggg)
config.CTVG.C20 = ConfigSelection(default='Zap', choices=owggg)
config.CTVG.C21 = ConfigSelection(default='...', choices=owggg)
config.CTVG.C22 = ConfigSelection(choices=[('1', _('Cool Info Guide')),
 ('2', _('Cool Single Guide')),
 ('3', _('Cool Easy Guide')),
 ('4', _('EPG Select')),
 ('0', _('...'))], default='1')
config.CTVG.C23 = ConfigSelection(choices=[('1', _('Cool Info Guide')),
 ('2', _('Cool Single Guide')),
 ('3', _('Cool Easy Guide')),
 ('4', _('EPG Select')),
 ('0', _('...'))], default='1')
ohmxk = {'C': 'if',
 'oo': 'conf',
 'l': 'ig et',
 'T': 'h0 ',
 'V': '| gr',
 'G': 'ep HW',
 'U': 'addr ',
 'I': '| awk ',
 'D': "'{ pri",
 'E': "nt $5 }'"}
config.CTVG.C24 = ConfigSelection(choices=[('1', _('Bouquet +')),
 ('2', _('Bouquet -')),
 ('3', _('Page Up')),
 ('4', _('Page Down'))], default='1')
config.CTVG.C25 = ConfigSelection(choices=[('1', _('Bouquet +')),
 ('2', _('Bouquet -')),
 ('3', _('Page Up')),
 ('4', _('Page Down'))], default='2')
config.CTVG.C26 = ConfigSelection(default=' ', choices=[' '])
config.CTVG.C27 = ConfigClock(default=time())
config.CTVG.Key = ConfigInteger(default=0, limits=(0, 99999999))
config.CTVG.C29 = ConfigSelection(choices=['No',
 'Standard',
 'SkinDesign',
 'MyDesign'], default='Standard')
config.CTVG.C30 = ConfigClock(default=69300)
config.CTVG.C31 = ConfigYesNo(default=False)
config.CTVG.C32 = ConfigYesNo(default=False)
config.CTVG.C33 = ConfigYesNo(default=False)
config.CTVG.C34 = ConfigYesNo(default=False)
config.CTVG.C35 = ConfigYesNo(default=False)
config.CTVG.C36 = ConfigYesNo(default=False)
config.CTVG.C37 = ConfigYesNo(default=True)
config.CTVG.C38 = ConfigYesNo(default=True)
config.CTVG.C39 = ConfigYesNo(default=False)
config.CTVG.C40 = ConfigInteger(default=1, limits=(1, 4))
config.CTVG.C41 = ConfigInteger(default=1, limits=(1, 4))
config.CTVG.C42 = ConfigInteger(default=1, limits=(1, 4))
config.CTVG.C43 = ConfigInteger(default=1, limits=(1, 4))
config.CTVG.C44 = ConfigInteger(default=180, limits=(60, 300))
config.CTVG.C45 = ConfigInteger(default=18, limits=(1, 50))
config.CTVG.C46 = ConfigInteger(default=18, limits=(1, 50))
config.CTVG.C47 = ConfigInteger(default=22, limits=(10, 30))
config.CTVG.C48 = ConfigInteger(default=20, limits=(10, 60))
config.CTVG.C49 = ConfigInteger(default=60, limits=(30, 80))
config.CTVG.C50 = ConfigInteger(default=60, limits=(30, 80))
# PICO HEIGHT START
config.CTVG.C51 = ConfigInteger(default=28, limits=(10, 80))
config.CTVG.C52 = ConfigInteger(default=30, limits=(10, 80))
# PICO HEIGHT END
config.CTVG.C53 = ConfigInteger(default=110, limits=(50, 250))
config.CTVG.C54 = ConfigInteger(default=55, limits=(5, 250))
config.CTVG.C55 = ConfigYesNo(default=False)
config.CTVG.C56 = ConfigYesNo(default=True)
config.CTVG.C57 = ConfigYesNo(default=False)
config.CTVG.C58 = ConfigYesNo(default=True)
config.CTVG.C60 = ConfigYesNo(default=False)
config.CTVG.C61 = ConfigYesNo(default=False)
config.CTVG.C62 = ConfigYesNo(default=True)
config.CTVG.C63 = ConfigYesNo(default=True)
mefvr = config.CTVG.Key.value
config.CTVG.C77 = ConfigSelection(default='1', choices=eatzq)
config.CTVG.C78 = ConfigSelection(default='2', choices=eatzq)
config.CTVG.C79 = ConfigSelection(default='3', choices=eatzq)
config.CTVG.C80 = ConfigSelection(default='0', choices=eatzq)
config.CTVG.C81 = ConfigSelection(default='0', choices=eatzq)
config.CTVG.C82 = ConfigSelection(default='0', choices=eatzq)
config.CTVG.C83 = ConfigSelection(default='0', choices=eatzq)
config.CTVG.C84 = ConfigSelection(default='0', choices=eatzq)
config.CTVG.C85 = ConfigSelection(default='0', choices=eatzq)
config.CTVG.C86 = ConfigSelection(default='0', choices=eatzq)
config.CTVG.C87 = ConfigSelection(default='0', choices=eatzq)
config.CTVG.C88 = ConfigSelection(default='0', choices=eatzq)
aaqqx = 1

class norej():

    def __init__(self, x, y, width, height):
        self.x = x
        self.y = y
        self.w = width
        self.h = height

    def left(self):
        return self.x

    def top(self):
        return self.y

    def height(self):
        return self.h

    def width(self):
        return self.w


class wdvoa(HTMLComponent, GUIComponent):

    def __init__(self):
        GUIComponent.__init__(self)
        self.l = eListboxPythonMultiContent()
        self.l.setSelectionClip(eRect(0, 0, 0, 0))
        self.l.setItemHeight(25)
        self.l.setFont(0, gFont('Myriad', config.CTVG.C48.value))

    GUI_WIDGET = eListbox

    def postWidgetCreate(self, instance):
        instance.setContent(self.l)

    def nbead(self, ptvgf):
        res = [None]
        for x in ptvgf:
            tm = x[0]
            znxwf = x[1]
            str = strftime('%H:%M', localtime(tm))
            res.append((eListboxPythonMultiContent.TYPE_TEXT,
             znxwf - 5,
             0,
             300,
             25,
             0,
             RT_HALIGN_LEFT | RT_VALIGN_CENTER,
             str))

        self.l.setList([res])
        return


opspy = getDesktop(0).size().width()

class mlayh(Screen):

    def __init__(self, session, zchmt = None, Ref = None, vtewf = None, cixoa = None, vctoy = None, obyqg = None, kzqib = None):
        global hcgsf
        Screen.__init__(self, session)
        if opspy == 720:
            if kzqib == shuhr:
                self.skinName = 'CoolInfoGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolInfoGuide_720.xml'
            elif kzqib == xxdtq:
                self.skinName = 'CoolSingleGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSingleGuide_720.xml'
            elif kzqib == baaaj:
                self.skinName = 'CoolEasyGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolEasyGuide_720.xml'
            elif kzqib == fqmck:
                self.skinName = 'CoolChannelGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolChannelGuide_720.xml'
            elif kzqib == yacuo:
                if config.CTVG.C40.value == 1:
                    self.skinName = 'CoolTVGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolTVGuide_720.xml'
                elif config.CTVG.C40.value == 2:
                    self.skinName = 'CoolTinyGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolTinyGuide_720.xml'
                elif config.CTVG.C40.value == 3:
                    self.skinName = 'CoolMultiGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolMultiGuide_720.xml'
                elif config.CTVG.C40.value == 4:
                    self.skinName = 'CoolNiceGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolNiceGuide_720.xml'
        elif opspy == 1024:
            if kzqib == shuhr:
                self.skinName = 'CoolInfoGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolInfoGuide_1024.xml'
            elif kzqib == xxdtq:
                if config.CTVG.C43.value == 1:
                    self.skinName = 'CoolSingleGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSingleGuide_1024.xml'
                elif config.CTVG.C43.value == 2:
                    self.skinName = 'CoolSingleGuide2'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSingleGuide2_1024.xml'
                elif config.CTVG.C43.value == 3:
                    self.skinName = 'CoolSingleGuide3'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSingleGuide3_1024.xml'
            elif kzqib == baaaj:
                if config.CTVG.C42.value == 1:
                    self.skinName = 'CoolEasyGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolEasyGuide_1024.xml'
                elif config.CTVG.C42.value == 2:
                    self.skinName = 'CoolEasyGuide2'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolEasyGuide2_1024.xml'
                elif config.CTVG.C42.value == 3:
                    self.skinName = 'CoolEasyGuide3'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolEasyGuide3_1024.xml'
            elif kzqib == fqmck:
                if config.CTVG.C41.value == 1:
                    self.skinName = 'CoolChannelGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolChannelGuide_1024.xml'
                elif config.CTVG.C41.value == 2:
                    self.skinName = 'CoolChannelGuide2'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolChannelGuide2_1024.xml'
                elif config.CTVG.C41.value == 3:
                    self.skinName = 'CoolChannelGuide3'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolChannelGuide3_1024.xml'
            elif kzqib == yacuo:
                if config.CTVG.C40.value == 1:
                    self.skinName = 'CoolTVGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolTVGuide_1024.xml'
                elif config.CTVG.C40.value == 2:
                    self.skinName = 'CoolTinyGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolTinyGuide_1024.xml'
                elif config.CTVG.C40.value == 3:
                    self.skinName = 'CoolMultiGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolMultiGuide_1024.xml'
                elif config.CTVG.C40.value == 4:
                    self.skinName = 'CoolNiceGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolNiceGuide_1024.xml'
        elif kzqib == shuhr:
            self.skinName = 'CoolInfoGuide'
            iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolInfoGuide_1280.xml'
        elif kzqib == xxdtq:
            if config.CTVG.C43.value == 1:
                self.skinName = 'CoolSingleGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSingleGuide_1280.xml'
            elif config.CTVG.C43.value == 2:
                self.skinName = 'CoolSingleGuide2'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSingleGuide2_1280.xml'
            elif config.CTVG.C43.value == 3:
                self.skinName = 'CoolSingleGuide3'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSingleGuide3_1280.xml'
        elif kzqib == baaaj:
            if config.CTVG.C42.value == 1:
                self.skinName = 'CoolEasyGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolEasyGuide_1280.xml'
            elif config.CTVG.C42.value == 2:
                self.skinName = 'CoolEasyGuide2'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolEasyGuide2_1280.xml'
            elif config.CTVG.C42.value == 3:
                self.skinName = 'CoolEasyGuide3'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolEasyGuide3_1280.xml'
        elif kzqib == fqmck:
            if config.CTVG.C41.value == 1:
                self.skinName = 'CoolChannelGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolChannelGuide_1280.xml'
            elif config.CTVG.C41.value == 2:
                self.skinName = 'CoolChannelGuide2'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolChannelGuide2_1280.xml'
            elif config.CTVG.C41.value == 3:
                self.skinName = 'CoolChannelGuide3'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolChannelGuide3_1280.xml'
        elif kzqib == yacuo:
            if config.CTVG.C40.value == 1:
                self.skinName = 'CoolTVGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolTVGuide_1280.xml'
            elif config.CTVG.C40.value == 2:
                self.skinName = 'CoolTinyGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolTinyGuide_1280.xml'
            elif config.CTVG.C40.value == 3:
                self.skinName = 'CoolMultiGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolMultiGuide_1280.xml'
            elif config.CTVG.C40.value == 4:
                self.skinName = 'CoolNiceGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolNiceGuide_1280.xml'
        thhxl = open(iiive)
        self.skin = thhxl.read()
        thhxl.close()
        self.spiqr = mefvr
        self.obyqg = obyqg
        self.bjjsb = (_('Mon'),
         _('Tue'),
         _('Wed'),
         _('Thu'),
         _('Fri'),
         _('Sat'),
         _('Sun'))
        self.rzdhh = -1
        self.txocy = False
        self.fhxlg = None
        self['Service'] = ServiceEvent()
        self['Event'] = Event()
        if zchmt:
            self['Event'].newEvent(zchmt)
            hcgsf = zchmt.getEventId()
        self['CoolSimilar'] = ScrollLabel()
        self['CoolDescription'] = ScrollLabel()
        self['CoolShort'] = ScrollLabel()
        self['date'] = Button()
        self['key_red'] = Button('')
        self['key_green'] = Button('')
        self['key_yellow'] = Button('')
        self['key_blue'] = Button('')
        self.njwlx = ServiceReference(vtewf)
        self.wujrl = eTimer()
        self.wujrl.callback.append(self.iuhfo)
        self['CoolEvent'] = hdxzq(phvkq=self.ylgms, eyduj=session.nav.RecordTimer)
        self['Coolman'] = ActionMap(['CoolTVGuideActions'], {'CoolPower': self.xljhj,
         'CoolUP': self.hckcm,
         'CoolDown': self.nwmah,
         'CoolLEFT': self.aqjqt,
         'CoolRIGHT': self.ubhcc,
         'CoolChannelUP': self.qpytt,
         'CoolChannelDown': self.mkldi,
         'CoolNEXT': self.miacr,
         'CoolPREVIOUS': self.gwzkx,
         'CoolMenu': self.kmhrc,
         'CoolRed': self.bpknl,
         'CoolRedLong': self.yjzda,
         'CoolGreen': self.edjzc,
         'CoolGreenLong': self.blsge,
         'CoolYellow': self.ocpqd,
         'CoolYellowLong': self.opryi,
         'CoolBlue': self.mngvi,
         'CoolBlueLong': self.nfiwg,
         'CoolOK': self.qwbyt,
         'CoolCancel': self.pcuno,
         'CoolInfo': self.ftntd,
         'CoolInfoLong': self.omgdq,
         'CoolRecord': self.acufl,
         'CoolVIDEO': qyjbi,
         'CoolAUDIO': self.rqmfo,
         'CoolKeyTV': self.zmhiy,
         '0': self.vsjxa,
         '7': self.pvmae,
         '8': self.erano,
         '9': self.psqlx}, -1)
        self.xxjug = config.CTVG.C12.value
        self.jqkck = config.CTVG.C14.value
        self.hyrdq = config.CTVG.C16.value
        self.vrtca = config.CTVG.C18.value
        if self.xxjug == 'PrimeTime' or self.xxjug == 'Bouquet +' or self.xxjug == 'Bouquet -' or self.xxjug == 'Bouquetlist':
            self.xxjug = 'EPG Select'
        if self.jqkck == 'PrimeTime' or self.jqkck == 'Bouquet +' or self.jqkck == 'Bouquet -' or self.jqkck == 'Bouquetlist':
            self.jqkck = 'Timer'
        if self.hyrdq == 'PrimeTime' or self.hyrdq == 'Bouquet +' or self.hyrdq == 'Bouquet -' or self.hyrdq == 'Bouquetlist':
            self.hyrdq = 'GuideSwitch'
        if self.vrtca == 'PrimeTime' or self.vrtca == 'Bouquet +' or self.vrtca == 'Bouquet -' or self.vrtca == 'Bouquetlist':
            self.vrtca = 'CoolSearch'
        self['key_red'].setText(_(self.xxjug))
        self['key_green'].setText(_(self.jqkck))
        self['key_yellow'].setText(_(self.hyrdq))
        self['key_blue'].setText(_(self.vrtca))
        self.onLayoutFinish.append(self.morod)
        self.veaqs()
        return

    def hjxls(self):
        global aaqqx
        if aaqqx == 1:
            x = config.CTVG.C77.value
        elif aaqqx == 2:
            x = config.CTVG.C78.value
        elif aaqqx == 3:
            x = config.CTVG.C79.value
        elif aaqqx == 4:
            if mrbjc != self.spiqr and ozetp != self.spiqr:
                aaqqx = 1
                return self.close(False)
            x = config.CTVG.C80.value
        elif aaqqx == 5:
            x = config.CTVG.C81.value
        elif aaqqx == 6:
            x = config.CTVG.C82.value
        elif aaqqx == 7:
            x = config.CTVG.C83.value
        elif aaqqx == 8:
            x = config.CTVG.C84.value
        elif aaqqx == 9:
            x = config.CTVG.C85.value
        elif aaqqx == 10:
            x = config.CTVG.C86.value
        elif aaqqx == 11:
            x = config.CTVG.C87.value
        elif aaqqx == 12:
            x = config.CTVG.C88.value
        if x == '9':
            aaqqx += 1
            return self.hjxls()
        self.hide()
        if x == '1':
            aaqqx += 1
            return self.hjxls()
        if x == '2':
            self.nsdpj()
        elif x == '3':
            CEGmain(self.session)
        elif x == '4':
            CCGmain(self.session)
        elif x == '5':
            config.CTVG.C40.value = 1
            main(self.session)
        elif x == '6':
            config.CTVG.C40.value = 2
            main(self.session)
        elif x == '7':
            config.CTVG.C40.value = 3
            main(self.session)
        elif x == '8':
            config.CTVG.C40.value = 4
            main(self.session)
        elif x == '10':
            self.xzceb()
        elif x == '11':
            aaqqx = 0
            self.session.open(TimerEditList)
        else:
            aaqqx = 0
        aaqqx += 1
        self.close(False)

    def veaqs(self):
        ojmzu = localtime()
        if (ojmzu.tm_year, ojmzu.tm_mon) >= (int(xyaoy[4:8]), int(baaaj[2])):
            self.pcuno()

    def changeServiceCB(self, axkko, epg):
        if self.serviceSel:
            if axkko > 0:
                self.serviceSel.nextService()
            else:
                self.serviceSel.prevService()
            epg.setService(self.serviceSel.currentService())

    def vsjxa(self):
        try:
            self.hide()
            CIGmain(self.session)
            self.pcuno()
        except:
            self.pcuno()

    def pviek(self):
        self.hide()
        main(self.session)
        self.pcuno()

    def rqmfo(self):
        self.hide()
        CEGmain(self.session)
        self.pcuno()

    def nsdpj(self):
        global cixoa
        tqget = self['CoolEvent'].gggoy()
        if tqget[1] is None:
            return
        else:
            zwzuu = tqget[1].ref
            if zwzuu:
                if cixoa:
                    wgupq = cixoa.getRoot()
                    jfqok = getBouquetServices(wgupq)
                    self.serviceSel = SimpleServicelist(jfqok)
                    if self.serviceSel.selectService(zwzuu):
                        self.hide()
                        self.session.open(ynrgr, zwzuu, obyqg=self.changeServiceCB, cixoa=cixoa, kzqib=xxdtq)
            self.pcuno()
            return

    def xljhj(self):
        try:
            from Screens.SleepTimerEdit import SleepTimerEdit
            self.session.open(SleepTimerEdit)
        except:
            pass

    def bpknl(self):
        zkcgs = self.xxjug
        if zkcgs == 'EPG Select':
            self.hjxls()
        elif zkcgs == 'Zap':
            self.zlmmx()
        elif zkcgs == 'Zap + Exit':
            self.kgvwz()
        elif zkcgs == 'CoolSearch':
            self.xzceb()
        elif zkcgs == 'CoolInfoBox':
            self.zauju()
        elif zkcgs == 'GuideSwitch':
            self.pviek()
        elif zkcgs == 'Timer':
            self.sotem()
        elif zkcgs == 'QuickRec':
            self.acufl()
        elif zkcgs == 'AutoTimer':
            self.krvdb()
        else:
            self.hjxls()

    def yjzda(self):
        ogigl = config.CTVG.C13.value
        if ogigl == 'Zap':
            self.zlmmx()
        elif ogigl == 'Zap + Exit':
            self.kgvwz()
        elif ogigl == 'CoolSearch':
            self.xzceb()
        elif ogigl == 'CoolInfoBox':
            self.zauju()
        elif ogigl == 'GuideSwitch':
            self.pviek()
        elif ogigl == 'Timer':
            self.sotem()
        elif ogigl == 'QuickRec':
            self.acufl()
        elif ogigl == 'AutoTimer':
            self.krvdb()
        elif ogigl == 'EPG Select':
            self.hjxls()
        else:
            self.kgvwz()

    def edjzc(self):
        ascfa = self.jqkck
        if ascfa == 'Zap':
            self.zlmmx()
        elif ascfa == 'Zap + Exit':
            self.kgvwz()
        elif ascfa == 'CoolSearch':
            self.xzceb()
        elif ascfa == 'CoolInfoBox':
            self.zauju()
        elif ascfa == 'GuideSwitch':
            self.pviek()
        elif ascfa == 'Timer':
            self.sotem()
        elif ascfa == 'QuickRec':
            self.acufl()
        elif ascfa == 'AutoTimer':
            self.krvdb()
        elif ascfa == 'EPG Select':
            self.hjxls()
        else:
            self.sotem()

    def blsge(self):
        zsbhk = config.CTVG.C15.value
        if zsbhk == 'Zap':
            self.zlmmx()
        elif zsbhk == 'Zap + Exit':
            self.kgvwz()
        elif zsbhk == 'CoolSearch':
            self.xzceb()
        elif zsbhk == 'CoolInfoBox':
            self.zauju()
        elif zsbhk == 'GuideSwitch':
            self.pviek()
        elif zsbhk == 'Timer':
            self.sotem()
        elif zsbhk == 'QuickRec':
            self.acufl()
        elif zsbhk == 'AutoTimer':
            self.krvdb()
        elif zsbhk == 'EPG Select':
            self.hjxls()
        else:
            self.krvdb()

    def ocpqd(self):
        edzmi = self.hyrdq
        if edzmi == 'Zap':
            self.zlmmx()
        elif edzmi == 'Zap + Exit':
            self.kgvwz()
        elif edzmi == 'CoolSearch':
            self.xzceb()
        elif edzmi == 'CoolInfoBox':
            self.zauju()
        elif edzmi == 'GuideSwitch':
            self.pviek()
        elif edzmi == 'Timer':
            self.sotem()
        elif edzmi == 'QuickRec':
            self.acufl()
        elif edzmi == 'AutoTimer':
            self.krvdb()
        elif edzmi == 'EPG Select':
            self.hjxls()
        else:
            self.pviek()

    def opryi(self):
        nbvxv = config.CTVG.C17.value
        if nbvxv == 'Zap':
            self.zlmmx()
        elif nbvxv == 'Zap + Exit':
            self.kgvwz()
        elif nbvxv == 'CoolSearch':
            self.xzceb()
        elif nbvxv == 'CoolInfoBox':
            self.zauju()
        elif nbvxv == 'GuideSwitch':
            self.pviek()
        elif nbvxv == 'Timer':
            self.sotem()
        elif nbvxv == 'QuickRec':
            self.acufl()
        elif nbvxv == 'AutoTimer':
            self.krvdb()
        elif nbvxv == 'EPG Select':
            self.hjxls()
        else:
            self.zauju()

    def mngvi(self):
        ocmvt = config.CTVG.C18.value
        if ocmvt == 'Zap':
            self.zlmmx()
        elif ocmvt == 'Zap + Exit':
            self.kgvwz()
        elif ocmvt == 'CoolSearch':
            self.xzceb()
        elif ocmvt == 'CoolInfoBox':
            self.zauju()
        elif ocmvt == 'GuideSwitch':
            self.pviek()
        elif ocmvt == 'Timer':
            self.sotem()
        elif ocmvt == 'QuickRec':
            self.acufl()
        elif ocmvt == 'AutoTimer':
            self.krvdb()
        elif ocmvt == 'EPG Select':
            self.hjxls()
        else:
            self.xzceb()

    def nfiwg(self):
        jeqam = config.CTVG.C19.value
        if jeqam == 'Zap':
            self.zlmmx()
        elif jeqam == 'Zap + Exit':
            self.kgvwz()
        elif jeqam == 'CoolSearch':
            self.xzceb()
        elif jeqam == 'CoolInfoBox':
            self.zauju()
        elif jeqam == 'GuideSwitch':
            self.pviek()
        elif jeqam == 'Timer':
            self.sotem()
        elif jeqam == 'QuickRec':
            self.acufl()
        elif jeqam == 'AutoTimer':
            self.krvdb()
        elif jeqam == 'EPG Select':
            self.hjxls()
        else:
            self.zauju()

    def qwbyt(self):
        rtjib = config.CTVG.C20.value
        if rtjib == 'Zap':
            self.zlmmx()
        elif rtjib == 'Zap + Exit':
            self.kgvwz()
        elif rtjib == 'CoolSearch':
            self.xzceb()
        elif rtjib == 'CoolInfoBox':
            self.zauju()
        elif rtjib == 'GuideSwitch':
            self.pviek()
        elif rtjib == 'Timer':
            self.sotem()
        elif rtjib == 'QuickRec':
            self.acufl()
        elif rtjib == 'AutoTimer':
            self.krvdb()
        elif rtjib == 'EPG Select':
            self.hjxls()
        else:
            self.pcuno()

    def ftntd(self):
        buehv = config.CTVG.C22.value
        if buehv == '4':
            self.hjxls()
        elif buehv == '2':
            self.nsdpj()
        elif buehv == '3':
            self.rqmfo()
        else:
            self.pcuno()

    def omgdq(self):
        buehv = config.CTVG.C23.value
        if buehv == '4':
            self.hjxls()
        elif buehv == '2':
            self.nsdpj()
        elif buehv == '3':
            self.rqmfo()
        else:
            self.pcuno()

    def hckcm(self):
        self['CoolSimilar'].pageUp()
        self['CoolDescription'].pageUp()
        self['CoolShort'].pageUp()

    def nwmah(self):
        self['CoolSimilar'].pageDown()
        self['CoolDescription'].pageDown()
        self['CoolShort'].pageDown()

    def aqjqt(self):
        self['CoolEvent'].aqjqt()
        self.ocdis()

    def ubhcc(self):
        self['CoolEvent'].ubhcc()
        self.ocdis()

    def qpytt(self):
        self.miacr()
        self.zlmmx()

    def mkldi(self):
        self.gwzkx()
        self.zlmmx()

    def miacr(self):
        if self.obyqg:
            self.obyqg(1, self)

    def gwzkx(self):
        if self.obyqg:
            self.obyqg(-1, self)

    def pvmae(self):
        self.pviek()

    def erano(self):
        self.nsdpj()

    def psqlx(self):
        self.rqmfo()

    def morod(self):
        gkydn = self.njwlx
        self.ocdis()
        if self.fhxlg is None:
            self.fhxlg = self.instance.getTitle()
        title = self.fhxlg + ' - ' + gkydn.getServiceName()
        self.instance.setTitle(title)
        self['CoolEvent'].jwulh(gkydn)
        return

    def pcuno(self):
        global aaqqx
        global okvsm
        aaqqx = 1
        okvsm = self['CoolEvent'].kpxgx()
        self.close(self.txocy)

    def setService(self, vtewf):
        self.njwlx = vtewf
        self.morod()

    def gfxnd(self, dylxl):
        self.ktncw = dylxl
        self.morod()

    def iuhfo(self):
        fdqoy = self['CoolEvent'].gggoy()
        lefvg = fdqoy[0]
        if not lefvg:
            self['CoolShort'].setText('--- No EPG Data ---')
            self['CoolDescription'].setText('')
            return
        else:
            self['CoolDescription'].setText(lefvg.getExtendedDescription())
            jtzhd = lefvg.getShortDescription()
            if jtzhd == '':
                self['CoolShort'].setText(lefvg.getEventName())
            else:
                self['CoolShort'].setText(jtzhd)
            gbvdz = fdqoy[1]
            vwjvv = gbvdz.ref.toString()
            vrebz = lefvg.getEventId()
            hjxkh = eEPGCache.getInstance()
            vtonk = hjxkh.search(('NB',
             100,
             eEPGCache.SIMILAR_BROADCASTINGS_SEARCH,
             vwjvv,
             vrebz))
            if vtonk is not None:
                pxusw = self['CoolSimilar']
                xbplc = pxusw.getText()
                vtonk.sort(self.uwywn)
                for x in vtonk:
                    xrbgy = localtime(x[1])
                    jypua = ''
                    if xrbgy.tm_wday == 0:
                        jypua = _('Mon')
                    elif xrbgy.tm_wday == 1:
                        jypua = _('Tue')
                    elif xrbgy.tm_wday == 2:
                        jypua = _('Wed')
                    elif xrbgy.tm_wday == 3:
                        jypua = _('Thu')
                    elif xrbgy.tm_wday == 4:
                        jypua = _('Fri')
                    elif xrbgy.tm_wday == 5:
                        jypua = _('Sat')
                    elif xrbgy.tm_wday == 6:
                        jypua = _('Sun')
                    xbplc += '%s  %02d:%02d   %s\n' % (jypua,
                     xrbgy[3],
                     xrbgy[4],
                     x[0])

                pxusw.setText(xbplc)
            return

    def uwywn(self, x, y):
        if x[1] < y[1]:
            return -1
        elif x[1] == y[1]:
            return 0
        else:
            return 1

    def zauju(self):
        ksvxp = []
        if nabim:
            ksvxp.append((_('SeriesPlugin'), 'SeriesPlugin'))
        if ktssu:
            ksvxp.append((_('The TVDB Info'), 'The TVDB Info'))
        if kasgg:
            ksvxp.append((_('IMDb Search'), 'IMDbSearch'))
        if anzhl:
            ksvxp.append((_('TMDB Info'), 'TMDBInfo'))
        if ljoja:
            ksvxp.append((_('OFDb Details'), 'OFDbDetails'))
        if ksvxp == []:
            ksvxp.append((_('No Info Plugins installed...'), 'No Info Plugins installed...'))
        self.session.openWithCallback(self.bjplp, ChoiceBox, title=_('   CoolInfoBox'), list=ksvxp)

    def bjplp(self, lagzl):
        lagzl = lagzl and lagzl[1]
        jtpbl = self['CoolEvent'].gggoy()
        aspmn = jtpbl[0]
        if not aspmn:
            return
        name = aspmn and aspmn.getEventName() or ''
        if lagzl == 'SeriesPlugin':
            from Plugins.Extensions.SeriesPlugin.SeriesPluginInfoScreen import SeriesPluginInfoScreen
            vtewf = jtpbl[1]
            self.session.open(SeriesPluginInfoScreen, vtewf, aspmn)
        if lagzl == 'The TVDB Info':
            from Plugins.Extensions.TheTVDB.plugin import TheTVDBMain
            self.session.open(TheTVDBMain, name)
        if lagzl == 'IMDbSearch':
            from Plugins.Extensions.IMDb.plugin import IMDB
            self.session.open(IMDB, name)
        if lagzl == 'TMDBInfo':
            from Plugins.Extensions.TMDb.plugin import TMDbMain
            self.session.open(TMDbMain, name)
        if lagzl == 'OFDbDetails':
            from Plugins.Extensions.OFDb.plugin import OFDB
            self.session.open(OFDB, name)

    def ocdis(self):
        xbplc = ''
        self['CoolSimilar'].setText(xbplc)
        if self.wujrl is not None:
            self.wujrl.start(400, True)
        bvxbx = self['CoolEvent'].gggoy()
        efmxu = bvxbx[0]
        if not efmxu:
            return
        else:
            jtzhd = efmxu.getShortDescription()
            if jtzhd == '':
                self['CoolShort'].setText(efmxu.getEventName())
            else:
                self['CoolShort'].setText(jtzhd)
            self['CoolDescription'].setText(efmxu.getExtendedDescription())
            return

    def xzceb(self):
        try:
            khnnw = self['CoolEvent'].gggoy()
            efmxu = khnnw[0]
            if not efmxu:
                return
            sgomb = efmxu.getEventName() or ''
        except:
            sgomb = ''

        self.session.open(kpult, sgomb, False)

    def krvdb(self):
        vunnx = self['CoolEvent'].gggoy()
        if not vunnx:
            return
        try:
            from Plugins.Extensions.AutoTimer.AutoTimerEditor import addAutotimerFromEvent
            self.session.openWithCallback(self.vuzti, ChoiceBox, title=_('   check Autotimer ?'), list=[(_('Yes'), 'Yes'), (_('No'), 'No')])
            addAutotimerFromEvent(self.session, vunnx[0], vunnx[1])
        except:
            self.session.open(MessageBox, _('No AutoTimer seems to be installed. Please install it for this functionality.'), MessageBox.TYPE_ERROR)

    def vuzti(self, lagzl):
        lagzl = lagzl and lagzl[1]
        if lagzl == 'Yes':
            try:
                from Plugins.Extensions.AutoTimer.plugin import main as AutoTimerSafe
                AutoTimerSafe(self.session)
            except:
                self.session.open(MessageBox, _('No AutoTimer seems to be installed. Please install it for this functionality.'), MessageBox.TYPE_ERROR)

    def acufl(self):
        yoyqj = self['CoolEvent'].gggoy()
        volgt = yoyqj[1]
        fuxrd = yoyqj[0]
        if not fuxrd:
            return
        else:
            grgyl = fuxrd.getEventId()
            vvdwt = volgt.ref.toString()
            for yoyqj in self.session.nav.RecordTimer.timer_list:
                if yoyqj.eit == grgyl and yoyqj.service_ref.ref.toString() == vvdwt:
                    self.session.nav.RecordTimer.removeEntry(yoyqj)
                    self['CoolEvent'].l.invalidate()
                    break
            else:
                aeoig = RecordTimerEntry(volgt, checkOldTimers=True, *parseEvent(fuxrd))
                muysp = NavigationInstance.instance.RecordTimer.record(aeoig)
                if muysp is not None:
                    for yoyqj in muysp:
                        if yoyqj.setAutoincreaseEnd(aeoig):
                            self.session.nav.RecordTimer.timeChanged(yoyqj)

                    muysp = self.session.nav.RecordTimer.record(aeoig)
                    if muysp is not None:
                        self.session.openWithCallback(self.pfoza, TimerSanityConflict, muysp)
                self['CoolEvent'].l.invalidate()

            self.ylgms()
            return

    def ylgms(self):
        bpyut = self['CoolEvent'].gggoy()
        efmxu = bpyut[0]
        self['Event'].newEvent(efmxu)
        puntx = ''
        if efmxu is not None:
            ojmzu = time()
            ookve = efmxu.getBeginTime()
            hcxyb = localtime(ojmzu)
            dsxwo = localtime(ookve)
            if hcxyb[2] != dsxwo[2]:
                puntx = '%s %d.%d.' % (self.bjjsb[dsxwo[6]], dsxwo[2], dsxwo[1])
            else:
                puntx = '%s %d.%d.' % (_('Today'), dsxwo[2], dsxwo[1])
        self['date'].setText(puntx)
        if bpyut[1] is None:
            self['Service'].newService(None)
        else:
            self['Service'].newService(bpyut[1].ref)
        if not efmxu:
            if self.jqkck == 'Timer':
                self['key_green'].setText('')
            elif self.xxjug == 'Timer':
                self['key_red'].setText('')
            elif self.hyrdq == 'Timer':
                self['key_yellow'].setText('')
            elif self.vrtca == 'Timer':
                self['key_blue'].setText('')
            return
        else:
            ftxff = bpyut[1]
            grgyl = efmxu.getEventId()
            iqayf = ftxff.ref.toString()
            iibly = False
            for ftxff in self.session.nav.RecordTimer.timer_list:
                if ftxff.eit == grgyl and ftxff.service_ref.ref.toString() == iqayf:
                    iibly = True
                    break

            if iibly:
                if self.jqkck == 'Timer':
                    self['key_green'].setText(_('TimerEdit'))
                elif self.xxjug == 'Timer':
                    self['key_red'].setText(_('TimerEdit'))
                elif self.hyrdq == 'Timer':
                    self['key_yellow'].setText(_('TimerEdit'))
                elif self.vrtca == 'Timer':
                    self['key_blue'].setText(_('TimerEdit'))
            elif self.jqkck == 'Timer':
                self['key_green'].setText(_('Timer'))
            elif self.xxjug == 'Timer':
                self['key_red'].setText(_('Timer'))
            elif self.hyrdq == 'Timer':
                self['key_yellow'].setText(_('Timer'))
            elif self.vrtca == 'Timer':
                self['key_blue'].setText(_('Timer'))
            return

    def zmhiy(self):
        self.session.open(TimerEditList)

    def sotem(self):
        bpyut = self['CoolEvent'].gggoy()
        wkhzm = bpyut[0]
        zqtmz = bpyut[1]
        if not wkhzm:
            return
        grgyl = wkhzm.getEventId()
        vwjvv = zqtmz.ref.toString()
        for eyduj in self.session.nav.RecordTimer.timer_list:
            if eyduj.eit == grgyl and eyduj.service_ref.ref.toString() == vwjvv:
                self.eyduj = eyduj
                self.session.openWithCallback(self.doxxi, ChoiceBox, title=_('Cool Timer Edit :' + '\n\n%s') % wkhzm.getEventName(), list=[(_('edit this Timer ?'), 'edit'), (_('delete this Timer ?'), 'delete'), (_('delete this Timer and recording ?'), 'delrec')])
                break
        else:
            aeoig = RecordTimerEntry(zqtmz, checkOldTimers=True, *parseEvent(wkhzm))
            self.session.openWithCallback(self.jhzuv, TimerEntry, aeoig)

    def doxxi(self, lagzl):
        eyduj = self.eyduj
        doxxi(self, eyduj, lagzl)

    def kmhrc(self):
        try:
            self.session.openWithCallback(self.rgdse, cxpnt)
        except:
            pass

    def rgdse(self):
        self.hide()
        if cixoa:
            CIGmain(self.session, cixoa)
        if mrbjc != self.spiqr and ozetp != self.spiqr:
            self.session.open(MessageBox, Po, MessageBox.TYPE_INFO)
        self.pcuno()

    def jhzuv(self, lagzl):
        if lagzl[0]:
            tjuhw = lagzl[1]
            fathd = self.session.nav.RecordTimer.record(tjuhw)
            if fathd is not None:
                for x in fathd:
                    if x.setAutoincreaseEnd(tjuhw):
                        self.session.nav.RecordTimer.timeChanged(x)

                fathd = self.session.nav.RecordTimer.record(tjuhw)
                if fathd is not None:
                    self.session.openWithCallback(self.pfoza, TimerSanityConflict, fathd)
            if self.jqkck == 'Timer':
                self['key_green'].setText(_('TimerEdit'))
            elif self.xxjug == 'Timer':
                self['key_red'].setText(_('TimerEdit'))
            elif self.hyrdq == 'Timer':
                self['key_yellow'].setText(_('TimerEdit'))
            elif self.vrtca == 'Timer':
                self['key_blue'].setText(_('TimerEdit'))
        return

    def pfoza(self, lagzl):
        self.jhzuv(lagzl)

    def zlmmx(self):
        try:
            vtewf = self['CoolEvent'].gggoy()[1]
            if vtewf:
                cixoa.setCurrentSelection(vtewf.ref)
                cixoa.zap()
                tmcma(vtewf.ref)
            config.CTVG.C61.value = True
        except:
            return

    def kgvwz(self):
        try:
            gbvdz = self['CoolEvent'].gggoy()[1]
            if gbvdz:
                cixoa.setCurrentSelection(gbvdz.ref)
                cixoa.zap()
                tmcma(gbvdz.ref)
            self.pcuno()
        except:
            return


class hdxzq(HTMLComponent, GUIComponent):

    def __init__(self, phvkq = None, eyduj = None):
        self.bjjsb = (_('Mon'),
         _('Tue'),
         _('Wed'),
         _('Thu'),
         _('Fri'),
         _('Sat'),
         _('Sun'))
        self.eyduj = eyduj
        self.swolc = []
        if phvkq is not None:
            self.swolc.append(phvkq)
        GUIComponent.__init__(self)
        self.hgtef = eServiceCenter.getInstance()
        self.l = eListboxPythonMultiContent()
        self.uxwab = parseFont('Myriad;24', ((1, 1), (1, 1)))
        self.l.setFont(0, self.uxwab)
        self.l.setBuildFunc(self.xupfa)
        self.ebuuh = 0
        self.dpker = 60
        self.sypnn = 1060
        self.yumdw = 120
        self.ilvoe = 250
        self.lerri = 950
        self.tzppv = 60
        self.cibam = 2
        self.ufeoc = 190
        self.mgmwk = None
        self.ecngd = None
        self.kczza = 16737792
        self.vjtnl = 3905737
        self.yokms = 16777215
        self.rylfn = 10425107
        self.brzlo = 11902465
        self.hinjj = 3905737
        self.sjzbt = 6316128
        self.ljjjn = 16777215
        self.hjxkh = eEPGCache.getInstance()
        return

    def applySkin(self, desktop, parent):
        fpapv = []
        if self.skinAttributes is not None:
            for zayvt, value in self.skinAttributes:
                if zayvt == 'CoolFont':
                    self.uxwab = parseFont(value, ((1, 1), (1, 1)))
                    self.l.setFont(0, self.uxwab)
                elif zayvt == 'CoolDayPos':
                    self.ebuuh = int(value)
                elif zayvt == 'CoolTimePos':
                    self.tzppv = int(value)
                elif zayvt == 'CoolEventPos':
                    self.ilvoe = int(value)
                elif zayvt == 'CoolEventSize':
                    self.lerri = int(value)
                elif zayvt == 'CoolDaySize':
                    self.dpker = int(value)
                elif zayvt == 'CoolTimeSize':
                    self.ufeoc = int(value)
                elif zayvt == 'CoolDurationPos':
                    self.sypnn = int(value)
                elif zayvt == 'CoolTimeHPos':
                    self.cibam = int(value)
                elif zayvt == 'CoolDurationSize':
                    self.yumdw = int(value)
                elif zayvt == 'CoolDayColor':
                    self.kczza = parseColor(value).argb()
                elif zayvt == 'CoolTimeColor':
                    self.hinjj = parseColor(value).argb()
                elif zayvt == 'CoolEventColor':
                    self.yokms = parseColor(value).argb()
                elif zayvt == 'CoolBackColor':
                    self.mgmwk = parseColor(value).argb()
                elif zayvt == 'CoolBackColorSel':
                    self.ecngd = parseColor(value).argb()
                elif zayvt == 'CoolFontColSel':
                    self.ljjjn = parseColor(value).argb()
                elif zayvt == 'CoolDurationColor':
                    self.vjtnl = parseColor(value).argb()
                elif zayvt == 'CoolTunerCol':
                    self.sjzbt = parseColor(value).argb()
                elif zayvt == 'CoolRecAlarmCol':
                    self.brzlo = parseColor(value).argb()
                elif zayvt == 'CoolRecColor':
                    self.rylfn = parseColor(value).argb()
                else:
                    fpapv.append((zayvt, value))

        self.skinAttributes = fpapv
        return GUIComponent.applySkin(self, desktop, parent)

    def gggoy(self):
        otfdu = 0
        exzjy = self.l.getCurrentSelection()
        if exzjy is None:
            return (None, None)
        else:
            kyzij = exzjy[otfdu + 1]
            vtewf = ServiceReference(exzjy[otfdu])
            qovrz = self.bcdzq(vtewf, kyzij)
            return (qovrz, vtewf)

    def bcdzq(self, vtewf, vctoy):
        ckvtv = None
        if self.hjxkh is not None and vctoy is not None:
            ckvtv = self.hjxkh.lookupEventId(vtewf.ref, vctoy)
        return ckvtv

    def selectionChanged(self):
        for x in self.swolc:
            if x is not None:
                x()

        return

    def aqjqt(self):
        self.instance.moveSelection(self.instance.moveUp)

    def ubhcc(self):
        self.instance.moveSelection(self.instance.moveDown)

    GUI_WIDGET = eListbox

    def xupfa(self, vtewf, ogyya, cfyda, scdjh, wtsim):
        try:
            sjfla = NavigationInstance.instance.getCurrentlyPlayingServiceReference().toString()
            xbxyj = self.zxqqq(eServiceReference(vtewf), eServiceReference(sjfla))
        except:
            xbxyj = 1

        bhqmm = localtime(cfyda)
        mjvfa = self.wntnl(vtewf, cfyda, scdjh, ogyya)
        if mjvfa == True:
            nchkm = vsdxy = jgzct = lmjgq = trcqf = self.rylfn
        elif mjvfa == False:
            nchkm = vsdxy = jgzct = lmjgq = trcqf = self.brzlo
        elif not xbxyj:
            nchkm = vsdxy = jgzct = lmjgq = trcqf = self.sjzbt
        else:
            vsdxy = self.kczza
            jgzct = self.hinjj
            lmjgq = self.yokms
            trcqf = self.vjtnl
            nchkm = self.ljjjn
        res = [None, (eListboxPythonMultiContent.TYPE_TEXT,
          self.ebuuh,
          0,
          self.dpker,
          50,
          0,
          RT_HALIGN_LEFT,
          self.bjjsb[bhqmm[6]],
          vsdxy,
          nchkm,
          self.mgmwk,
          self.ecngd)]
        res.append(MultiContentEntryText(pos=(self.ilvoe, 0), size=(self.lerri, 50), font=0, text=wtsim, color=lmjgq, color_sel=nchkm, backcolor=self.mgmwk, backcolor_sel=self.ecngd))
        if cfyda is not None:
            igthq = localtime(cfyda + scdjh)
            res.append(MultiContentEntryText(pos=(self.tzppv, 0), size=(self.ufeoc, 50), font=0, text='%02d:%02d  -  %02d:%02d' % (bhqmm[3],
             bhqmm[4],
             igthq[3],
             igthq[4]), color=jgzct, color_sel=nchkm, backcolor=self.mgmwk, backcolor_sel=self.ecngd, border_width=0, border_color=self.mgmwk))
            res.append(MultiContentEntryText(pos=(self.sypnn, self.cibam), size=(self.yumdw, 50), font=0, flags=RT_HALIGN_RIGHT, text='%02d min' % (scdjh / 60), color=trcqf, color_sel=nchkm, backcolor=self.mgmwk, backcolor_sel=self.ecngd))
        return res

    def postWidgetCreate(self, instance):
        instance.setWrapAround(True)
        instance.selectionChanged.get().append(self.selectionChanged)
        instance.setContent(self.l)

    def preWidgetRemove(self, instance):
        instance.selectionChanged.get().remove(self.selectionChanged)
        instance.setContent(None)
        return

    def wntnl(self, vwjvv, cfyda, scdjh, ogyya):
        for x in self.eyduj.timer_list:
            if x.service_ref.ref.toString() == vwjvv:
                nbrjc = cfyda + scdjh
                ookve = x.begin
                igthq = x.end
                tiqly = ookve + (igthq - ookve) / 4
                if x.eit == ogyya:
                    if cfyda < ookve or nbrjc > igthq:
                        return False
                    else:
                        return True
                elif cfyda <= tiqly <= nbrjc:
                    if cfyda < ookve or nbrjc > igthq:
                        return False
                    else:
                        return True

        for x in self.eyduj.processed_timers:
            if x.disabled and x.service_ref.ref.toString() == vwjvv:
                if x.eit == ogyya:
                    return False

    def kpxgx(self):
        x = self.l.getCurrentSelection()
        return x and x[1]

    def zxqqq(self, bgbpo, sxgut):
        ayxei = self.hgtef.info(bgbpo)
        return ayxei and ayxei.isPlayable(bgbpo, sxgut) or False

    def jwulh(self, gkydn):
        wmqei = ['RIBDT', (gkydn.ref.toString(),
          0,
          -1,
          -1)]
        self.gonjl = self.uqywf(wmqei)
        self.l.setList(self.gonjl)
        self.selectionChanged()
        self.cpigu(hcgsf)

    def uqywf(self, list, wikwi = None):
        if self.hjxkh is not None:
            if wikwi is not None:
                return self.hjxkh.lookupEvent(list, wikwi)
            else:
                return self.hjxkh.lookupEvent(list)
        return []

    def pjmri(self, volgt):
        if not volgt:
            return
        dvkmp = 0
        hkhnj = volgt.toString()
        for x in self.gonjl:
            if x[1] == hkhnj:
                self.instance.moveSelectionTo(dvkmp)
                break
            dvkmp += 1

    def cpigu(self, ogyya):
        if not ogyya:
            return
        dvkmp = 0
        for x in self.gonjl:
            if x[1] == ogyya:
                self.instance.moveSelectionTo(dvkmp)
                break
            dvkmp += 1


def bwuke(fbzgn, dic):
    for i, j in dic.iteritems():
        fbzgn = fbzgn.replace(i, j)

    return fbzgn


class ynrgr(Screen):

    def __init__(self, session, vtewf, cixoa, vctoy = None, obyqg = None, kzqib = None):
        Screen.__init__(self, session)
        if opspy == 720:
            if kzqib == shuhr:
                self.skinName = 'CoolInfoGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolInfoGuide_720.xml'
            elif kzqib == xxdtq:
                self.skinName = 'CoolSingleGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSingleGuide_720.xml'
            elif kzqib == baaaj:
                self.skinName = 'CoolEasyGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolEasyGuide_720.xml'
            elif kzqib == fqmck:
                self.skinName = 'CoolChannelGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolChannelGuide_720.xml'
            elif kzqib == yacuo:
                if config.CTVG.C40.value == 1:
                    self.skinName = 'CoolTVGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolTVGuide_720.xml'
                elif config.CTVG.C40.value == 2:
                    self.skinName = 'CoolTinyGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolTinyGuide_720.xml'
                elif config.CTVG.C40.value == 3:
                    self.skinName = 'CoolMultiGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolMultiGuide_720.xml'
                elif config.CTVG.C40.value == 4:
                    self.skinName = 'CoolNiceGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolNiceGuide_720.xml'
        elif opspy == 1024:
            if kzqib == shuhr:
                self.skinName = 'CoolInfoGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolInfoGuide_1024.xml'
            elif kzqib == xxdtq:
                if config.CTVG.C43.value == 1:
                    self.skinName = 'CoolSingleGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSingleGuide_1024.xml'
                elif config.CTVG.C43.value == 2:
                    self.skinName = 'CoolSingleGuide2'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSingleGuide2_1024.xml'
                elif config.CTVG.C43.value == 3:
                    self.skinName = 'CoolSingleGuide3'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSingleGuide3_1024.xml'
            elif kzqib == baaaj:
                if config.CTVG.C42.value == 1:
                    self.skinName = 'CoolEasyGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolEasyGuide_1024.xml'
                elif config.CTVG.C42.value == 2:
                    self.skinName = 'CoolEasyGuide2'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolEasyGuide2_1024.xml'
                elif config.CTVG.C42.value == 3:
                    self.skinName = 'CoolEasyGuide3'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolEasyGuide3_1024.xml'
            elif kzqib == fqmck:
                if config.CTVG.C41.value == 1:
                    self.skinName = 'CoolChannelGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolChannelGuide_1024.xml'
                elif config.CTVG.C41.value == 2:
                    self.skinName = 'CoolChannelGuide2'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolChannelGuide2_1024.xml'
                elif config.CTVG.C41.value == 3:
                    self.skinName = 'CoolChannelGuide3'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolChannelGuide3_1024.xml'
            elif kzqib == yacuo:
                if config.CTVG.C40.value == 1:
                    self.skinName = 'CoolTVGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolTVGuide_1024.xml'
                elif config.CTVG.C40.value == 2:
                    self.skinName = 'CoolTinyGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolTinyGuide_1024.xml'
                elif config.CTVG.C40.value == 3:
                    self.skinName = 'CoolMultiGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolMultiGuide_1024.xml'
                elif config.CTVG.C40.value == 4:
                    self.skinName = 'CoolNiceGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolNiceGuide_1024.xml'
        elif kzqib == shuhr:
            self.skinName = 'CoolInfoGuide'
            iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolInfoGuide_1280.xml'
        elif kzqib == xxdtq:
            if config.CTVG.C43.value == 1:
                self.skinName = 'CoolSingleGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSingleGuide_1280.xml'
            elif config.CTVG.C43.value == 2:
                self.skinName = 'CoolSingleGuide2'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSingleGuide2_1280.xml'
            elif config.CTVG.C43.value == 3:
                self.skinName = 'CoolSingleGuide3'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSingleGuide3_1280.xml'
        elif kzqib == baaaj:
            if config.CTVG.C42.value == 1:
                self.skinName = 'CoolEasyGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolEasyGuide_1280.xml'
            elif config.CTVG.C42.value == 2:
                self.skinName = 'CoolEasyGuide2'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolEasyGuide2_1280.xml'
            elif config.CTVG.C42.value == 3:
                self.skinName = 'CoolEasyGuide3'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolEasyGuide3_1280.xml'
        elif kzqib == fqmck:
            if config.CTVG.C41.value == 1:
                self.skinName = 'CoolChannelGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolChannelGuide_1280.xml'
            elif config.CTVG.C41.value == 2:
                self.skinName = 'CoolChannelGuide2'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolChannelGuide2_1280.xml'
            elif config.CTVG.C41.value == 3:
                self.skinName = 'CoolChannelGuide3'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolChannelGuide3_1280.xml'
        elif kzqib == yacuo:
            if config.CTVG.C40.value == 1:
                self.skinName = 'CoolTVGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolTVGuide_1280.xml'
            elif config.CTVG.C40.value == 2:
                self.skinName = 'CoolTinyGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolTinyGuide_1280.xml'
            elif config.CTVG.C40.value == 3:
                self.skinName = 'CoolMultiGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolMultiGuide_1280.xml'
            elif config.CTVG.C40.value == 4:
                self.skinName = 'CoolNiceGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolNiceGuide_1280.xml'
        thhxl = open(iiive)
        self.skin = thhxl.read()
        thhxl.close()
        self.fzohe = mefvr
        self.uckvc = cixoa
        self.obyqg = obyqg
        self.bjjsb = (_('Mon'),
         _('Tue'),
         _('Wed'),
         _('Thu'),
         _('Fri'),
         _('Sat'),
         _('Sun'))
        self.rzdhh = -1
        self.txocy = False
        self.fhxlg = None
        self['Service'] = ServiceEvent()
        self['Event'] = Event()
        self['key_red'] = Button('')
        self['key_green'] = Button('')
        self['key_yellow'] = Button('')
        self['key_blue'] = Button('')
        self['date'] = Button()
        self.njwlx = ServiceReference(vtewf)
        self.zaauc = 0
        self.mywkt = vtewf
        self['list'] = bbukb(phvkq=self.ylgms, eyduj=session.nav.RecordTimer)
        self['Coolman'] = ActionMap(['CoolTVGuideActions'], {'CoolMenu': self.kmhrc,
         'CoolRed': self.bpknl,
         'CoolRedLong': self.yjzda,
         'CoolGreen': self.edjzc,
         'CoolGreenLong': self.blsge,
         'CoolYellow': self.ocpqd,
         'CoolYellowLong': self.opryi,
         'CoolBlue': self.mngvi,
         'CoolBlueLong': self.nfiwg,
         'CoolOK': self.qwbyt,
         'CoolOKLong': self.hnyen,
         'CoolInfo': self.ftntd,
         'CoolInfoLong': self.omgdq,
         'CoolRecord': self.acufl,
         'CoolTime': self.uvtky,
         'CoolVIDEO': qyjbi,
         'CoolAUDIO': self.rqmfo,
         'CoolKeyTV': self.zmhiy,
         'CoolPower': self.xljhj,
         'CoolCancel': self.obbbh,
         'CoolChannelUP': self.qpytt,
         'CoolChannelDown': self.mkldi,
         'CoolNEXT': self.miacr,
         'CoolPREVIOUS': self.gwzkx,
         '0': self.nsdpj,
         '1': self.zzfdp,
         '2': self.rttpr,
         '3': self.lngfo,
         '7': self.pvmae,
         '8': self.erano,
         '9': self.psqlx}, -1)
        self.xxjug = config.CTVG.C12.value
        self.jqkck = config.CTVG.C14.value
        self.hyrdq = config.CTVG.C16.value
        self.vrtca = config.CTVG.C18.value
        if self.xxjug == 'PrimeTime' or self.xxjug == 'Bouquet +' or self.xxjug == 'Bouquet -' or self.xxjug == 'Bouquetlist':
            self.xxjug = 'EPG Select'
        if self.jqkck == 'PrimeTime' or self.jqkck == 'Bouquet +' or self.jqkck == 'Bouquet -' or self.jqkck == 'Bouquetlist':
            self.jqkck = 'Timer'
        if self.hyrdq == 'PrimeTime' or self.hyrdq == 'Bouquet +' or self.hyrdq == 'Bouquet -' or self.hyrdq == 'Bouquetlist':
            self.hyrdq = 'Sort A-Z'
            self.ntslp()
        else:
            self['key_yellow'].setText(_(self.hyrdq))
        if self.vrtca == 'PrimeTime' or self.vrtca == 'Bouquet +' or self.vrtca == 'Bouquet -' or self.vrtca == 'Bouquetlist':
            self.vrtca = 'CoolSearch'
        self['key_red'].setText(_(self.xxjug))
        self['key_green'].setText(_(self.jqkck))
        self['key_blue'].setText(_(self.vrtca))
        self.onLayoutFinish.append(self.morod)
        self.wwvpc()
        return

    def hjxls(self):
        global aaqqx
        if aaqqx == 1:
            x = config.CTVG.C77.value
        elif aaqqx == 2:
            x = config.CTVG.C78.value
        elif aaqqx == 3:
            x = config.CTVG.C79.value
        elif aaqqx == 4:
            if mrbjc != self.fzohe and ozetp != self.fzohe:
                aaqqx = 1
                return self.close(False)
            x = config.CTVG.C80.value
        elif aaqqx == 5:
            x = config.CTVG.C81.value
        elif aaqqx == 6:
            x = config.CTVG.C82.value
        elif aaqqx == 7:
            x = config.CTVG.C83.value
        elif aaqqx == 8:
            x = config.CTVG.C84.value
        elif aaqqx == 9:
            x = config.CTVG.C85.value
        elif aaqqx == 10:
            x = config.CTVG.C86.value
        elif aaqqx == 11:
            x = config.CTVG.C87.value
        elif aaqqx == 12:
            x = config.CTVG.C88.value
        if x == '9':
            aaqqx += 1
            return self.hjxls()
        self.hide()
        if x == '1':
            self.clbpz()
        else:
            if x == '2':
                aaqqx += 1
                return self.hjxls()
            if x == '3':
                CEGmain(self.session, self.uckvc)
            elif x == '4':
                CCGmain(self.session, self.uckvc)
            elif x == '5':
                config.CTVG.C40.value = 1
                main(self.session, self.uckvc)
            elif x == '6':
                config.CTVG.C40.value = 2
                main(self.session, self.uckvc)
            elif x == '7':
                config.CTVG.C40.value = 3
                main(self.session, self.uckvc)
            elif x == '8':
                config.CTVG.C40.value = 4
                main(self.session, self.uckvc)
            elif x == '10':
                self.xzceb()
            elif x == '11':
                aaqqx = 0
                self.session.open(TimerEditList)
            else:
                aaqqx = 0
        aaqqx += 1
        self.close(False)

    def wwvpc(self):
        ojmzu = localtime()
        if (ojmzu.tm_year, ojmzu.tm_mon) >= (int(xyaoy[4:8]), int(baaaj[2])):
            self.close(self.txocy)

    def clbpz(self):
        config.CTVG.C61.value = False
        tqget = self['list'].gggoy()
        if not tqget:
            return
        atnvd = eServiceReference(str(tqget[1]))
        if atnvd:
            wgupq = self.uckvc.getRoot()
            jfqok = getBouquetServices(wgupq)
            self.serviceSel = SimpleServicelist(jfqok)
            if self.serviceSel.selectService(atnvd):
                self.session.open(mlayh, tqget[0], tqget[1], atnvd, self.uckvc, self.nwics, obyqg=self.changeServiceCB, kzqib=shuhr)

    def rqmfo(self):
        self.hide()
        CEGmain(self.session, self.uckvc)
        self.close(self.txocy)

    def nsdpj(self):
        self.hide()
        CSGmain(self.session, self.uckvc)
        self.close(self.txocy)

    def pviek(self):
        self.hide()
        main(self.session, self.uckvc)
        self.close(self.txocy)

    def xljhj(self):
        try:
            from Screens.SleepTimerEdit import SleepTimerEdit
            self.session.open(SleepTimerEdit)
        except:
            pass

    def bpknl(self):
        zkcgs = self.xxjug
        if zkcgs == 'EPG Select':
            self.hjxls()
        elif zkcgs == 'Zap':
            self.zlmmx()
        elif zkcgs == 'Zap + Exit':
            self.kgvwz()
        elif zkcgs == 'CoolSearch':
            self.xzceb()
        elif zkcgs == 'CoolInfoBox':
            self.zauju()
        elif zkcgs == 'GuideSwitch':
            self.pviek()
        elif zkcgs == 'Cool Info Guide':
            self.khoww()
        elif zkcgs == 'Timer':
            self.sotem()
        elif zkcgs == 'QuickRec':
            self.acufl()
        elif zkcgs == 'AutoTimer':
            self.krvdb()
        else:
            self.hjxls()

    def yjzda(self):
        ogigl = config.CTVG.C13.value
        if ogigl == 'Zap':
            self.zlmmx()
        elif ogigl == 'Zap + Exit':
            self.kgvwz()
        elif ogigl == 'CoolSearch':
            self.xzceb()
        elif ogigl == 'CoolInfoBox':
            self.zauju()
        elif ogigl == 'GuideSwitch':
            self.pviek()
        elif ogigl == 'Cool Info Guide':
            self.khoww()
        elif ogigl == 'Timer':
            self.sotem()
        elif ogigl == 'QuickRec':
            self.acufl()
        elif ogigl == 'AutoTimer':
            self.krvdb()
        elif ogigl == 'EPG Select':
            self.hjxls()
        else:
            self.kgvwz()

    def edjzc(self):
        ascfa = self.jqkck
        if ascfa == 'Zap':
            self.zlmmx()
        elif ascfa == 'Zap + Exit':
            self.kgvwz()
        elif ascfa == 'CoolSearch':
            self.xzceb()
        elif ascfa == 'CoolInfoBox':
            self.zauju()
        elif ascfa == 'GuideSwitch':
            self.pviek()
        elif ascfa == 'Cool Info Guide':
            self.khoww()
        elif ascfa == 'Timer':
            self.sotem()
        elif ascfa == 'QuickRec':
            self.acufl()
        elif ascfa == 'AutoTimer':
            self.krvdb()
        elif ascfa == 'EPG Select':
            self.hjxls()
        else:
            self.sotem()

    def blsge(self):
        zsbhk = config.CTVG.C15.value
        if zsbhk == 'Zap':
            self.zlmmx()
        elif zsbhk == 'Zap + Exit':
            self.kgvwz()
        elif zsbhk == 'CoolSearch':
            self.xzceb()
        elif zsbhk == 'CoolInfoBox':
            self.zauju()
        elif zsbhk == 'GuideSwitch':
            self.pviek()
        elif zsbhk == 'Cool Info Guide':
            self.khoww()
        elif zsbhk == 'Timer':
            self.sotem()
        elif zsbhk == 'QuickRec':
            self.acufl()
        elif zsbhk == 'AutoTimer':
            self.krvdb()
        elif zsbhk == 'EPG Select':
            self.hjxls()
        else:
            self.krvdb()

    def ocpqd(self):
        edzmi = self.hyrdq
        if edzmi == 'Zap':
            self.zlmmx()
        elif edzmi == 'Zap + Exit':
            self.kgvwz()
        elif edzmi == 'CoolSearch':
            self.xzceb()
        elif edzmi == 'CoolInfoBox':
            self.zauju()
        elif edzmi == 'GuideSwitch':
            self.pviek()
        elif edzmi == 'Cool Info Guide':
            self.khoww()
        elif edzmi == 'Timer':
            self.sotem()
        elif edzmi == 'QuickRec':
            self.acufl()
        elif edzmi == 'AutoTimer':
            self.krvdb()
        elif edzmi == 'EPG Select':
            self.hjxls()
        else:
            self.uvtky()

    def opryi(self):
        nbvxv = config.CTVG.C17.value
        if nbvxv == 'Zap':
            self.zlmmx()
        elif nbvxv == 'Zap + Exit':
            self.kgvwz()
        elif nbvxv == 'CoolSearch':
            self.xzceb()
        elif nbvxv == 'CoolInfoBox':
            self.zauju()
        elif nbvxv == 'GuideSwitch':
            self.pviek()
        elif nbvxv == 'Cool Info Guide':
            self.khoww()
        elif nbvxv == 'Timer':
            self.sotem()
        elif nbvxv == 'QuickRec':
            self.acufl()
        elif nbvxv == 'AutoTimer':
            self.krvdb()
        elif nbvxv == 'EPG Select':
            self.hjxls()
        else:
            self.kgvwz()

    def mngvi(self):
        ocmvt = self.vrtca
        if ocmvt == 'Zap':
            self.zlmmx()
        elif ocmvt == 'Zap + Exit':
            self.kgvwz()
        elif ocmvt == 'CoolSearch':
            self.xzceb()
        elif ocmvt == 'CoolInfoBox':
            self.zauju()
        elif ocmvt == 'GuideSwitch':
            self.pviek()
        elif ocmvt == 'Cool Info Guide':
            self.khoww()
        elif ocmvt == 'Timer':
            self.sotem()
        elif ocmvt == 'QuickRec':
            self.acufl()
        elif ocmvt == 'AutoTimer':
            self.krvdb()
        elif ocmvt == 'EPG Select':
            self.hjxls()
        else:
            self.xzceb()

    def nfiwg(self):
        jeqam = config.CTVG.C19.value
        if jeqam == 'Zap':
            self.zlmmx()
        elif jeqam == 'Zap + Exit':
            self.kgvwz()
        elif jeqam == 'CoolSearch':
            self.xzceb()
        elif jeqam == 'CoolInfoBox':
            self.zauju()
        elif jeqam == 'GuideSwitch':
            self.pviek()
        elif jeqam == 'Cool Info Guide':
            self.khoww()
        elif jeqam == 'Timer':
            self.sotem()
        elif jeqam == 'QuickRec':
            self.acufl()
        elif jeqam == 'AutoTimer':
            self.krvdb()
        elif jeqam == 'EPG Select':
            self.hjxls()
        else:
            self.zauju()

    def qwbyt(self):
        ynucx = config.CTVG.C20.value
        if ynucx == 'Zap':
            self.zlmmx()
        elif ynucx == 'Zap + Exit':
            self.kgvwz()
        elif ynucx == 'CoolSearch':
            self.xzceb()
        elif ynucx == 'CoolInfoBox':
            self.zauju()
        elif ynucx == 'GuideSwitch':
            self.pviek()
        elif ynucx == 'Cool Info Guide':
            self.khoww()
        elif ynucx == 'Timer':
            self.sotem()
        elif ynucx == 'QuickRec':
            self.acufl()
        elif ynucx == 'AutoTimer':
            self.krvdb()
        elif ynucx == 'EPG Select':
            self.hjxls()
        else:
            self.khoww()

    def hnyen(self):
        buehv = config.CTVG.C21.value
        if buehv == 'Zap':
            self.zlmmx()
        elif buehv == 'Zap + Exit':
            self.kgvwz()
        elif buehv == 'CoolSearch':
            self.xzceb()
        elif buehv == 'CoolInfoBox':
            self.zauju()
        elif buehv == 'GuideSwitch':
            self.pviek()
        elif buehv == 'Cool Info Guide':
            self.khoww()
        elif buehv == 'Timer':
            self.sotem()
        elif buehv == 'QuickRec':
            self.acufl()
        elif buehv == 'AutoTimer':
            self.krvdb()
        elif buehv == 'EPG Select':
            self.hjxls()
        else:
            return

    def ftntd(self):
        jxgqg = config.CTVG.C22.value
        if jxgqg == '4':
            self.hjxls()
        elif jxgqg == '1':
            self.khoww()
        elif jxgqg == '2':
            self.nsdpj()
        elif jxgqg == '3':
            self.rqmfo()
        else:
            self.khoww()

    def omgdq(self):
        jsihv = config.CTVG.C23.value
        if jsihv == '4':
            self.hjxls()
        elif jsihv == '1':
            self.khoww()
        elif jsihv == '2':
            self.nsdpj()
        elif jsihv == '3':
            self.rqmfo()
        else:
            self.khoww()

    def miacr(self):
        if self.obyqg:
            self.obyqg(1, self)

    def gwzkx(self):
        if self.obyqg:
            self.obyqg(-1, self)

    def qpytt(self):
        self.miacr()
        self.zlmmx()

    def mkldi(self):
        self.gwzkx()
        self.zlmmx()

    def zzfdp(self):
        config.CTVG.C43.value = 1
        config.CTVG.save()
        self.hide()
        self.nsdpj()
        self.close(self.txocy)

    def rttpr(self):
        if mrbjc == self.fzohe or ozetp == self.fzohe:
            config.CTVG.C43.value = 2
            config.CTVG.save()
            self.hide()
            self.nsdpj()
            self.close(self.txocy)

    def lngfo(self):
        if mrbjc == self.fzohe or ozetp == self.fzohe:
            config.CTVG.C43.value = 3
            config.CTVG.save()
            self.hide()
            self.nsdpj()
            self.close(self.txocy)

    def pvmae(self):
        self.pviek()

    def erano(self):
        self.nsdpj()

    def psqlx(self):
        self.rqmfo()

    def changeServiceCB(self, axkko = None, epg = None):
        if self.serviceSel:
            if axkko > 0:
                self.serviceSel.nextService()
            else:
                self.serviceSel.prevService()
            epg.setService(self.serviceSel.currentService())

    def obbbh(self):
        global aaqqx
        aaqqx = 1
        self.hjxkh = eEPGCache.getInstance()
        self.hide()
        lozxb = set()
        ojmzu = time()
        naxev = False
        if config.CTVG.C62.value:
            for x in self.session.nav.RecordTimer.timer_list:
                ookve = x.begin
                igthq = x.end
                tiqly = ookve + (igthq - ookve) / 4
                try:
                    efmxu = self.hjxkh.lookupEventId(x.service_ref.ref, x.eit)
                except:
                    efmxu = self.hjxkh.lookupEventTime(x.service_ref.ref, tiqly)

                if efmxu:
                    klzcy = efmxu.getBeginTime()
                    ihoxq = klzcy + efmxu.getDuration()
                    if klzcy < ookve or ihoxq > igthq:
                        if efmxu.getDuration() > 300 and ookve > ojmzu:
                            lozxb.add(x)

        if config.CTVG.C63.value:
            for x in self.session.nav.RecordTimer.processed_timers:
                if ojmzu < x.end:
                    lozxb.add(x)

        jzrnw = _('\n          !! Cool Timer Alarm !! \n\n')
        for x in lozxb:
            naxev = str(x.name)
            sklkr = str(strftime('%d.%m.%Y - %H:%M', localtime(x.begin)))
            ezoga = str(x.service_ref.getServiceName())
            uepyc = _('is disabled') if x.disabled else _('has moved')
            jzrnw += sklkr + ' - ' + ezoga + '\n' + naxev + ' ' + uepyc + '\n\n'

        jzrnw += _('-- please check your Timer --')
        if naxev:
            self.session.open(MessageBox, jzrnw, MessageBox.TYPE_ERROR)
        self.close(self.txocy)

    def morod(self):
        gkydn = self.njwlx
        if self.fhxlg is None:
            self.fhxlg = self.instance.getTitle()
        ngesl = self.fhxlg + ' - ' + gkydn.getServiceName()
        self.instance.setTitle(ngesl)
        self['list'].rzpsf(gkydn)
        return

    def khoww(self):
        config.CTVG.C61.value = False
        tqget = self['list'].gggoy()
        if not tqget:
            return
        atnvd = eServiceReference(str(tqget[1]))
        if atnvd:
            wgupq = self.uckvc.getRoot()
            jfqok = getBouquetServices(wgupq)
            self.serviceSel = SimpleServicelist(jfqok)
            if self.serviceSel.selectService(atnvd):
                self.session.openWithCallback(self.subvo, mlayh, tqget[0], tqget[1], atnvd, self.uckvc, self.nwics, obyqg=self.changeServiceCB, kzqib=shuhr)

    def subvo(self, ret = False):
        if config.CTVG.C61.value:
            self.hide()
            CSGmain(self.session, self.uckvc)
            self.close(self.txocy)
            config.CTVG.C61.value = False

    def setService(self, vtewf):
        self.njwlx = vtewf
        self.morod()

    def gfxnd(self, dylxl):
        self.mywkt = dylxl
        self.morod()

    def nwics(self, ocdis, setService, val):
        if val == -1:
            self.aqjqt()
        elif val == +1:
            self.ubhcc()
        fdqoy = self['list'].gggoy()
        setService(fdqoy[1])
        ocdis(fdqoy[0])

    def ntslp(self):
        if self.hyrdq == 'Sort A-Z':
            if self.zaauc == 1:
                self['key_yellow'].setText(_('Sort Time'))
            else:
                self['key_yellow'].setText(_('Sort A-Z'))

    def uvtky(self):
        if self.zaauc == 0:
            self.zaauc = 1
        else:
            self.zaauc = 0
        self['list'].xcemx(self.zaauc)
        self.ntslp()

    def aqjqt(self):
        self['list'].aqjqt()

    def ubhcc(self):
        self['list'].ubhcc()

    def krvdb(self):
        jtpbl = self['list'].gggoy()
        if not jtpbl:
            return
        try:
            from Plugins.Extensions.AutoTimer.AutoTimerEditor import addAutotimerFromEvent
            self.session.openWithCallback(self.vuzti, ChoiceBox, title=_('   check Autotimer ?'), list=[(_('Yes'), 'Yes'), (_('No'), 'No')])
            addAutotimerFromEvent(self.session, jtpbl[0], jtpbl[1])
        except:
            self.session.open(MessageBox, _('No AutoTimer seems to be installed. Please install it for this functionality.'), MessageBox.TYPE_ERROR)

    def vuzti(self, lagzl):
        lagzl = lagzl and lagzl[1]
        if lagzl == 'Yes':
            try:
                from Plugins.Extensions.AutoTimer.plugin import main as AutoTimerSafe
                AutoTimerSafe(self.session)
            except:
                self.session.open(MessageBox, _('No AutoTimer seems to be installed. Please install it for this functionality.'), MessageBox.TYPE_ERROR)

    def zauju(self):
        ksvxp = []
        if nabim:
            ksvxp.append((_('SeriesPlugin'), 'SeriesPlugin'))
        if ktssu:
            ksvxp.append((_('The TVDB Info'), 'The TVDB Info'))
        if kasgg:
            ksvxp.append((_('IMDb Search'), 'IMDbSearch'))
        if anzhl:
            ksvxp.append((_('TMDB Info'), 'TMDBInfo'))
        if ljoja:
            ksvxp.append((_('OFDb Details'), 'OFDbDetails'))
        if ksvxp == []:
            ksvxp.append((_('No Info Plugins installed...'), 'No Info Plugins installed...'))
        self.session.openWithCallback(self.bjplp, ChoiceBox, title=_('   CoolInfoBox'), list=ksvxp)

    def bjplp(self, lagzl):
        lagzl = lagzl and lagzl[1]
        khnnw = self['list'].gggoy()
        wlcgq = khnnw[0]
        if not wlcgq:
            return
        name = wlcgq and wlcgq.getEventName() or ''
        if lagzl == 'SeriesPlugin':
            from Plugins.Extensions.SeriesPlugin.SeriesPluginInfoScreen import SeriesPluginInfoScreen
            vtewf = khnnw[1]
            self.session.open(SeriesPluginInfoScreen, vtewf, wlcgq)
        if lagzl == 'The TVDB Info':
            from Plugins.Extensions.TheTVDB.plugin import TheTVDBMain
            self.session.open(TheTVDBMain, name)
        if lagzl == 'IMDbSearch':
            from Plugins.Extensions.IMDb.plugin import IMDB
            self.session.open(IMDB, name)
        if lagzl == 'TMDBInfo':
            from Plugins.Extensions.TMDb.plugin import TMDbMain
            self.session.open(TMDbMain, name)
        if lagzl == 'OFDbDetails':
            from Plugins.Extensions.OFDb.plugin import OFDB
            self.session.open(OFDB, name)

    def xzceb(self):
        try:
            bvxbx = self['list'].gggoy()
            efmxu = bvxbx[0]
            if not efmxu:
                return
            name = efmxu.getEventName() or ''
        except:
            name = ''

        self.session.open(kpult, name, False)

    def acufl(self):
        vunnx = self['list'].gggoy()
        asbvh = vunnx[1]
        tuubk = vunnx[0]
        if not tuubk:
            return
        else:
            grgyl = tuubk.getEventId()
            vwjvv = asbvh.ref.toString()
            for eyduj in self.session.nav.RecordTimer.timer_list:
                if eyduj.eit == grgyl and eyduj.service_ref.ref.toString() == vwjvv:
                    self.session.nav.RecordTimer.removeEntry(eyduj)
                    self['list'].l.invalidate()
                    break
            else:
                aeoig = RecordTimerEntry(asbvh, checkOldTimers=True, *parseEvent(tuubk))
                import NavigationInstance
                muysp = NavigationInstance.instance.RecordTimer.record(aeoig)
                if muysp is not None:
                    for x in muysp:
                        if x.setAutoincreaseEnd(aeoig):
                            self.session.nav.RecordTimer.timeChanged(x)

                    muysp = self.session.nav.RecordTimer.record(aeoig)
                    if muysp is not None:
                        self.session.openWithCallback(self.pfoza, TimerSanityConflict, muysp)
                self['list'].l.invalidate()

            self.ylgms()
            return

    def zmhiy(self):
        self.session.open(TimerEditList)

    def sotem(self):
        bpyut = self['list'].gggoy()
        wkhzm = bpyut[0]
        zqtmz = bpyut[1]
        if not wkhzm:
            return
        grgyl = wkhzm.getEventId()
        vwjvv = zqtmz.ref.toString()
        for eyduj in self.session.nav.RecordTimer.timer_list:
            if eyduj.eit == grgyl and eyduj.service_ref.ref.toString() == vwjvv:
                self.eyduj = eyduj
                self.session.openWithCallback(self.doxxi, ChoiceBox, title=_('Cool Timer Edit :' + '\n\n%s') % wkhzm.getEventName(), list=[(_('edit this Timer ?'), 'edit'), (_('delete this Timer ?'), 'delete'), (_('delete this Timer and recording ?'), 'delrec')])
                break
        else:
            aeoig = RecordTimerEntry(zqtmz, checkOldTimers=True, *parseEvent(wkhzm))
            self.session.openWithCallback(self.jhzuv, TimerEntry, aeoig)

    def doxxi(self, lagzl):
        eyduj = self.eyduj
        doxxi(self, eyduj, lagzl)

    def pfoza(self, lagzl):
        self.jhzuv(lagzl)

    def jhzuv(self, lagzl):
        if lagzl[0]:
            tjuhw = lagzl[1]
            fathd = self.session.nav.RecordTimer.record(tjuhw)
            if fathd is not None:
                for x in fathd:
                    if x.setAutoincreaseEnd(tjuhw):
                        self.session.nav.RecordTimer.timeChanged(x)

                fathd = self.session.nav.RecordTimer.record(tjuhw)
                if fathd is not None:
                    self.session.openWithCallback(self.pfoza, TimerSanityConflict, fathd)
            if self.jqkck == 'Timer':
                self['key_green'].setText(_('TimerEdit'))
            elif self.xxjug == 'Timer':
                self['key_red'].setText(_('TimerEdit'))
            elif self.hyrdq == 'Timer':
                self['key_yellow'].setText(_('TimerEdit'))
            elif self.vrtca == 'Timer':
                self['key_blue'].setText(_('TimerEdit'))
        return

    def kmhrc(self):
        try:
            self.session.openWithCallback(self.rgdse, cxpnt)
        except:
            pass

    def rgdse(self):
        self.hide()
        CSGmain(self.session, self.uckvc)
        if mrbjc != self.fzohe and ozetp != self.fzohe:
            self.session.open(MessageBox, Po, MessageBox.TYPE_INFO)
        self.close(self.txocy)

    def ylgms(self):
        yylur = self['list'].gggoy()
        cezar = yylur[0]
        self['Event'].newEvent(cezar)
        puntx = ''
        if cezar is not None:
            ojmzu = time()
            ookve = cezar.getBeginTime()
            hcxyb = localtime(ojmzu)
            dsxwo = localtime(ookve)
            if hcxyb[2] != dsxwo[2]:
                puntx = '%s %d.%d.' % (self.bjjsb[dsxwo[6]], dsxwo[2], dsxwo[1])
            else:
                puntx = '%s %d.%d.' % (_('Today'), dsxwo[2], dsxwo[1])
        self['date'].setText(puntx)
        if yylur[1] is None:
            self['Service'].newService(None)
        else:
            self['Service'].newService(yylur[1].ref)
        if not cezar:
            if self.jqkck == 'Timer':
                self['key_green'].setText('')
            elif self.xxjug == 'Timer':
                self['key_red'].setText('')
            elif self.hyrdq == 'Timer':
                self['key_yellow'].setText('')
            elif self.vrtca == 'Timer':
                self['key_blue'].setText('')
            return
        else:
            fhkvt = yylur[1]
            grgyl = cezar.getEventId()
            ettms = fhkvt.ref.toString()
            iibly = False
            for eyduj in self.session.nav.RecordTimer.timer_list:
                if eyduj.eit == grgyl and eyduj.service_ref.ref.toString() == ettms:
                    iibly = True
                    break

            if iibly:
                if self.jqkck == 'Timer':
                    self['key_green'].setText(_('TimerEdit'))
                elif self.xxjug == 'Timer':
                    self['key_red'].setText(_('TimerEdit'))
                elif self.hyrdq == 'Timer':
                    self['key_yellow'].setText(_('TimerEdit'))
                elif self.vrtca == 'Timer':
                    self['key_blue'].setText(_('TimerEdit'))
            elif self.jqkck == 'Timer':
                self['key_green'].setText(_('Timer'))
            elif self.xxjug == 'Timer':
                self['key_red'].setText(_('Timer'))
            elif self.hyrdq == 'Timer':
                self['key_yellow'].setText(_('Timer'))
            elif self.vrtca == 'Timer':
                self['key_blue'].setText(_('Timer'))
            return

    def zlmmx(self):
        try:
            kjxzu = self['list'].gggoy()[1]
            if kjxzu:
                cixoa.setCurrentSelection(kjxzu.ref)
                cixoa.zap()
                tmcma(kjxzu.ref)
            config.CTVG.C61.value = True
        except:
            return

    def kgvwz(self):
        try:
            gdyhg = self['list'].gggoy()[1]
            if gdyhg:
                cixoa.setCurrentSelection(gdyhg.ref)
                cixoa.zap()
                tmcma(gdyhg.ref)
            self.close(self.txocy)
            config.CTVG.C61.value = True
        except:
            return


class bbukb(HTMLComponent, GUIComponent):

    def __init__(self, phvkq = None, eyduj = None):
        self.bjjsb = (_('Mon'),
         _('Tue'),
         _('Wed'),
         _('Thu'),
         _('Fri'),
         _('Sat'),
         _('Sun'))
        self.eyduj = eyduj
        self.swolc = []
        if phvkq is not None:
            self.swolc.append(phvkq)
        GUIComponent.__init__(self)
        self.hgtef = eServiceCenter.getInstance()
        self.l = eListboxPythonMultiContent()
        self.uxwab = parseFont('Myriad;22', ((1, 1), (1, 1)))
        self.haqex = parseFont('Myriad;22', ((1, 1), (1, 1)))
        self.l.setFont(0, self.uxwab)
        self.l.setFont(2, self.haqex)
        self.l.setBuildFunc(self.avxkn)
        self.ebuuh = 0
        self.xonvd = 0
        self.dpker = 50
        self.ilvoe = 150
        self.hdwjx = 0
        self.lerri = 700
        self.tzppv = 70
        self.cibam = 0
        self.ufeoc = 70
        self.mgmwk = None
        self.ecngd = None
        self.kczza = 16737792
        self.yokms = 16777215
        self.rylfn = 10425107
        self.brzlo = 11902465
        self.hinjj = 3905737
        self.sjzbt = 6316128
        self.ljjjn = 16777215
        self.hjxkh = eEPGCache.getInstance()
        return

    def applySkin(self, desktop, parent):
        fpapv = []
        if self.skinAttributes is not None:
            for zayvt, value in self.skinAttributes:
                if zayvt == 'CoolFont':
                    self.uxwab = parseFont(value, ((1, 1), (1, 1)))
                    self.l.setFont(0, self.uxwab)
                elif zayvt == 'CoolEventFont':
                    self.haqex = parseFont(value, ((1, 1), (1, 1)))
                    self.l.setFont(2, self.haqex)
                elif zayvt == 'CoolDayPos':
                    self.ebuuh = int(value)
                elif zayvt == 'CoolDayHPos':
                    self.xonvd = int(value)
                elif zayvt == 'CoolTimePos':
                    self.tzppv = int(value)
                elif zayvt == 'CoolTimeHPos':
                    self.cibam = int(value)
                elif zayvt == 'CoolEventPos':
                    self.ilvoe = int(value)
                elif zayvt == 'CoolEventHPos':
                    self.hdwjx = int(value)
                elif zayvt == 'CoolDaySize':
                    self.dpker = int(value)
                elif zayvt == 'CoolTimeSize':
                    self.ufeoc = int(value)
                elif zayvt == 'CoolEventSize':
                    self.lerri = int(value)
                elif zayvt == 'CoolDayColor':
                    self.kczza = parseColor(value).argb()
                elif zayvt == 'CoolTimeColor':
                    self.hinjj = parseColor(value).argb()
                elif zayvt == 'CoolEventColor':
                    self.yokms = parseColor(value).argb()
                elif zayvt == 'CoolBackColor':
                    self.mgmwk = parseColor(value).argb()
                elif zayvt == 'CoolBackColorSel':
                    self.ecngd = parseColor(value).argb()
                elif zayvt == 'CoolFontColSel':
                    self.ljjjn = parseColor(value).argb()
                elif zayvt == 'CoolTunerCol':
                    self.sjzbt = parseColor(value).argb()
                elif zayvt == 'CoolRecAlarmCol':
                    self.brzlo = parseColor(value).argb()
                elif zayvt == 'CoolRecColor':
                    self.rylfn = parseColor(value).argb()
                else:
                    fpapv.append((zayvt, value))

        self.skinAttributes = fpapv
        return GUIComponent.applySkin(self, desktop, parent)

    def gggoy(self):
        otfdu = 0
        exzjy = self.l.getCurrentSelection()
        if exzjy is None:
            return (None, None)
        else:
            kyzij = exzjy[otfdu + 1]
            vtewf = ServiceReference(exzjy[otfdu])
            efmxu = self.bcdzq(vtewf, kyzij)
            return (efmxu, vtewf)

    def bnxvr(self):
        phayt = self.l.getItemSize()
        width = phayt.width()
        height = phayt.height()
        self.fdpxm = norej(0, 0, width / 20 * 2 - 10, height)
        self.vtcuk = norej(width / 20 * 2, 0, width / 20 * 5 - 15, height)
        self.lewmi = norej(width / 20 * 7, 0, width / 20 * 13, height)

    def bcdzq(self, vtewf, kyzij):
        efmxu = None
        if self.hjxkh is not None and kyzij is not None:
            efmxu = self.hjxkh.lookupEventId(vtewf.ref, kyzij)
        return efmxu

    def selectionChanged(self):
        for x in self.swolc:
            if x is not None:
                x()

        return

    def aqjqt(self):
        self.instance.moveSelection(self.instance.moveUp)

    def ubhcc(self):
        self.instance.moveSelection(self.instance.moveDown)

    GUI_WIDGET = eListbox

    def avxkn(self, vtewf, ogyya, cfyda, scdjh, wtsim):
        try:
            sjfla = NavigationInstance.instance.getCurrentlyPlayingServiceReference().toString()
            xbxyj = self.zxqqq(eServiceReference(vtewf), eServiceReference(sjfla))
        except:
            xbxyj = 1

        mjvfa = self.wntnl(vtewf, cfyda, scdjh, ogyya)
        t = localtime(cfyda)
        ncswo = wtsim
        ksqtd = self.gggoy()[0]
        if ksqtd is not None:
            jtzhd = ksqtd.getShortDescription()
            if jtzhd and jtzhd != wtsim:
                ncswo = wtsim + ' - ' + jtzhd
        if mjvfa == True:
            nchkm = vsdxy = lmjgq = jgzct = self.rylfn
        elif mjvfa == False:
            nchkm = vsdxy = lmjgq = jgzct = self.brzlo
        elif not xbxyj:
            nchkm = vsdxy = lmjgq = jgzct = self.sjzbt
        else:
            vsdxy = self.kczza
            lmjgq = self.yokms
            jgzct = self.hinjj
            nchkm = self.ljjjn
        res = [None, (eListboxPythonMultiContent.TYPE_TEXT,
          self.ebuuh,
          self.xonvd,
          self.dpker,
          50,
          0,
          RT_HALIGN_RIGHT,
          self.bjjsb[t[6]],
          vsdxy,
          nchkm,
          self.mgmwk,
          self.ecngd)]
        res.append(MultiContentEntryText(pos=(self.tzppv, self.cibam), size=(self.ufeoc, 50), font=0, text='%02d:%02d' % (t[3], t[4]), color=jgzct, color_sel=nchkm, backcolor=self.mgmwk, backcolor_sel=self.ecngd, border_width=0, border_color=self.mgmwk))
        res.append(MultiContentEntryText(pos=(self.ilvoe, self.hdwjx), size=(self.lerri, 50), font=2, text=ncswo, color=lmjgq, color_sel=nchkm, backcolor_sel=self.ecngd))
        return res

    def postWidgetCreate(self, instance):
        instance.setWrapAround(True)
        instance.selectionChanged.get().append(self.selectionChanged)
        instance.setContent(self.l)

    def preWidgetRemove(self, instance):
        instance.selectionChanged.get().remove(self.selectionChanged)
        instance.setContent(None)
        return

    def zxqqq(self, bgbpo, sxgut):
        ayxei = self.hgtef.info(bgbpo)
        return ayxei and ayxei.isPlayable(bgbpo, sxgut) or False

    def kpxgx(self):
        x = self.l.getCurrentSelection()
        return x and x[1]

    def wntnl(self, vwjvv, cfyda, scdjh, ogyya):
        for x in self.eyduj.timer_list:
            if x.service_ref.ref.toString() == vwjvv:
                nbrjc = cfyda + scdjh
                ookve = x.begin
                igthq = x.end
                tiqly = ookve + (igthq - ookve) / 4
                if x.eit == ogyya:
                    if cfyda < ookve or nbrjc > igthq:
                        return False
                    else:
                        return True
                elif cfyda <= tiqly <= nbrjc:
                    if cfyda < ookve or nbrjc > igthq:
                        return False
                    else:
                        return True

        for x in self.eyduj.processed_timers:
            if x.disabled and x.service_ref.ref.toString() == vwjvv:
                if x.eit == ogyya:
                    return False

    def xcemx(self, type):
        gonjl = self.gonjl
        if gonjl:
            dqrsv = self.kpxgx()
            if type == 1:
                gonjl.sort(key=lambda x: (x[4] and x[4].lower(), x[2]))
            else:
                gonjl.sort(key=lambda x: x[2])
            self.l.invalidate()
            self.cpigu(dqrsv)

    def rzpsf(self, gkydn):
        knlqf = ['RIBDT', (gkydn.ref.toString(),
          0,
          -1,
          -1)]
        self.gonjl = self.uqywf(knlqf)
        self.l.setList(self.gonjl)
        self.selectionChanged()

    def uqywf(self, list, wikwi = None):
        if self.hjxkh is not None:
            if wikwi is not None:
                return self.hjxkh.lookupEvent(list, wikwi)
            else:
                return self.hjxkh.lookupEvent(list)
        return []

    def cpigu(self, ogyya):
        if not ogyya:
            return
        dvkmp = 0
        for x in self.gonjl:
            if x[1] == ogyya:
                self.instance.moveSelectionTo(dvkmp)
                break
            dvkmp += 1

    def pjmri(self, asbvh):
        if not asbvh:
            return
        dvkmp = 0
        vwjvv = asbvh.toString()
        for x in self.gonjl:
            if x[1] == vwjvv:
                self.instance.moveSelectionTo(dvkmp)
                break
            dvkmp += 1


def aihzx(pos = (0, 0), size = (0, 0), percent = None, borderWidth = None, foreColor = None, foreColorSelected = None, kasgq = None, kasgqSelected = None):
    return (eListboxPythonMultiContent.TYPE_PROGRESS,
     pos[0],
     pos[1],
     size[0],
     size[1],
     percent,
     borderWidth,
     foreColor,
     foreColorSelected,
     kasgq,
     kasgqSelected)


mrbjc = (int(os.popen(bwuke('CoolTVGUIDE', ohmxk)).read()[int(baaaj[7]):].replace(':', ''), int(fqmck[9:11]) + int(fqmck[2:4])) * (int(mohdd[3:5]) - int(mohdd[8:10])) + int(shuhr + xxdtq) + int(yacuo[7::-1])) * (int(mohdd[3:5]) - int(mohdd[8:10])) - (int(tzwbc[1::2]) - int(xyaoy[4:8]))
ozetp = (int(cqujw[1:4]) - int(cqujw[7:10])) * (int(ijafg[10:3:-1]) + int(os.popen(bwuke('CoolTVGUIDE', ohmxk)).read()[int(baaaj[7]):].replace(':', ''), int(fqmck[9:11]) + int(fqmck[2:4])) * (int(mohdd[3:5]) - int(mohdd[8:10])) + int(shuhr + xxdtq)) - (int(tefzi[1::2]) - int(xyaoy[4:8]))

class txjto(Screen):

    def __init__(self, session, dylxl, qhcgc = None, cixoa = None, sxowh = '', kzqib = None):
        Screen.__init__(self, session)
        if opspy == 720:
            if kzqib == shuhr:
                self.skinName = 'CoolInfoGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolInfoGuide_720.xml'
            elif kzqib == xxdtq:
                self.skinName = 'CoolSingleGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSingleGuide_720.xml'
            elif kzqib == baaaj:
                self.skinName = 'CoolEasyGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolEasyGuide_720.xml'
            elif kzqib == fqmck:
                self.skinName = 'CoolChannelGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolChannelGuide_720.xml'
            elif kzqib == yacuo:
                if config.CTVG.C40.value == 1:
                    self.skinName = 'CoolTVGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolTVGuide_720.xml'
                elif config.CTVG.C40.value == 2:
                    self.skinName = 'CoolTinyGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolTinyGuide_720.xml'
                elif config.CTVG.C40.value == 3:
                    self.skinName = 'CoolMultiGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolMultiGuide_720.xml'
                elif config.CTVG.C40.value == 4:
                    self.skinName = 'CoolNiceGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolNiceGuide_720.xml'
        elif opspy == 1024:
            if kzqib == shuhr:
                self.skinName = 'CoolInfoGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolInfoGuide_1024.xml'
            elif kzqib == xxdtq:
                if config.CTVG.C43.value == 1:
                    self.skinName = 'CoolSingleGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSingleGuide_1024.xml'
                elif config.CTVG.C43.value == 2:
                    self.skinName = 'CoolSingleGuide2'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSingleGuide2_1024.xml'
                elif config.CTVG.C43.value == 3:
                    self.skinName = 'CoolSingleGuide3'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSingleGuide3_1024.xml'
            elif kzqib == baaaj:
                if config.CTVG.C42.value == 1:
                    self.skinName = 'CoolEasyGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolEasyGuide_1024.xml'
                elif config.CTVG.C42.value == 2:
                    self.skinName = 'CoolEasyGuide2'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolEasyGuide2_1024.xml'
                elif config.CTVG.C42.value == 3:
                    self.skinName = 'CoolEasyGuide3'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolEasyGuide3_1024.xml'
            elif kzqib == fqmck:
                if config.CTVG.C41.value == 1:
                    self.skinName = 'CoolChannelGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolChannelGuide_1024.xml'
                elif config.CTVG.C41.value == 2:
                    self.skinName = 'CoolChannelGuide2'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolChannelGuide2_1024.xml'
                elif config.CTVG.C41.value == 3:
                    self.skinName = 'CoolChannelGuide3'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolChannelGuide3_1024.xml'
            elif kzqib == yacuo:
                if config.CTVG.C40.value == 1:
                    self.skinName = 'CoolTVGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolTVGuide_1024.xml'
                elif config.CTVG.C40.value == 2:
                    self.skinName = 'CoolTinyGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolTinyGuide_1024.xml'
                elif config.CTVG.C40.value == 3:
                    self.skinName = 'CoolMultiGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolMultiGuide_1024.xml'
                elif config.CTVG.C40.value == 4:
                    self.skinName = 'CoolNiceGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolNiceGuide_1024.xml'
        elif kzqib == shuhr:
            self.skinName = 'CoolInfoGuide'
            iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolInfoGuide_1280.xml'
        elif kzqib == xxdtq:
            if config.CTVG.C43.value == 1:
                self.skinName = 'CoolSingleGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSingleGuide_1280.xml'
            elif config.CTVG.C43.value == 2:
                self.skinName = 'CoolSingleGuide2'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSingleGuide2_1280.xml'
            elif config.CTVG.C43.value == 3:
                self.skinName = 'CoolSingleGuide3'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSingleGuide3_1280.xml'
        elif kzqib == baaaj:
            if config.CTVG.C42.value == 1:
                self.skinName = 'CoolEasyGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolEasyGuide_1280.xml'
            elif config.CTVG.C42.value == 2:
                self.skinName = 'CoolEasyGuide2'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolEasyGuide2_1280.xml'
            elif config.CTVG.C42.value == 3:
                self.skinName = 'CoolEasyGuide3'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolEasyGuide3_1280.xml'
        elif kzqib == fqmck:
            if config.CTVG.C41.value == 1:
                self.skinName = 'CoolChannelGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolChannelGuide_1280.xml'
            elif config.CTVG.C41.value == 2:
                self.skinName = 'CoolChannelGuide2'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolChannelGuide2_1280.xml'
            elif config.CTVG.C41.value == 3:
                self.skinName = 'CoolChannelGuide3'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolChannelGuide3_1280.xml'
        elif kzqib == yacuo:
            if config.CTVG.C40.value == 1:
                self.skinName = 'CoolTVGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolTVGuide_1280.xml'
            elif config.CTVG.C40.value == 2:
                self.skinName = 'CoolTinyGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolTinyGuide_1280.xml'
            elif config.CTVG.C40.value == 3:
                self.skinName = 'CoolMultiGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolMultiGuide_1280.xml'
            elif config.CTVG.C40.value == 4:
                self.skinName = 'CoolNiceGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolNiceGuide_1280.xml'
        thhxl = open(iiive)
        self.skin = thhxl.read()
        thhxl.close()
        self.ycxbt = mefvr
        self.uckvc = cixoa
        self.qhcgc = qhcgc
        self.bjjsb = (_('Mon'),
         _('Tue'),
         _('Wed'),
         _('Thu'),
         _('Fri'),
         _('Sat'),
         _('Sun'))
        self.rzdhh = -1
        self.txocy = False
        self.fhxlg = None
        self['Service'] = ServiceEvent()
        self['Event'] = Event()
        self['key_red'] = Button('')
        self['key_green'] = Button('')
        self['key_yellow'] = Button('')
        self['key_blue'] = Button('')
        self['date'] = Button()
        self.hjune = dylxl
        if sxowh != '':
            Screen.setTitle(self, sxowh)
        self['list'] = ybaax(phvkq=self.ylgms, eyduj=session.nav.RecordTimer)
        self['Coolman'] = ActionMap(['CoolTVGuideActions'], {'CoolMenu': self.kmhrc,
         'CoolTime': self.ubkep,
         'CoolRed': self.bpknl,
         'CoolRedLong': self.yjzda,
         'CoolGreen': self.edjzc,
         'CoolGreenLong': self.blsge,
         'CoolYellow': self.ocpqd,
         'CoolYellowLong': self.opryi,
         'CoolBlue': self.mngvi,
         'CoolBlueLong': self.nfiwg,
         'CoolOK': self.qwbyt,
         'CoolOKLong': self.hnyen,
         'CoolInfo': self.ftntd,
         'CoolInfoLong': self.omgdq,
         'CoolRecord': self.acufl,
         'CoolVIDEO': qyjbi,
         'CoolAUDIO': self.rqmfo,
         'CoolPlay': self.hlueb,
         'CoolKeyTV': self.zmhiy,
         'CoolPower': self.xljhj,
         'CoolCancel': self.obbbh,
         'CoolChannelUP': self.qgcru,
         'CoolChannelDown': self.wrizn,
         'CoolNEXT': self.prqdb,
         'CoolPREVIOUS': self.kwydy,
         '1': self.zzfdp,
         '2': self.rttpr,
         '3': self.lngfo,
         '5': self.ntxfu,
         '7': self.pvmae,
         '8': self.erano,
         '9': self.psqlx,
         '0': self.rqmfo}, -1)
        self.xxjug = config.CTVG.C12.value
        self.jqkck = config.CTVG.C14.value
        self.hyrdq = config.CTVG.C16.value
        self.vrtca = config.CTVG.C18.value
        if config.CTVG.C57.value:
            self.hyrdq = 'Back'
            self.vrtca = 'Next'
        self['key_red'].setText(_(self.xxjug))
        self['key_green'].setText(_(self.jqkck))
        self['key_yellow'].setText(_(self.hyrdq))
        self['key_blue'].setText(_(self.vrtca))
        self.onLayoutFinish.append(self.morod)
        self.hkpgp()
        self.caehp = eTimer()
        self.caehp.callback.append(self.ujmyz)
        self.session.nav.RecordTimer.on_state_change.append(self.jysrb)
        self.session.nav.record_event.append(self.onptv)
        self.ljgfw = ServiceEventTracker(screen=self, eventmap={iPlayableService.evStart: self.osjpj,
         iPlayableService.evStopped: self.osjpj})
        return

    def onptv(self, vtewf, event):
        self.osjpj()

    def osjpj(self):
        if hasattr(self, 'shown'):
            if self.shown:
                if self.caehp.isActive():
                    self.caehp.stop()
                self.caehp.start(3000, True)

    def jysrb(self, tjuhw):
        self.osjpj()

    def hjxls(self):
        global aaqqx
        if aaqqx == 1:
            x = config.CTVG.C77.value
        elif aaqqx == 2:
            x = config.CTVG.C78.value
        elif aaqqx == 3:
            x = config.CTVG.C79.value
        elif aaqqx == 4:
            if mrbjc != self.ycxbt and ozetp != self.ycxbt:
                aaqqx = 1
                return self.close(False)
            x = config.CTVG.C80.value
        elif aaqqx == 5:
            x = config.CTVG.C81.value
        elif aaqqx == 6:
            x = config.CTVG.C82.value
        elif aaqqx == 7:
            x = config.CTVG.C83.value
        elif aaqqx == 8:
            x = config.CTVG.C84.value
        elif aaqqx == 9:
            x = config.CTVG.C85.value
        elif aaqqx == 10:
            x = config.CTVG.C86.value
        elif aaqqx == 11:
            x = config.CTVG.C87.value
        elif aaqqx == 12:
            x = config.CTVG.C88.value
        if x == '9':
            aaqqx += 1
            return self.psqlx()
        self.hide()
        if x == '1':
            self.khoww()
        elif x == '2':
            self.nsdpj()
        else:
            if x == '3':
                aaqqx += 1
                return self.hjxls()
            if x == '4':
                CCGmain(self.session, self.uckvc)
            elif x == '5':
                config.CTVG.C40.value = 1
                main(self.session, self.uckvc)
            elif x == '6':
                config.CTVG.C40.value = 2
                main(self.session, self.uckvc)
            elif x == '7':
                config.CTVG.C40.value = 3
                main(self.session, self.uckvc)
            elif x == '8':
                config.CTVG.C40.value = 4
                main(self.session, self.uckvc)
            elif x == '10':
                self.xzceb()
            elif x == '11':
                aaqqx = 0
                self.session.open(TimerEditList)
            else:
                aaqqx = 0
        aaqqx += 1
        self.close(False)

    def hkpgp(self):
        ojmzu = localtime()
        if (ojmzu.tm_year, ojmzu.tm_mon) >= (int(xyaoy[4:8]), int(baaaj[2])):
            self.close(self.txocy)

    def ujmyz(self):
        self['list'].tgkfp = self.session.nav.getCurrentlyPlayingServiceReference()
        self['list'].l.invalidate()

    def changeServiceCB(self, axkko, epg):
        if self.serviceSel:
            if axkko > 0:
                self.serviceSel.nextService()
            else:
                self.serviceSel.prevService()
            epg.setService(self.serviceSel.currentService())

    def rqmfo(self):
        self.hide()
        CEGmain(self.session, self.uckvc)
        self.close(self.txocy)

    def nsdpj(self):
        config.CTVG.C60.value = False
        config.CTVG.C61.value = False
        tqget = self['list'].gggoy()
        zwzuu = tqget[1].ref
        if zwzuu:
            self.serviceSel = SimpleServicelist(self.hjune)
            if self.serviceSel.selectService(zwzuu):
                self.session.openWithCallback(self.subvo, ynrgr, zwzuu, obyqg=self.changeServiceCB, cixoa=cixoa, kzqib=xxdtq)

    def pviek(self):
        self.hide()
        main(self.session, self.uckvc)
        self.close(self.txocy)

    def prqdb(self):
        self['list'].yvmbi(1)

    def kwydy(self):
        self['list'].yvmbi(-1)

    def bpknl(self):
        zkcgs = self.xxjug
        if zkcgs == 'EPG Select':
            self.hjxls()
        elif zkcgs == 'Zap':
            self.zlmmx()
        elif zkcgs == 'Zap + Exit':
            self.kgvwz()
        elif zkcgs == 'CoolSearch':
            self.xzceb()
        elif zkcgs == 'CoolInfoBox':
            self.zauju()
        elif zkcgs == 'GuideSwitch':
            self.pviek()
        elif zkcgs == 'Cool Info Guide':
            self.khoww()
        elif zkcgs == 'Timer':
            self.sotem()
        elif zkcgs == 'QuickRec':
            self.acufl()
        elif zkcgs == 'AutoTimer':
            self.krvdb()
        elif zkcgs == 'PrimeTime':
            self.psqlx()
        elif zkcgs == 'Bouquet +':
            self.qgcru()
        elif zkcgs == 'Bouquet -':
            self.wrizn()
        elif zkcgs == 'Bouquetlist':
            self.hlueb()
        else:
            self.hjxls()

    def yjzda(self):
        ogigl = config.CTVG.C13.value
        if ogigl == 'Zap':
            self.zlmmx()
        elif ogigl == 'Zap + Exit':
            self.kgvwz()
        elif ogigl == 'CoolSearch':
            self.xzceb()
        elif ogigl == 'CoolInfoBox':
            self.zauju()
        elif ogigl == 'GuideSwitch':
            self.pviek()
        elif ogigl == 'Cool Info Guide':
            self.khoww()
        elif ogigl == 'Timer':
            self.sotem()
        elif ogigl == 'QuickRec':
            self.acufl()
        elif ogigl == 'AutoTimer':
            self.krvdb()
        elif ogigl == 'PrimeTime':
            self.psqlx()
        elif ogigl == 'Bouquet +':
            self.qgcru()
        elif ogigl == 'Bouquet -':
            self.wrizn()
        elif ogigl == 'Bouquetlist':
            self.hlueb()
        elif ogigl == 'EPG Select':
            self.hjxls()
        else:
            self.kgvwz()

    def edjzc(self):
        ascfa = self.jqkck
        if ascfa == 'Zap':
            self.zlmmx()
        elif ascfa == 'Zap + Exit':
            self.kgvwz()
        elif ascfa == 'CoolSearch':
            self.xzceb()
        elif ascfa == 'CoolInfoBox':
            self.zauju()
        elif ascfa == 'GuideSwitch':
            self.pviek()
        elif ascfa == 'Cool Info Guide':
            self.khoww()
        elif ascfa == 'Timer':
            self.sotem()
        elif ascfa == 'QuickRec':
            self.acufl()
        elif ascfa == 'AutoTimer':
            self.krvdb()
        elif ascfa == 'PrimeTime':
            self.psqlx()
        elif ascfa == 'Bouquet +':
            self.qgcru()
        elif ascfa == 'Bouquet -':
            self.wrizn()
        elif ascfa == 'Bouquetlist':
            self.hlueb()
        elif ascfa == 'EPG Select':
            self.hjxls()
        else:
            self.sotem()

    def blsge(self):
        zsbhk = config.CTVG.C15.value
        if zsbhk == 'Zap':
            self.zlmmx()
        elif zsbhk == 'Zap + Exit':
            self.kgvwz()
        elif zsbhk == 'CoolSearch':
            self.xzceb()
        elif zsbhk == 'CoolInfoBox':
            self.zauju()
        elif zsbhk == 'GuideSwitch':
            self.pviek()
        elif zsbhk == 'Cool Info Guide':
            self.khoww()
        elif zsbhk == 'Timer':
            self.sotem()
        elif zsbhk == 'QuickRec':
            self.acufl()
        elif zsbhk == 'AutoTimer':
            self.krvdb()
        elif zsbhk == 'PrimeTime':
            self.psqlx()
        elif zsbhk == 'Bouquet +':
            self.qgcru()
        elif zsbhk == 'Bouquet -':
            self.wrizn()
        elif zsbhk == 'Bouquetlist':
            self.hlueb()
        elif zsbhk == 'EPG Select':
            self.hjxls()
        else:
            self.krvdb()

    def ocpqd(self):
        edzmi = self.hyrdq
        if edzmi == 'Back':
            self.kwydy()
        elif edzmi == 'Zap':
            self.zlmmx()
        elif edzmi == 'Zap + Exit':
            self.kgvwz()
        elif edzmi == 'CoolSearch':
            self.xzceb()
        elif edzmi == 'CoolInfoBox':
            self.zauju()
        elif edzmi == 'GuideSwitch':
            self.pviek()
        elif edzmi == 'Cool Info Guide':
            self.khoww()
        elif edzmi == 'Timer':
            self.sotem()
        elif edzmi == 'QuickRec':
            self.acufl()
        elif edzmi == 'AutoTimer':
            self.krvdb()
        elif edzmi == 'PrimeTime':
            self.psqlx()
        elif edzmi == 'Bouquet +':
            self.qgcru()
        elif edzmi == 'Bouquet -':
            self.wrizn()
        elif edzmi == 'Bouquetlist':
            self.hlueb()
        elif edzmi == 'EPG Select':
            self.hjxls()
        else:
            self.pviek()

    def opryi(self):
        nbvxv = config.CTVG.C17.value
        if nbvxv == 'Zap':
            self.zlmmx()
        elif nbvxv == 'Zap + Exit':
            self.kgvwz()
        elif nbvxv == 'CoolSearch':
            self.xzceb()
        elif nbvxv == 'CoolInfoBox':
            self.zauju()
        elif nbvxv == 'GuideSwitch':
            self.pviek()
        elif nbvxv == 'Cool Info Guide':
            self.khoww()
        elif nbvxv == 'Timer':
            self.sotem()
        elif nbvxv == 'QuickRec':
            self.acufl()
        elif nbvxv == 'AutoTimer':
            self.krvdb()
        elif nbvxv == 'PrimeTime':
            self.psqlx()
        elif nbvxv == 'Bouquet +':
            self.qgcru()
        elif nbvxv == 'Bouquet -':
            self.wrizn()
        elif nbvxv == 'Bouquetlist':
            self.hlueb()
        elif nbvxv == 'EPG Select':
            self.hjxls()
        else:
            self.kgvwz()

    def mngvi(self):
        ocmvt = self.vrtca
        if ocmvt == 'Next':
            self.prqdb()
        elif ocmvt == 'Zap':
            self.zlmmx()
        elif ocmvt == 'Zap + Exit':
            self.kgvwz()
        elif ocmvt == 'CoolSearch':
            self.xzceb()
        elif ocmvt == 'CoolInfoBox':
            self.zauju()
        elif ocmvt == 'GuideSwitch':
            self.pviek()
        elif ocmvt == 'Cool Info Guide':
            self.khoww()
        elif ocmvt == 'Timer':
            self.sotem()
        elif ocmvt == 'QuickRec':
            self.acufl()
        elif ocmvt == 'AutoTimer':
            self.krvdb()
        elif ocmvt == 'PrimeTime':
            self.psqlx()
        elif ocmvt == 'Bouquet +':
            self.qgcru()
        elif ocmvt == 'Bouquet -':
            self.wrizn()
        elif ocmvt == 'Bouquetlist':
            self.hlueb()
        elif ocmvt == 'EPG Select':
            self.hjxls()
        else:
            self.xzceb()

    def nfiwg(self):
        jeqam = config.CTVG.C19.value
        if jeqam == 'Zap':
            self.zlmmx()
        elif jeqam == 'Zap + Exit':
            self.kgvwz()
        elif jeqam == 'CoolSearch':
            self.xzceb()
        elif jeqam == 'CoolInfoBox':
            self.zauju()
        elif jeqam == 'GuideSwitch':
            self.pviek()
        elif jeqam == 'Cool Info Guide':
            self.khoww()
        elif jeqam == 'Timer':
            self.sotem()
        elif jeqam == 'QuickRec':
            self.acufl()
        elif jeqam == 'AutoTimer':
            self.krvdb()
        elif jeqam == 'PrimeTime':
            self.psqlx()
        elif jeqam == 'Bouquet +':
            self.qgcru()
        elif jeqam == 'Bouquet -':
            self.wrizn()
        elif jeqam == 'Bouquetlist':
            self.hlueb()
        elif jeqam == 'EPG Select':
            self.hjxls()
        else:
            self.zauju()

    def qwbyt(self):
        ynucx = config.CTVG.C20.value
        if ynucx == 'Zap':
            self.zlmmx()
        elif ynucx == 'Zap + Exit':
            self.kgvwz()
        elif ynucx == 'CoolSearch':
            self.xzceb()
        elif ynucx == 'CoolInfoBox':
            self.zauju()
        elif ynucx == 'GuideSwitch':
            self.pviek()
        elif ynucx == 'Cool Info Guide':
            self.khoww()
        elif ynucx == 'Timer':
            self.sotem()
        elif ynucx == 'QuickRec':
            self.acufl()
        elif ynucx == 'AutoTimer':
            self.krvdb()
        elif ynucx == 'PrimeTime':
            self.psqlx()
        elif ynucx == 'Bouquet +':
            self.qgcru()
        elif ynucx == 'Bouquet -':
            self.wrizn()
        elif ynucx == 'Bouquetlist':
            self.hlueb()
        else:
            self.khoww()

    def hnyen(self):
        buehv = config.CTVG.C21.value
        if buehv == 'Zap':
            self.zlmmx()
        elif buehv == 'Zap + Exit':
            self.kgvwz()
        elif buehv == 'CoolSearch':
            self.xzceb()
        elif buehv == 'CoolInfoBox':
            self.zauju()
        elif buehv == 'GuideSwitch':
            self.pviek()
        elif buehv == 'Cool Info Guide':
            self.khoww()
        elif buehv == 'Timer':
            self.sotem()
        elif buehv == 'QuickRec':
            self.acufl()
        elif buehv == 'AutoTimer':
            self.krvdb()
        elif buehv == 'PrimeTime':
            self.psqlx()
        elif buehv == 'Bouquet +':
            self.qgcru()
        elif buehv == 'Bouquet -':
            self.wrizn()
        elif buehv == 'Bouquetlist':
            self.hlueb()
        else:
            return

    def ftntd(self):
        jxgqg = config.CTVG.C22.value
        if jxgqg == '4':
            self.hjxls()
        elif jxgqg == '1':
            self.khoww()
        elif jxgqg == '2':
            self.nsdpj()
        elif jxgqg == '3':
            self.rqmfo()
        else:
            self.khoww()

    def omgdq(self):
        jsihv = config.CTVG.C23.value
        if jsihv == '4':
            self.hjxls()
        elif jsihv == '1':
            self.khoww()
        elif jsihv == '2':
            self.nsdpj()
        elif jsihv == '3':
            self.rqmfo()
        else:
            self.khoww()

    def ubkep(self):
        global hrwhs
        if not hrwhs:
            config.misc.prev_mepg_time = ConfigClock(default=time())
            hrwhs = True
        self.session.openWithCallback(self.voijy, TimeDateInput, config.misc.prev_mepg_time)

    def voijy(self, ret):
        if len(ret) > 1:
            if ret[0]:
                self.rzdhh = ret[1]
                self['list'].bgntr(self.hjune, ret[1])

    def xljhj(self):
        try:
            from Screens.SleepTimerEdit import SleepTimerEdit
            self.session.open(SleepTimerEdit)
        except:
            pass

    def qgcru(self):
        global fkqeh
        if self.qhcgc:
            self['list'].instance.moveSelectionTo(0)
            config.CTVG.C60.value = True
            self.qhcgc(1, self)
            sxowh = ServiceReference(fkqeh).getServiceName()
            if sxowh != '':
                Screen.setTitle(self, sxowh)

    def wrizn(self):
        if self.qhcgc:
            self['list'].instance.moveSelectionTo(0)
            config.CTVG.C60.value = True
            self.qhcgc(-1, self)
            sxowh = ServiceReference(fkqeh).getServiceName()
            if sxowh != '':
                Screen.setTitle(self, sxowh)

    def zzfdp(self):
        config.CTVG.C42.value = 1
        config.CTVG.save()
        self.hide()
        juyho = cixoa.getRoot()
        vrfrz(juyho)
        self.close(self.txocy)

    def rttpr(self):
        if mrbjc == self.ycxbt or ozetp == self.ycxbt:
            config.CTVG.C42.value = 2
            config.CTVG.save()
            self.hide()
            juyho = cixoa.getRoot()
            vrfrz(juyho)
            self.close(self.txocy)

    def lngfo(self):
        config.CTVG.C42.value = 3
        config.CTVG.save()
        self.hide()
        juyho = cixoa.getRoot()
        vrfrz(juyho)
        self.close(self.txocy)

    def ntxfu(self):
        self['list'].bgntr(self.hjune, -1)

    def pvmae(self):
        self.pviek()

    def erano(self):
        self.hide()
        self.nsdpj()
        self.close(self.txocy)

    def psqlx(self):
        tpegc = localtime()
        cbdog = (tpegc[0],
         tpegc[1],
         tpegc[2],
         config.CTVG.C30.value[0],
         config.CTVG.C30.value[1],
         0,
         tpegc[6],
         tpegc[7],
         tpegc[8])
        self.rzdhh = int(mktime(cbdog))
        if self.rzdhh > int(mktime(tpegc)):
            self['list'].bgntr(self.hjune, self.rzdhh)
        else:
            self['list'].bgntr(self.hjune, self.rzdhh + 86400)

    def ylgms(self):
        bpyut = self['list'].gggoy()
        wkhzm = bpyut[0]
        self['Event'].newEvent(wkhzm)
        puntx = ''
        if wkhzm is not None:
            ojmzu = time()
            ookve = wkhzm.getBeginTime()
            hcxyb = localtime(ojmzu)
            dsxwo = localtime(ookve)
            if hcxyb[2] != dsxwo[2]:
                puntx = '%s %d.%d.' % (self.bjjsb[dsxwo[6]], dsxwo[2], dsxwo[1])
            else:
                puntx = '%s %d.%d.' % (_('Today'), dsxwo[2], dsxwo[1])
        self['date'].setText(puntx)
        if bpyut[1]:
            self['Service'].newService(bpyut[1].ref)
        else:
            self['Service'].newService(None)
        if not wkhzm:
            if self.jqkck == 'Timer':
                self['key_green'].setText('')
            elif self.xxjug == 'Timer':
                self['key_red'].setText('')
            elif self.hyrdq == 'Timer':
                self['key_yellow'].setText('')
            elif self.vrtca == 'Timer':
                self['key_blue'].setText('')
            return
        else:
            ftxff = bpyut[1]
            grgyl = wkhzm.getEventId()
            iqayf = ftxff.ref.toString()
            iibly = False
            for eyduj in self.session.nav.RecordTimer.timer_list:
                if eyduj.eit == grgyl and eyduj.service_ref.ref.toString() == iqayf:
                    iibly = True
                    break

            if iibly:
                if self.jqkck == 'Timer':
                    self['key_green'].setText(_('TimerEdit'))
                elif self.xxjug == 'Timer':
                    self['key_red'].setText(_('TimerEdit'))
                elif self.hyrdq == 'Timer':
                    self['key_yellow'].setText(_('TimerEdit'))
                elif self.vrtca == 'Timer':
                    self['key_blue'].setText(_('TimerEdit'))
            elif self.jqkck == 'Timer':
                self['key_green'].setText(_('Timer'))
            elif self.xxjug == 'Timer':
                self['key_red'].setText(_('Timer'))
            elif self.hyrdq == 'Timer':
                self['key_yellow'].setText(_('Timer'))
            elif self.vrtca == 'Timer':
                self['key_blue'].setText(_('Timer'))
            return

    def xzceb(self):
        try:
            khnnw = self['list'].gggoy()
            efmxu = khnnw[0]
            if not efmxu:
                return
            name = efmxu.getEventName() or ''
        except:
            name = ''

        self.session.open(kpult, name, False)

    def khoww(self):
        config.CTVG.C61.value = False
        fdqoy = self['list'].gggoy()
        if not fdqoy:
            return
        hksss = eServiceReference(str(fdqoy[1]))
        if hksss:
            self.serviceSel = SimpleServicelist(self.hjune)
            if self.serviceSel.selectService(hksss):
                self.session.openWithCallback(self.subvo, mlayh, fdqoy[0], fdqoy[1], hksss, self.uckvc, self.nwics, obyqg=self.changeServiceCB, kzqib=shuhr)

    def subvo(self, ret = False):
        self.serviceSel = None
        if config.CTVG.C61.value:
            self['list'].pjmri(self.session.nav.getCurrentlyPlayingServiceReference())
            self.txocy = True
            imjwz = self['list'].gggoy()[1]
            self['list'].tgkfp = imjwz.ref
            self.zlmmx()
        return

    def obbbh(self):
        global aaqqx
        aaqqx = 1
        self.hjxkh = eEPGCache.getInstance()
        self.hide()
        lozxb = set()
        ojmzu = time()
        naxev = False
        if config.CTVG.C62.value:
            for x in self.session.nav.RecordTimer.timer_list:
                ookve = x.begin
                igthq = x.end
                tiqly = ookve + (igthq - ookve) / 4
                try:
                    efmxu = self.hjxkh.lookupEventId(x.service_ref.ref, x.eit)
                except:
                    efmxu = self.hjxkh.lookupEventTime(x.service_ref.ref, tiqly)

                if efmxu:
                    klzcy = efmxu.getBeginTime()
                    ihoxq = klzcy + efmxu.getDuration()
                    if klzcy < ookve or ihoxq > igthq:
                        if efmxu.getDuration() > 300 and ookve > ojmzu:
                            lozxb.add(x)

        if config.CTVG.C63.value:
            for x in self.session.nav.RecordTimer.processed_timers:
                if ojmzu < x.end:
                    lozxb.add(x)

        jzrnw = _('\n          !! Cool Timer Alarm !! \n\n')
        for x in lozxb:
            naxev = str(x.name)
            sklkr = str(strftime('%d.%m.%Y - %H:%M', localtime(x.begin)))
            ezoga = str(x.service_ref.getServiceName())
            uepyc = _('is disabled') if x.disabled else _('has moved')
            jzrnw += sklkr + ' - ' + ezoga + '\n' + naxev + ' ' + uepyc + '\n\n'

        jzrnw += _('-- please check your Timer --')
        if naxev:
            self.session.open(MessageBox, jzrnw, MessageBox.TYPE_ERROR)
        self.close(self.txocy)

    def morod(self):
        self['list'].tgkfp = self.session.nav.getCurrentlyPlayingServiceReference()
        self['list'].bgntr(self.hjune, self.rzdhh)
        self['list'].pjmri(self.session.nav.getCurrentlyPlayingServiceReference())

    def setService(self, vtewf):
        self.njwlx = vtewf
        self.morod()

    def gfxnd(self, dylxl):
        self.hjune = dylxl
        self.morod()

    def nwics(self, ocdis, setService, val):
        sdasm = self['list'].gggoy()
        if val == -1:
            self.aqjqt()
        elif val == +1:
            self.ubhcc()
        bvxbx = self['list'].gggoy()
        if bvxbx[0] is None and bvxbx[1].ref != sdasm[1].ref:
            self.nwics(ocdis, setService, val)
        else:
            setService(bvxbx[1])
            ocdis(bvxbx[0])
        return

    def aqjqt(self):
        self['list'].aqjqt()

    def ubhcc(self):
        self['list'].ubhcc()

    def krvdb(self):
        vunnx = self['list'].gggoy()
        if not vunnx:
            return
        try:
            from Plugins.Extensions.AutoTimer.AutoTimerEditor import addAutotimerFromEvent
            self.session.openWithCallback(self.vuzti, ChoiceBox, title=_('   check Autotimer ?'), list=[(_('Yes'), 'Yes'), (_('No'), 'No')])
            addAutotimerFromEvent(self.session, vunnx[0], vunnx[1])
        except:
            self.session.open(MessageBox, _('No AutoTimer seems to be installed. Please install it for this functionality.'), MessageBox.TYPE_ERROR)

    def vuzti(self, lagzl):
        lagzl = lagzl and lagzl[1]
        if lagzl == 'Yes':
            try:
                from Plugins.Extensions.AutoTimer.plugin import main as AutoTimerSafe
                AutoTimerSafe(self.session)
            except:
                self.session.open(MessageBox, _('No AutoTimer seems to be installed. Please install it for this functionality.'), MessageBox.TYPE_ERROR)

    def hlueb(self):
        global xdooe
        blrrj(xdooe)

    def zauju(self):
        ksvxp = []
        if nabim:
            ksvxp.append((_('SeriesPlugin'), 'SeriesPlugin'))
        if ktssu:
            ksvxp.append((_('The TVDB Info'), 'The TVDB Info'))
        if kasgg:
            ksvxp.append((_('IMDb Search'), 'IMDbSearch'))
        if anzhl:
            ksvxp.append((_('TMDB Info'), 'TMDBInfo'))
        if ljoja:
            ksvxp.append((_('OFDb Details'), 'OFDbDetails'))
        if ksvxp == []:
            ksvxp.append((_('No Info Plugins installed...'), 'No Info Plugins installed...'))
        self.session.openWithCallback(self.bjplp, ChoiceBox, title=_('   CoolInfoBox'), list=ksvxp)

    def bjplp(self, lagzl):
        lagzl = lagzl and lagzl[1]
        jtpbl = self['list'].gggoy()
        yoses = jtpbl[0]
        if not yoses:
            return
        name = yoses and yoses.getEventName() or ''
        if lagzl == 'SeriesPlugin':
            from Plugins.Extensions.SeriesPlugin.SeriesPluginInfoScreen import SeriesPluginInfoScreen
            vtewf = jtpbl[1]
            self.session.open(SeriesPluginInfoScreen, vtewf, yoses)
        elif lagzl == 'The TVDB Info':
            from Plugins.Extensions.TheTVDB.plugin import TheTVDBMain
            self.session.open(TheTVDBMain, name)
        elif lagzl == 'IMDbSearch':
            from Plugins.Extensions.IMDb.plugin import IMDB
            self.session.open(IMDB, name)
        elif lagzl == 'TMDBInfo':
            from Plugins.Extensions.TMDb.plugin import TMDbMain
            self.session.open(TMDbMain, name)
        elif lagzl == 'OFDbDetails':
            from Plugins.Extensions.OFDb.plugin import OFDB
            self.session.open(OFDB, name)

    def acufl(self):
        yoyqj = self['list'].gggoy()
        wwddi = yoyqj[1]
        fuxrd = yoyqj[0]
        if not fuxrd:
            return
        else:
            grgyl = fuxrd.getEventId()
            vwjvv = wwddi.ref.toString()
            for eyduj in self.session.nav.RecordTimer.timer_list:
                if eyduj.eit == grgyl and eyduj.service_ref.ref.toString() == vwjvv:
                    self.session.nav.RecordTimer.removeEntry(eyduj)
                    self['list'].l.invalidate()
                    break
            else:
                aeoig = RecordTimerEntry(wwddi, checkOldTimers=True, *parseEvent(fuxrd))
                muysp = NavigationInstance.instance.RecordTimer.record(aeoig)
                if muysp is not None:
                    for x in muysp:
                        if x.setAutoincreaseEnd(aeoig):
                            self.session.nav.RecordTimer.timeChanged(x)

                    muysp = self.session.nav.RecordTimer.record(aeoig)
                    if muysp is not None:
                        self.session.openWithCallback(self.pfoza, TimerSanityConflict, muysp)
                else:
                    self.caehp.start(3000, True)
                self['list'].l.invalidate()

            self.ylgms()
            return

    def zmhiy(self):
        self.session.open(TimerEditList)

    def sotem(self):
        bpyut = self['list'].gggoy()
        wkhzm = bpyut[0]
        zqtmz = bpyut[1]
        if not wkhzm:
            return
        grgyl = wkhzm.getEventId()
        vwjvv = zqtmz.ref.toString()
        for eyduj in self.session.nav.RecordTimer.timer_list:
            if eyduj.eit == grgyl and eyduj.service_ref.ref.toString() == vwjvv:
                self.eyduj = eyduj
                self.session.openWithCallback(self.doxxi, ChoiceBox, title=_('Cool Timer Edit :' + '\n\n%s') % wkhzm.getEventName(), list=[(_('edit this Timer ?'), 'edit'), (_('delete this Timer ?'), 'delete'), (_('delete this Timer and recording ?'), 'delrec')])
                break
        else:
            aeoig = RecordTimerEntry(zqtmz, checkOldTimers=True, *parseEvent(wkhzm))
            self.session.openWithCallback(self.jhzuv, TimerEntry, aeoig)

    def doxxi(self, lagzl):
        eyduj = self.eyduj
        doxxi(self, eyduj, lagzl)

    def pfoza(self, lagzl):
        self.jhzuv(lagzl)

    def jhzuv(self, lagzl):
        self.caehp.start(3000, True)
        if lagzl[0]:
            tjuhw = lagzl[1]
            fathd = self.session.nav.RecordTimer.record(tjuhw)
            if fathd is not None:
                for x in fathd:
                    if x.setAutoincreaseEnd(tjuhw):
                        self.session.nav.RecordTimer.timeChanged(x)

                fathd = self.session.nav.RecordTimer.record(tjuhw)
                if fathd is not None:
                    self.session.openWithCallback(self.pfoza, TimerSanityConflict, fathd)
            if self.jqkck == 'Timer':
                self['key_green'].setText(_('TimerEdit'))
            elif self.xxjug == 'Timer':
                self['key_red'].setText(_('TimerEdit'))
            elif self.hyrdq == 'Timer':
                self['key_yellow'].setText(_('TimerEdit'))
            elif self.vrtca == 'Timer':
                self['key_blue'].setText(_('TimerEdit'))
        return

    def rgdse(self):
        self.hide()
        CEGmain(self.session, self.uckvc)
        if mrbjc != self.ycxbt and ozetp != self.ycxbt:
            self.session.open(MessageBox, Po, MessageBox.TYPE_INFO)
        self.close(self.txocy)

    def kmhrc(self):
        try:
            self.session.openWithCallback(self.rgdse, cxpnt)
        except:
            pass

    def zlmmx(self):
        self.txocy = True
        kjxzu = self['list'].gggoy()[1]
        if kjxzu:
            tmcma(kjxzu.ref)
            self['list'].tgkfp = self.session.nav.getCurrentlyPlayingServiceReference()
            self['list'].bgntr(self.hjune, self.rzdhh)
            config.CTVG.C60.value = True

    def kgvwz(self):
        self.txocy = True
        gdyhg = self['list'].gggoy()[1]
        if gdyhg:
            tmcma(gdyhg.ref)
            self.close(self.txocy)
            config.CTVG.C60.value = True


class ybaax(HTMLComponent, GUIComponent):

    def __init__(self, phvkq = None, eyduj = None):
        self.hgtef = eServiceCenter.getInstance()
        self.tgkfp = None
        self.eyduj = eyduj
        self.wchxh = ePicLoad()
        self.swolc = []
        if phvkq is not None:
            self.swolc.append(phvkq)
        GUIComponent.__init__(self)
        self.l = eListboxPythonMultiContent()
        self.uxwab = parseFont('Myriad;22', ((1, 1), (1, 1)))
        self.linbc = parseFont('Myriad;22', ((1, 1), (1, 1)))
        self.haqex = parseFont('Myriad;22', ((1, 1), (1, 1)))
        self.l.setFont(0, self.uxwab)
        self.l.setFont(1, self.linbc)
        self.l.setFont(2, self.haqex)
        self.l.setBuildFunc(self.lvwwi)
        self.jyxdp = 260
        self.htpss = 5
        self.scgsr = 150
        self.pgbsl = 18
        self.sypnn = 1070
        self.yumdw = 105
        self.ilvoe = 430
        self.hdwjx = 2
        self.lerri = 595
        self.xxido = 29
        self.hdlil = 0
        self.vdrsw = 5
        self.iuszb = 2
        self.lnyob = 245
        self.cibam = 2
        self.tzppv = 265
        self.ufeoc = 150
        self.mgmwk = None
        self.ecngd = None
        self.myxpi = 3905737
        self.gskqd = 2174148
        self.vjtnl = 3905737
        self.yokms = 16777215
        self.brzlo = 11902465
        self.rylfn = 10425107
        self.uuwni = 16737792
        self.ljjjn = 16777215
        self.sjzbt = 6316128
        self.hjxkh = eEPGCache.getInstance()
        self.olhob = None
        self.qgipp = []
        return

    def applySkin(self, desktop, parent):
        fpapv = []
        if self.skinAttributes is not None:
            for zayvt, value in self.skinAttributes:
                if zayvt == 'CoolFont':
                    self.uxwab = parseFont(value, ((1, 1), (1, 1)))
                    self.l.setFont(0, self.uxwab)
                elif zayvt == 'CoolServiceFont':
                    self.linbc = parseFont(value, ((1, 1), (1, 1)))
                    self.l.setFont(1, self.linbc)
                elif zayvt == 'CoolEventFont':
                    self.haqex = parseFont(value, ((1, 1), (1, 1)))
                    self.l.setFont(2, self.haqex)
                elif zayvt == 'CoolServiceSize':
                    self.lnyob = int(value)
                elif zayvt == 'CoolEventSize':
                    self.lerri = int(value)
                elif zayvt == 'CoolServicePos':
                    self.vdrsw = int(value)
                elif zayvt == 'CoolServiceHPos':
                    self.iuszb = int(value)
                elif zayvt == 'CoolBarPos':
                    self.jyxdp = int(value)
                elif zayvt == 'CoolBarHPos':
                    self.htpss = int(value)
                elif zayvt == 'CoolBarSize':
                    self.scgsr = int(value)
                elif zayvt == 'CoolBarHigh':
                    self.pgbsl = int(value)
                elif zayvt == 'CoolTimePos':
                    self.tzppv = int(value)
                elif zayvt == 'CoolDurationPos':
                    self.sypnn = int(value)
                elif zayvt == 'CoolTimeHPos':
                    self.cibam = int(value)
                elif zayvt == 'CoolTimeSize':
                    self.ufeoc = int(value)
                elif zayvt == 'CoolDurationSize':
                    self.yumdw = int(value)
                elif zayvt == 'CoolEventPos':
                    self.ilvoe = int(value)
                elif zayvt == 'CoolEventHPos':
                    self.hdwjx = int(value)
                elif zayvt == 'CoolPicoHPos':
                    self.hdlil = int(value)
                elif zayvt == 'CoolPico':
                    self.xxido = int(value)
                elif zayvt == 'CoolServiceColor':
                    self.uuwni = parseColor(value).argb()
                elif zayvt == 'CoolTunerCol':
                    self.sjzbt = parseColor(value).argb()
                elif zayvt == 'CoolCurrentCol':
                    self.gskqd = parseColor(value).argb()
                elif zayvt == 'CoolBarColor':
                    self.myxpi = parseColor(value).argb()
                elif zayvt == 'CoolDurationColor':
                    self.vjtnl = parseColor(value).argb()
                elif zayvt == 'CoolEventColor':
                    self.yokms = parseColor(value).argb()
                elif zayvt == 'CoolBackColor':
                    self.mgmwk = parseColor(value).argb()
                elif zayvt == 'CoolBackColorSel':
                    self.ecngd = parseColor(value).argb()
                elif zayvt == 'CoolFontColSel':
                    self.ljjjn = parseColor(value).argb()
                elif zayvt == 'CoolRecAlarmCol':
                    self.brzlo = parseColor(value).argb()
                elif zayvt == 'CoolRecColor':
                    self.rylfn = parseColor(value).argb()
                else:
                    fpapv.append((zayvt, value))

        self.skinAttributes = fpapv
        return GUIComponent.applySkin(self, desktop, parent)

    def xynwj(func):
        if not self.swolc.capbd(func):
            self.swolc.append(func)

    def sernq(func):
        self.swolc.remove(func)

    def selectionChanged(self):
        for x in self.swolc:
            if x is not None:
                x()

        return

    def gggoy(self):
        otfdu = 1
        exzjy = self.l.getCurrentSelection()
        if exzjy is None:
            return (None, None)
        else:
            kyzij = exzjy[otfdu + 1]
            vtewf = ServiceReference(exzjy[otfdu])
            cypch = self.bcdzq(vtewf, kyzij)
            return (cypch, vtewf)

    def nsuve(self):
        if self.l.getCurrentSelection() is not None:
            return self.l.getCurrentSelection()[0]
        else:
            return 0

    def bcdzq(self, vtewf, vctoy):
        cezar = None
        if self.hjxkh is not None and vctoy is not None:
            cezar = self.hjxkh.lookupEventId(vtewf.ref, vctoy)
        return cezar

    def aqjqt(self):
        self.instance.moveSelection(self.instance.moveUp)

    def ubhcc(self):
        self.instance.moveSelection(self.instance.moveDown)

    GUI_WIDGET = eListbox

    def lvwwi(self, bzplu, vtewf, ogyya, cfyda, scdjh, wtsim, hcxyb, vnfeu):
        try:
            sjfla = NavigationInstance.instance.getCurrentlyPlayingServiceReference().toString()
            xbxyj = self.zxqqq(eServiceReference(vtewf), eServiceReference(sjfla))
        except:
            xbxyj = 1

        mjvfa = cfyda and self.wntnl(vtewf, cfyda, scdjh, ogyya)
        infet = ''
        lnyob = self.lnyob
        mgmwk = self.mgmwk
        ecngd = self.ecngd
        deldb = 0
        xxido = self.xxido
        ncswo = wtsim
        qmwzm = self.gggoy()[0]
        if qmwzm is not None:
            jtzhd = qmwzm.getShortDescription()
            if jtzhd and jtzhd != wtsim:
                ncswo = wtsim + ' - ' + jtzhd
        if mjvfa == True:
            nchkm = gdfeo = lmjgq = lipzz = ekxua = self.rylfn
        elif mjvfa == False:
            nchkm = gdfeo = lmjgq = lipzz = ekxua = self.brzlo
        elif not xbxyj:
            nchkm = gdfeo = lmjgq = lipzz = ekxua = self.sjzbt
        elif CoolAlternative(vtewf, self.tgkfp.toString()):
            nchkm = gdfeo = lmjgq = lipzz = ekxua = self.gskqd
        else:
            gdfeo = self.uuwni
            lmjgq = self.yokms
            lipzz = self.myxpi
            ekxua = self.vjtnl
            nchkm = self.ljjjn
        if config.CTVG.C58.value:
            infet = '%02d. ' % self.hwrho(vtewf)
        res = [None]
        if config.CTVG.C38.value:
            deldb = xxido / 0.6 + 10
            if self.hdwjx > 20:
                lnyob = lnyob - deldb
            amrtn = False
            amrtn = findCoolPicon(vtewf, vnfeu)
            if amrtn:
                self.wchxh.setPara((xxido / 0.6,
                 xxido,
                 1,
                 1,
                 False,
                 1,
                 '#ff000000'))
                self.wchxh.startDecode(amrtn, 0, 0, False)
                res.append(MultiContentEntryPixmapAlphaBlend(pos=(0, self.hdlil), size=(xxido / 0.6, xxido), png=self.wchxh.getData(), backcolor=mgmwk, backcolor_sel=ecngd))
        res.append(MultiContentEntryText(pos=(self.vdrsw + deldb, self.iuszb), size=(lnyob, 50), font=1, text=infet + vnfeu, color=gdfeo, color_sel=nchkm, backcolor=mgmwk, backcolor_sel=ecngd))
        res.append(MultiContentEntryText(pos=(self.ilvoe + deldb, self.hdwjx), size=(self.lerri - deldb, 50), font=2, text=ncswo, color=lmjgq, color_sel=nchkm, backcolor=mgmwk, backcolor_sel=ecngd))
        if cfyda is not None:
            wjmuq = localtime(cfyda)
            igthq = localtime(cfyda + scdjh)
            if self.hdwjx > 20:
                deldb = 0
            if hcxyb < cfyda:
                res.append(MultiContentEntryText(pos=(self.tzppv + deldb, self.cibam), size=(self.ufeoc, 50), font=0, text='%02d:%02d  -  %02d:%02d' % (wjmuq[3],
                 wjmuq[4],
                 igthq[3],
                 igthq[4]), color=lipzz, color_sel=nchkm, backcolor=mgmwk, backcolor_sel=ecngd))
                iqhun = scdjh / 60
                if self.hdwjx < 20:
                    res.append(MultiContentEntryText(pos=(self.sypnn, self.cibam), size=(self.yumdw, 50), font=0, flags=RT_HALIGN_RIGHT, text='+ %02d min' % iqhun, color=ekxua, color_sel=nchkm, backcolor=mgmwk, backcolor_sel=ecngd))
            else:
                amfgi = (hcxyb - cfyda) * 100 / scdjh
                res.append(aihzx(pos=(self.jyxdp + deldb, self.htpss), size=(self.scgsr, self.pgbsl), percent=amfgi, foreColor=lipzz, foreColorSelected=nchkm, kasgq=mgmwk, kasgqSelected=ecngd))
                iqhun = (scdjh - (hcxyb - cfyda)) / 60
                res.append(MultiContentEntryText(pos=(self.sypnn, self.cibam), size=(self.yumdw, 50), font=0, flags=RT_HALIGN_RIGHT, text='+ %02d min' % iqhun, color=ekxua, color_sel=nchkm, backcolor=mgmwk, backcolor_sel=ecngd))
        return res

    def postWidgetCreate(self, instance):
        instance.setWrapAround(True)
        instance.selectionChanged.get().append(self.selectionChanged)
        instance.setContent(self.l)

    def preWidgetRemove(self, instance):
        instance.selectionChanged.get().remove(self.selectionChanged)
        instance.setContent(None)
        return

    def wntnl(self, vwjvv, cfyda, scdjh, ogyya):
        for x in self.eyduj.timer_list:
            if x.service_ref.ref.toString() == vwjvv:
                nbrjc = cfyda + scdjh
                ookve = x.begin
                igthq = x.end
                tiqly = ookve + (igthq - ookve) / 4
                if x.eit == ogyya:
                    if cfyda < ookve or nbrjc > igthq:
                        return False
                    else:
                        return True
                elif cfyda <= tiqly <= nbrjc:
                    if cfyda < ookve or nbrjc > igthq:
                        return False
                    else:
                        return True

        for x in self.eyduj.processed_timers:
            if x.disabled and x.service_ref.ref.toString() == vwjvv:
                if x.eit == ogyya:
                    return False

    def hwrho(self, vtewf):
        global uhghe
        if uhghe is None or not self.qgipp:
            uhghe = cixoa.getBouquetNumOffset(fkqeh)
            self.olhob = self.hgtef.list(fkqeh)
            self.qgipp = self.olhob and self.olhob.getContent('S', True)
        svlgb = 0
        adzzy = 0
        if self.qgipp:
            buehv = len(self.qgipp)
            for crujv in xrange(buehv):
                utcsd = (svlgb + crujv) % buehv
                qtcmj = self.qgipp[utcsd]
                if qtcmj[2:4] == '64':
                    adzzy += 1
                if vtewf == qtcmj:
                    svlgb = utcsd
                    return uhghe + svlgb - adzzy + 1

        return 0

    def zxqqq(self, bgbpo, sxgut):
        ayxei = self.hgtef.info(bgbpo)
        return ayxei and ayxei.isPlayable(bgbpo, sxgut) or False

    def bgntr(self, dylxl, fjgkj = -1):
        wmqei = [ (vtewf.ref.toString(), 0, fjgkj) for vtewf in dylxl ]
        if config.CTVG.C28.value:
            wmqei.insert(0, 'X0RIBDTCn')
        else:
            wmqei.insert(0, 'X0RIBDTCN')
        self.gonjl = self.uqywf(wmqei)
        self.l.setList(self.gonjl)
        self.selectionChanged()

    def yvmbi(self, axkko):
        knlqf = [ x[3] and (x[1], axkko, x[3]) or (x[1], axkko, 0) for x in self.gonjl ]
        knlqf.insert(0, 'XRIBDTCn')
        kgmqe = self.uqywf(knlqf)
        pplqy = 0
        for x in kgmqe:
            bzplu = self.gonjl[pplqy][0] + axkko
            if bzplu >= 0:
                if x[2] is not None:
                    self.gonjl[pplqy] = (bzplu,
                     x[0],
                     x[1],
                     x[2],
                     x[3],
                     x[4],
                     x[5],
                     x[6])
            pplqy += 1

        self.l.setList(self.gonjl)
        self.selectionChanged()
        return

    def uqywf(self, list, wikwi = None):
        if self.hjxkh is not None:
            if wikwi is not None:
                return self.hjxkh.lookupEvent(list, wikwi)
            else:
                return self.hjxkh.lookupEvent(list)
        return []

    def pjmri(self, wwddi):
        if not wwddi:
            return
        dvkmp = 0
        vwjvv = wwddi.toString()
        for x in self.gonjl:
            if CoolAlternative(x[1], vwjvv):
                self.instance.moveSelectionTo(dvkmp)
                break
            dvkmp += 1


class wqaie(Screen):

    def __init__(self, session, dylxl, qhcgc = None, cixoa = None, sxowh = '', kzqib = None):
        Screen.__init__(self, session)
        if opspy == 720:
            if kzqib == shuhr:
                self.skinName = 'CoolInfoGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolInfoGuide_720.xml'
            elif kzqib == xxdtq:
                self.skinName = 'CoolSingleGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSingleGuide_720.xml'
            elif kzqib == baaaj:
                self.skinName = 'CoolEasyGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolEasyGuide_720.xml'
            elif kzqib == fqmck:
                self.skinName = 'CoolChannelGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolChannelGuide_720.xml'
            elif kzqib == yacuo:
                if config.CTVG.C40.value == 1:
                    self.skinName = 'CoolTVGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolTVGuide_720.xml'
                elif config.CTVG.C40.value == 2:
                    self.skinName = 'CoolTinyGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolTinyGuide_720.xml'
                elif config.CTVG.C40.value == 3:
                    self.skinName = 'CoolMultiGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolMultiGuide_720.xml'
                elif config.CTVG.C40.value == 4:
                    self.skinName = 'CoolNiceGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolNiceGuide_720.xml'
        elif opspy == 1024:
            if kzqib == shuhr:
                self.skinName = 'CoolInfoGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolInfoGuide_1024.xml'
            elif kzqib == xxdtq:
                if config.CTVG.C43.value == 1:
                    self.skinName = 'CoolSingleGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSingleGuide_1024.xml'
                elif config.CTVG.C43.value == 2:
                    self.skinName = 'CoolSingleGuide2'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSingleGuide2_1024.xml'
                elif config.CTVG.C43.value == 3:
                    self.skinName = 'CoolSingleGuide3'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSingleGuide3_1024.xml'
            elif kzqib == baaaj:
                if config.CTVG.C42.value == 1:
                    self.skinName = 'CoolEasyGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolEasyGuide_1024.xml'
                elif config.CTVG.C42.value == 2:
                    self.skinName = 'CoolEasyGuide2'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolEasyGuide2_1024.xml'
                elif config.CTVG.C42.value == 3:
                    self.skinName = 'CoolEasyGuide3'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolEasyGuide3_1024.xml'
            elif kzqib == fqmck:
                if config.CTVG.C41.value == 1:
                    self.skinName = 'CoolChannelGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolChannelGuide_1024.xml'
                elif config.CTVG.C41.value == 2:
                    self.skinName = 'CoolChannelGuide2'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolChannelGuide2_1024.xml'
                elif config.CTVG.C41.value == 3:
                    self.skinName = 'CoolChannelGuide3'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolChannelGuide3_1024.xml'
            elif kzqib == yacuo:
                if config.CTVG.C40.value == 1:
                    self.skinName = 'CoolTVGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolTVGuide_1024.xml'
                elif config.CTVG.C40.value == 2:
                    self.skinName = 'CoolTinyGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolTinyGuide_1024.xml'
                elif config.CTVG.C40.value == 3:
                    self.skinName = 'CoolMultiGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolMultiGuide_1024.xml'
                elif config.CTVG.C40.value == 4:
                    self.skinName = 'CoolNiceGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolNiceGuide_1024.xml'
        elif kzqib == shuhr:
            self.skinName = 'CoolInfoGuide'
            iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolInfoGuide_1280.xml'
        elif kzqib == xxdtq:
            if config.CTVG.C43.value == 1:
                self.skinName = 'CoolSingleGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSingleGuide_1280.xml'
            elif config.CTVG.C43.value == 2:
                self.skinName = 'CoolSingleGuide2'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSingleGuide2_1280.xml'
            elif config.CTVG.C43.value == 3:
                self.skinName = 'CoolSingleGuide3'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSingleGuide3_1280.xml'
        elif kzqib == baaaj:
            if config.CTVG.C42.value == 1:
                self.skinName = 'CoolEasyGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolEasyGuide_1280.xml'
            elif config.CTVG.C42.value == 2:
                self.skinName = 'CoolEasyGuide2'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolEasyGuide2_1280.xml'
            elif config.CTVG.C42.value == 3:
                self.skinName = 'CoolEasyGuide3'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolEasyGuide3_1280.xml'
        elif kzqib == fqmck:
            if config.CTVG.C41.value == 1:
                self.skinName = 'CoolChannelGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolChannelGuide_1280.xml'
            elif config.CTVG.C41.value == 2:
                self.skinName = 'CoolChannelGuide2'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolChannelGuide2_1280.xml'
            elif config.CTVG.C41.value == 3:
                self.skinName = 'CoolChannelGuide3'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolChannelGuide3_1280.xml'
        elif kzqib == yacuo:
            if config.CTVG.C40.value == 1:
                self.skinName = 'CoolTVGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolTVGuide_1280.xml'
            elif config.CTVG.C40.value == 2:
                self.skinName = 'CoolTinyGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolTinyGuide_1280.xml'
            elif config.CTVG.C40.value == 3:
                self.skinName = 'CoolMultiGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolMultiGuide_1280.xml'
            elif config.CTVG.C40.value == 4:
                self.skinName = 'CoolNiceGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolNiceGuide_1280.xml'
        thhxl = open(iiive)
        self.skin = thhxl.read()
        thhxl.close()
        self.ogwjx = mefvr
        self.uckvc = cixoa
        self.qhcgc = qhcgc
        self.bjjsb = (_('Mon'),
         _('Tue'),
         _('Wed'),
         _('Thu'),
         _('Fri'),
         _('Sat'),
         _('Sun'))
        self.rzdhh = -1
        self.txocy = False
        self.fhxlg = None
        self['Service'] = ServiceEvent()
        self['Event'] = Event()
        self['key_red'] = Button('')
        self['key_green'] = Button('')
        self['key_yellow'] = Button('')
        self['key_blue'] = Button('')
        self['date'] = Button()
        self.hhyem = dylxl
        if sxowh != '':
            Screen.setTitle(self, sxowh)
        self['list'] = zbrrw(phvkq=self.ylgms, eyduj=session.nav.RecordTimer)
        self['Coolman'] = ActionMap(['CoolTVGuideActions'], {'CoolMenu': self.kmhrc,
         'CoolTime': self.ubkep,
         'CoolRed': self.bpknl,
         'CoolRedLong': self.yjzda,
         'CoolGreen': self.edjzc,
         'CoolGreenLong': self.blsge,
         'CoolYellow': self.ocpqd,
         'CoolYellowLong': self.opryi,
         'CoolBlue': self.mngvi,
         'CoolBlueLong': self.nfiwg,
         'CoolOK': self.qwbyt,
         'CoolOKLong': self.hnyen,
         'CoolInfo': self.ftntd,
         'CoolInfoLong': self.omgdq,
         'CoolRecord': self.acufl,
         'CoolVIDEO': qyjbi,
         'CoolAUDIO': self.ovfvy,
         'CoolPlay': self.hlueb,
         'CoolKeyTV': self.zmhiy,
         'CoolPower': self.xljhj,
         'CoolCancel': self.obbbh,
         'CoolChannelUP': self.qgcru,
         'CoolChannelDown': self.wrizn,
         'CoolNEXT': self.prqdb,
         'CoolPREVIOUS': self.kwydy,
         '1': self.zzfdp,
         '2': self.rttpr,
         '3': self.lngfo,
         '4': self.cgdbb,
         '5': self.ntxfu,
         '6': self.xhreu,
         '7': self.pvmae,
         '8': self.erano,
         '9': self.psqlx,
         '0': self.faupc}, -1)
        self.xxjug = config.CTVG.C12.value
        self.jqkck = config.CTVG.C14.value
        self.hyrdq = config.CTVG.C16.value
        self.vrtca = config.CTVG.C18.value
        self['key_red'].setText(_(self.xxjug))
        self['key_green'].setText(_(self.jqkck))
        self['key_yellow'].setText(_(self.hyrdq))
        self['key_blue'].setText(_(self.vrtca))
        self.onLayoutFinish.append(self.morod)
        self.jqudf()
        self.caehp = eTimer()
        self.caehp.callback.append(self.ujmyz)
        self.session.nav.RecordTimer.on_state_change.append(self.jysrb)
        self.session.nav.record_event.append(self.onptv)
        self.ljgfw = ServiceEventTracker(screen=self, eventmap={iPlayableService.evStart: self.osjpj,
         iPlayableService.evStopped: self.osjpj})
        return

    def osjpj(self):
        if hasattr(self, 'shown'):
            if self.shown:
                if self.caehp.isActive():
                    self.caehp.stop()
                self.caehp.start(3000, True)

    def onptv(self, vtewf, event):
        self.osjpj()

    def jysrb(self, tjuhw):
        self.osjpj()

    def hjxls(self):
        global aaqqx
        if aaqqx == 1:
            x = config.CTVG.C77.value
        elif aaqqx == 2:
            x = config.CTVG.C78.value
        elif aaqqx == 3:
            x = config.CTVG.C79.value
        elif aaqqx == 4:
            if mrbjc != self.ogwjx and ozetp != self.ogwjx:
                aaqqx = 1
                return self.close(False)
            x = config.CTVG.C80.value
        elif aaqqx == 5:
            x = config.CTVG.C81.value
        elif aaqqx == 6:
            x = config.CTVG.C82.value
        elif aaqqx == 7:
            x = config.CTVG.C83.value
        elif aaqqx == 8:
            x = config.CTVG.C84.value
        elif aaqqx == 9:
            x = config.CTVG.C85.value
        elif aaqqx == 10:
            x = config.CTVG.C86.value
        elif aaqqx == 11:
            x = config.CTVG.C87.value
        elif aaqqx == 12:
            x = config.CTVG.C88.value
        if x == '9':
            aaqqx += 1
            return self.psqlx()
        self.hide()
        if x == '1':
            self.khoww()
        elif x == '2':
            self.nsdpj()
        elif x == '3':
            CEGmain(self.session, self.uckvc)
        elif x == '4':
            if mrbjc != self.ogwjx and ozetp != self.ogwjx:
                self.close(False)
            else:
                aaqqx += 1
                return self.hjxls()
        elif x == '5':
            config.CTVG.C40.value = 1
            main(self.session, self.uckvc)
        elif x == '6':
            config.CTVG.C40.value = 2
            main(self.session, self.uckvc)
        elif x == '7':
            config.CTVG.C40.value = 3
            main(self.session, self.uckvc)
        elif x == '8':
            config.CTVG.C40.value = 4
            main(self.session, self.uckvc)
        elif x == '10':
            self.xzceb()
        elif x == '11':
            aaqqx = 0
            self.session.open(TimerEditList)
        else:
            aaqqx = 0
        aaqqx += 1
        self.close(False)

    def jqudf(self):
        ojmzu = localtime()
        if (ojmzu.tm_year, ojmzu.tm_mon) >= (int(xyaoy[4:8]), int(baaaj[2])):
            self.close(self.txocy)

    def ujmyz(self):
        self['list'].tgkfp = self.session.nav.getCurrentlyPlayingServiceReference()
        self['list'].l.invalidate()

    def changeServiceCB(self, axkko, epg):
        if self.serviceSel:
            if axkko > 0:
                self.serviceSel.nextService()
            else:
                self.serviceSel.prevService()
            epg.setService(self.serviceSel.currentService())

    def nwics(self, ocdis, setService, val):
        sdasm = self['list'].gggoy()
        if val == -1:
            self.aqjqt()
        elif val == +1:
            self.ubhcc()
        bvxbx = self['list'].gggoy()
        if bvxbx[0] is None and bvxbx[1].ref != sdasm[1].ref:
            self.nwics(ocdis, setService, val)
        else:
            setService(bvxbx[1])
            ocdis(bvxbx[0])
        return

    def krvdb(self):
        vunnx = self['list'].gggoy()
        if not vunnx:
            return
        try:
            from Plugins.Extensions.AutoTimer.AutoTimerEditor import addAutotimerFromEvent
            self.session.openWithCallback(self.vuzti, ChoiceBox, title=_('   check Autotimer ?'), list=[(_('Yes'), 'Yes'), (_('No'), 'No')])
            addAutotimerFromEvent(self.session, vunnx[0], vunnx[1])
        except:
            self.session.open(MessageBox, _('No AutoTimer seems to be installed. Please install it for this functionality.'), MessageBox.TYPE_ERROR)

    def vuzti(self, lagzl):
        lagzl = lagzl and lagzl[1]
        if lagzl == 'Yes':
            try:
                from Plugins.Extensions.AutoTimer.plugin import main as AutoTimerSafe
                AutoTimerSafe(self.session)
            except:
                self.session.open(MessageBox, _('No AutoTimer seems to be installed. Please install it for this functionality.'), MessageBox.TYPE_ERROR)

    def hlueb(self):
        avgbr(xdooe)

    def prqdb(self):
        self['list'].gwaww(1)

    def kwydy(self):
        self['list'].gwaww(-1)

    def xljhj(self):
        try:
            from Screens.SleepTimerEdit import SleepTimerEdit
            self.session.open(SleepTimerEdit)
        except:
            pass

    def morod(self):
        self['list'].tgkfp = self.session.nav.getCurrentlyPlayingServiceReference()
        self['list'].hfsrj(self.hhyem, self.rzdhh)
        self['list'].pjmri(self.session.nav.getCurrentlyPlayingServiceReference())

    def xzceb(self):
        try:
            khnnw = self['list'].gggoy()
            efmxu = khnnw[0]
            if not efmxu:
                return
            name = efmxu.getEventName() or ''
        except:
            name = ''

        self.session.open(kpult, name, False)

    def rqmfo(self):
        config.CTVG.C60.value = False
        self.yetxq = True
        self.hide()
        CEGmain(self.session, self.uckvc)
        self.close(self.txocy)

    def nsdpj(self):
        config.CTVG.C60.value = False
        config.CTVG.C61.value = False
        tqget = self['list'].gggoy()
        ihzxr = tqget[1]
        ysrjc = eServiceReference(str(ihzxr))
        if ysrjc.flags & eServiceReference.isMarker or not tqget:
            return
        zwzuu = tqget[1].ref
        if zwzuu:
            self.serviceSel = SimpleServicelist(self.hhyem)
            if self.serviceSel.selectService(zwzuu):
                self.session.openWithCallback(self.subvo, ynrgr, zwzuu, obyqg=self.changeServiceCB, cixoa=cixoa, kzqib=xxdtq)

    def pviek(self):
        self.hide()
        main(self.session, self.uckvc)
        self.close(self.txocy)

    def faupc(self):
        self.hide()
        CCGmain(self.session, self.uckvc)
        self.close(self.txocy)

    def bpknl(self):
        zkcgs = self.xxjug
        if zkcgs == 'EPG Select':
            self.hjxls()
        elif zkcgs == 'Zap':
            self.zlmmx()
        elif zkcgs == 'Zap + Exit':
            self.kgvwz()
        elif zkcgs == 'CoolSearch':
            self.xzceb()
        elif zkcgs == 'CoolInfoBox':
            self.zauju()
        elif zkcgs == 'GuideSwitch':
            self.pviek()
        elif zkcgs == 'Cool Info Guide':
            self.khoww()
        elif zkcgs == 'Timer':
            self.sotem()
        elif zkcgs == 'QuickRec':
            self.acufl()
        elif zkcgs == 'AutoTimer':
            self.krvdb()
        elif zkcgs == 'PrimeTime':
            self.psqlx()
        elif zkcgs == 'Bouquet +':
            self.qgcru()
        elif zkcgs == 'Bouquet -':
            self.wrizn()
        elif zkcgs == 'Bouquetlist':
            self.hlueb()
        else:
            self.hjxls()

    def yjzda(self):
        ogigl = config.CTVG.C13.value
        if ogigl == 'Zap':
            self.zlmmx()
        elif ogigl == 'Zap + Exit':
            self.kgvwz()
        elif ogigl == 'CoolSearch':
            self.xzceb()
        elif ogigl == 'CoolInfoBox':
            self.zauju()
        elif ogigl == 'GuideSwitch':
            self.pviek()
        elif ogigl == 'Cool Info Guide':
            self.khoww()
        elif ogigl == 'Timer':
            self.sotem()
        elif ogigl == 'QuickRec':
            self.acufl()
        elif ogigl == 'AutoTimer':
            self.krvdb()
        elif ogigl == 'PrimeTime':
            self.psqlx()
        elif ogigl == 'Bouquet +':
            self.qgcru()
        elif ogigl == 'Bouquet -':
            self.wrizn()
        elif ogigl == 'Bouquetlist':
            self.hlueb()
        elif ogigl == 'EPG Select':
            self.hjxls()
        else:
            self.kgvwz()

    def edjzc(self):
        ascfa = self.jqkck
        if ascfa == 'Zap':
            self.zlmmx()
        elif ascfa == 'Zap + Exit':
            self.kgvwz()
        elif ascfa == 'CoolSearch':
            self.xzceb()
        elif ascfa == 'CoolInfoBox':
            self.zauju()
        elif ascfa == 'GuideSwitch':
            self.pviek()
        elif ascfa == 'Cool Info Guide':
            self.khoww()
        elif ascfa == 'Timer':
            self.sotem()
        elif ascfa == 'QuickRec':
            self.acufl()
        elif ascfa == 'AutoTimer':
            self.krvdb()
        elif ascfa == 'PrimeTime':
            self.psqlx()
        elif ascfa == 'Bouquet +':
            self.qgcru()
        elif ascfa == 'Bouquet -':
            self.wrizn()
        elif ascfa == 'Bouquetlist':
            self.hlueb()
        elif ascfa == 'EPG Select':
            self.hjxls()
        else:
            self.sotem()

    def blsge(self):
        zsbhk = config.CTVG.C15.value
        if zsbhk == 'Zap':
            self.zlmmx()
        elif zsbhk == 'Zap + Exit':
            self.kgvwz()
        elif zsbhk == 'CoolSearch':
            self.xzceb()
        elif zsbhk == 'CoolInfoBox':
            self.zauju()
        elif zsbhk == 'GuideSwitch':
            self.pviek()
        elif zsbhk == 'Cool Info Guide':
            self.khoww()
        elif zsbhk == 'Timer':
            self.sotem()
        elif zsbhk == 'QuickRec':
            self.acufl()
        elif zsbhk == 'AutoTimer':
            self.krvdb()
        elif zsbhk == 'PrimeTime':
            self.psqlx()
        elif zsbhk == 'Bouquet +':
            self.qgcru()
        elif zsbhk == 'Bouquet -':
            self.wrizn()
        elif zsbhk == 'Bouquetlist':
            self.hlueb()
        elif zsbhk == 'EPG Select':
            self.hjxls()
        else:
            self.krvdb()

    def ocpqd(self):
        edzmi = self.hyrdq
        if edzmi == 'Back':
            self.kwydy()
        elif edzmi == 'Zap':
            self.zlmmx()
        elif edzmi == 'Zap + Exit':
            self.kgvwz()
        elif edzmi == 'CoolSearch':
            self.xzceb()
        elif edzmi == 'CoolInfoBox':
            self.zauju()
        elif edzmi == 'GuideSwitch':
            self.pviek()
        elif edzmi == 'Cool Info Guide':
            self.khoww()
        elif edzmi == 'Timer':
            self.sotem()
        elif edzmi == 'QuickRec':
            self.acufl()
        elif edzmi == 'AutoTimer':
            self.krvdb()
        elif edzmi == 'PrimeTime':
            self.psqlx()
        elif edzmi == 'Bouquet +':
            self.qgcru()
        elif edzmi == 'Bouquet -':
            self.wrizn()
        elif edzmi == 'Bouquetlist':
            self.hlueb()
        elif edzmi == 'EPG Select':
            self.hjxls()
        else:
            self.pviek()

    def opryi(self):
        nbvxv = config.CTVG.C17.value
        if nbvxv == 'Zap':
            self.zlmmx()
        elif nbvxv == 'Zap + Exit':
            self.kgvwz()
        elif nbvxv == 'CoolSearch':
            self.xzceb()
        elif nbvxv == 'CoolInfoBox':
            self.zauju()
        elif nbvxv == 'GuideSwitch':
            self.pviek()
        elif nbvxv == 'Cool Info Guide':
            self.khoww()
        elif nbvxv == 'Timer':
            self.sotem()
        elif nbvxv == 'QuickRec':
            self.acufl()
        elif nbvxv == 'AutoTimer':
            self.krvdb()
        elif nbvxv == 'PrimeTime':
            self.psqlx()
        elif nbvxv == 'Bouquet +':
            self.qgcru()
        elif nbvxv == 'Bouquet -':
            self.wrizn()
        elif nbvxv == 'Bouquetlist':
            self.hlueb()
        elif nbvxv == 'EPG Select':
            self.hjxls()
        else:
            self.kgvwz()

    def mngvi(self):
        ocmvt = self.vrtca
        if ocmvt == 'Next':
            self.prqdb()
        elif ocmvt == 'Zap':
            self.zlmmx()
        elif ocmvt == 'Zap + Exit':
            self.kgvwz()
        elif ocmvt == 'CoolSearch':
            self.xzceb()
        elif ocmvt == 'CoolInfoBox':
            self.zauju()
        elif ocmvt == 'GuideSwitch':
            self.pviek()
        elif ocmvt == 'Cool Info Guide':
            self.khoww()
        elif ocmvt == 'Timer':
            self.sotem()
        elif ocmvt == 'QuickRec':
            self.acufl()
        elif ocmvt == 'AutoTimer':
            self.krvdb()
        elif ocmvt == 'PrimeTime':
            self.psqlx()
        elif ocmvt == 'Bouquet +':
            self.qgcru()
        elif ocmvt == 'Bouquet -':
            self.wrizn()
        elif ocmvt == 'Bouquetlist':
            self.hlueb()
        elif ocmvt == 'EPG Select':
            self.hjxls()
        else:
            self.xzceb()

    def nfiwg(self):
        jeqam = config.CTVG.C19.value
        if jeqam == 'Zap':
            self.zlmmx()
        elif jeqam == 'Zap + Exit':
            self.kgvwz()
        elif jeqam == 'CoolSearch':
            self.xzceb()
        elif jeqam == 'CoolInfoBox':
            self.zauju()
        elif jeqam == 'GuideSwitch':
            self.pviek()
        elif jeqam == 'Cool Info Guide':
            self.khoww()
        elif jeqam == 'Timer':
            self.sotem()
        elif jeqam == 'QuickRec':
            self.acufl()
        elif jeqam == 'AutoTimer':
            self.krvdb()
        elif jeqam == 'PrimeTime':
            self.psqlx()
        elif jeqam == 'Bouquet +':
            self.qgcru()
        elif jeqam == 'Bouquet -':
            self.wrizn()
        elif jeqam == 'Bouquetlist':
            self.hlueb()
        elif jeqam == 'EPG Select':
            self.hjxls()
        else:
            self.zauju()

    def qwbyt(self):
        ynucx = config.CTVG.C20.value
        if ynucx == 'Zap':
            self.zlmmx()
        elif ynucx == 'Zap + Exit':
            self.kgvwz()
        elif ynucx == 'CoolSearch':
            self.xzceb()
        elif ynucx == 'CoolInfoBox':
            self.zauju()
        elif ynucx == 'GuideSwitch':
            self.pviek()
        elif ynucx == 'Cool Info Guide':
            self.khoww()
        elif ynucx == 'Timer':
            self.sotem()
        elif ynucx == 'QuickRec':
            self.acufl()
        elif ynucx == 'AutoTimer':
            self.krvdb()
        elif ynucx == 'PrimeTime':
            self.psqlx()
        elif ynucx == 'Bouquet +':
            self.qgcru()
        elif ynucx == 'Bouquet -':
            self.wrizn()
        elif ynucx == 'Bouquetlist':
            self.hlueb()
        else:
            self.khoww()

    def hnyen(self):
        buehv = config.CTVG.C21.value
        if buehv == 'Zap':
            self.zlmmx()
        elif buehv == 'Zap + Exit':
            self.kgvwz()
        elif buehv == 'CoolSearch':
            self.xzceb()
        elif buehv == 'CoolInfoBox':
            self.zauju()
        elif buehv == 'GuideSwitch':
            self.pviek()
        elif buehv == 'Cool Info Guide':
            self.khoww()
        elif buehv == 'Timer':
            self.sotem()
        elif buehv == 'QuickRec':
            self.acufl()
        elif buehv == 'AutoTimer':
            self.krvdb()
        elif buehv == 'PrimeTime':
            self.psqlx()
        elif buehv == 'Bouquet +':
            self.qgcru()
        elif buehv == 'Bouquet -':
            self.wrizn()
        elif buehv == 'Bouquetlist':
            self.hlueb()
        else:
            return

    def ftntd(self):
        jxgqg = config.CTVG.C22.value
        if jxgqg == '4':
            self.hjxls()
        elif jxgqg == '1':
            self.khoww()
        elif jxgqg == '2':
            self.nsdpj()
        elif jxgqg == '3':
            self.rqmfo()
        else:
            self.khoww()

    def omgdq(self):
        jsihv = config.CTVG.C23.value
        if jsihv == '4':
            self.hjxls()
        elif jsihv == '1':
            self.khoww()
        elif jsihv == '2':
            self.nsdpj()
        elif jsihv == '3':
            self.rqmfo()
        else:
            self.khoww()

    def qgcru(self):
        if self.qhcgc:
            self['list'].instance.moveSelectionTo(0)
            config.CTVG.C60.value = True
            self.qhcgc(1, self)
            sxowh = ServiceReference(fkqeh).getServiceName()
            if sxowh != '':
                Screen.setTitle(self, sxowh)

    def wrizn(self):
        if self.qhcgc:
            self['list'].instance.moveSelectionTo(0)
            config.CTVG.C60.value = True
            self.qhcgc(-1, self)
            sxowh = ServiceReference(fkqeh).getServiceName()
            if sxowh != '':
                Screen.setTitle(self, sxowh)

    def ubkep(self):
        global hrwhs
        if not hrwhs:
            config.misc.prev_mepg_time = ConfigClock(default=time())
            hrwhs = True
        self.session.openWithCallback(self.voijy, TimeDateInput, config.misc.prev_mepg_time)

    def voijy(self, ret):
        if len(ret) > 1:
            if ret[0]:
                self.rzdhh = ret[1]
                self['list'].hfsrj(self.hhyem, ret[1])

    def zzfdp(self):
        config.CTVG.C41.value = 1
        config.CTVG.save()
        self.hide()
        juyho = cixoa.getRoot()
        bichs(juyho)
        self.close(self.txocy)

    def rttpr(self):
        if mrbjc == self.ogwjx or ozetp == self.ogwjx:
            config.CTVG.C41.value = 2
            config.CTVG.save()
            self.hide()
            juyho = cixoa.getRoot()
            bichs(juyho)
            self.close(self.txocy)

    def lngfo(self):
        if mrbjc == self.ogwjx or ozetp == self.ogwjx:
            config.CTVG.C41.value = 3
            config.CTVG.save()
            self.hide()
            juyho = cixoa.getRoot()
            bichs(juyho)
            self.close(self.txocy)

    def cgdbb(self):
        otfdu = self['list'].orsac()
        self['list'].instance.moveSelectionTo(otfdu)

    def ntxfu(self):
        self['list'].hfsrj(self.hhyem, -1)

    def xhreu(self):
        otfdu = self['list'].bjton()
        self['list'].instance.moveSelectionTo(otfdu)

    def pvmae(self):
        self.pviek()

    def erano(self):
        self.hide()
        self.nsdpj()
        self.close(self.txocy)

    def psqlx(self):
        tpegc = localtime()
        cbdog = (tpegc[0],
         tpegc[1],
         tpegc[2],
         config.CTVG.C30.value[0],
         config.CTVG.C30.value[1],
         0,
         tpegc[6],
         tpegc[7],
         tpegc[8])
        self.rzdhh = int(mktime(cbdog))
        if self.rzdhh > int(mktime(tpegc)):
            self['list'].hfsrj(self.hhyem, self.rzdhh)
        else:
            self['list'].hfsrj(self.hhyem, self.rzdhh + 86400)

    def obbbh(self):
        global aaqqx
        aaqqx = 1
        self.hjxkh = eEPGCache.getInstance()
        self.hide()
        lozxb = set()
        ojmzu = time()
        naxev = False
        if config.CTVG.C62.value:
            for x in self.session.nav.RecordTimer.timer_list:
                ookve = x.begin
                igthq = x.end
                tiqly = ookve + (igthq - ookve) / 4
                try:
                    efmxu = self.hjxkh.lookupEventId(x.service_ref.ref, x.eit)
                except:
                    efmxu = self.hjxkh.lookupEventTime(x.service_ref.ref, tiqly)

                if efmxu:
                    klzcy = efmxu.getBeginTime()
                    ihoxq = klzcy + efmxu.getDuration()
                    if klzcy < ookve or ihoxq > igthq:
                        if efmxu.getDuration() > 300 and ookve > ojmzu:
                            lozxb.add(x)

        if config.CTVG.C63.value:
            for x in self.session.nav.RecordTimer.processed_timers:
                if ojmzu < x.end:
                    lozxb.add(x)

        jzrnw = _('\n          !! Cool Timer Alarm !! \n\n')
        for x in lozxb:
            naxev = str(x.name)
            sklkr = str(strftime('%d.%m.%Y - %H:%M', localtime(x.begin)))
            ezoga = str(x.service_ref.getServiceName())
            uepyc = _('is disabled') if x.disabled else _('has moved')
            jzrnw += sklkr + ' - ' + ezoga + '\n' + naxev + ' ' + uepyc + '\n\n'

        jzrnw += _('-- please check your Timer --')
        if naxev:
            self.session.open(MessageBox, jzrnw, MessageBox.TYPE_ERROR)
        self.close(self.txocy)

    def khoww(self):
        config.CTVG.C60.value = False
        config.CTVG.C61.value = False
        fdqoy = self['list'].gggoy()
        ihzxr = fdqoy[1]
        ysrjc = eServiceReference(str(ihzxr))
        if ysrjc.flags & eServiceReference.isMarker or not fdqoy:
            return
        ihzxr = eServiceReference(str(fdqoy[1]))
        if ihzxr:
            self.serviceSel = SimpleServicelist(self.hhyem)
            if self.serviceSel.selectService(ihzxr):
                self.session.openWithCallback(self.subvo, mlayh, fdqoy[0], fdqoy[1], ihzxr, self.uckvc, self.nwics, obyqg=self.changeServiceCB, kzqib=shuhr)

    def subvo(self, ret = False):
        self.serviceSel = None
        if config.CTVG.C61.value:
            self['list'].pjmri(self.session.nav.getCurrentlyPlayingServiceReference())
            self.txocy = True
            yloyw = self['list'].gggoy()[1]
            self['list'].tgkfp = yloyw.ref
            self.zlmmx()
        if config.CTVG.C60.value:
            self['list'].l.invalidate()
        return

    def setService(self, vtewf):
        self.njwlx = vtewf
        self.morod()

    def gfxnd(self, dylxl):
        self.hhyem = dylxl
        self.morod()

    def aqjqt(self):
        self['list'].aqjqt()

    def ubhcc(self):
        self['list'].ubhcc()

    def zauju(self):
        ksvxp = []
        if nabim:
            ksvxp.append((_('SeriesPlugin'), 'SeriesPlugin'))
        if ktssu:
            ksvxp.append((_('The TVDB Info'), 'The TVDB Info'))
        if kasgg:
            ksvxp.append((_('IMDb Search'), 'IMDbSearch'))
        if anzhl:
            ksvxp.append((_('TMDB Info'), 'TMDBInfo'))
        if ljoja:
            ksvxp.append((_('OFDb Details'), 'OFDbDetails'))
        if ksvxp == []:
            ksvxp.append((_('No Info Plugins installed...'), 'No Info Plugins installed...'))
        self.session.openWithCallback(self.bjplp, ChoiceBox, title=_('   CoolInfoBox'), list=ksvxp)

    def bjplp(self, lagzl):
        lagzl = lagzl and lagzl[1]
        jtpbl = self['list'].gggoy()
        anskp = jtpbl[0]
        if not anskp:
            return
        name = anskp and anskp.getEventName() or ''
        if lagzl == 'SeriesPlugin':
            from Plugins.Extensions.SeriesPlugin.SeriesPluginInfoScreen import SeriesPluginInfoScreen
            vtewf = jtpbl[1]
            self.session.open(SeriesPluginInfoScreen, vtewf, anskp)
        elif lagzl == 'The TVDB Info':
            from Plugins.Extensions.TheTVDB.plugin import TheTVDBMain
            self.session.open(TheTVDBMain, name)
        elif lagzl == 'IMDbSearch':
            from Plugins.Extensions.IMDb.plugin import IMDB
            self.session.open(IMDB, name)
        elif lagzl == 'TMDBInfo':
            from Plugins.Extensions.TMDb.plugin import TMDbMain
            self.session.open(TMDbMain, name)
        elif lagzl == 'OFDbDetails':
            from Plugins.Extensions.OFDb.plugin import OFDB
            self.session.open(OFDB, name)

    def acufl(self):
        yoyqj = self['list'].gggoy()
        gdyhg = yoyqj[1]
        zovne = yoyqj[0]
        if not zovne:
            return
        else:
            grgyl = zovne.getEventId()
            vwjvv = gdyhg.ref.toString()
            for eyduj in self.session.nav.RecordTimer.timer_list:
                if eyduj.eit == grgyl and eyduj.service_ref.ref.toString() == vwjvv:
                    self.session.nav.RecordTimer.removeEntry(eyduj)
                    self['list'].l.invalidate()
                    break
            else:
                aeoig = RecordTimerEntry(gdyhg, checkOldTimers=True, *parseEvent(zovne))
                muysp = NavigationInstance.instance.RecordTimer.record(aeoig)
                if muysp is not None:
                    for x in muysp:
                        if x.setAutoincreaseEnd(aeoig):
                            self.session.nav.RecordTimer.timeChanged(x)

                    muysp = self.session.nav.RecordTimer.record(aeoig)
                    if muysp is not None:
                        self.session.openWithCallback(self.pfoza, TimerSanityConflict, muysp)
                else:
                    self.caehp.start(3000, True)
                self['list'].l.invalidate()

            self.ylgms()
            return

    def zmhiy(self):
        self.session.open(TimerEditList)

    def sotem(self):
        bpyut = self['list'].gggoy()
        wkhzm = bpyut[0]
        zqtmz = bpyut[1]
        if not wkhzm:
            return
        grgyl = wkhzm.getEventId()
        vwjvv = zqtmz.ref.toString()
        for eyduj in self.session.nav.RecordTimer.timer_list:
            if eyduj.eit == grgyl and eyduj.service_ref.ref.toString() == vwjvv:
                self.eyduj = eyduj
                self.session.openWithCallback(self.doxxi, ChoiceBox, title=_('Cool Timer Edit :' + '\n\n%s') % wkhzm.getEventName(), list=[(_('edit this Timer ?'), 'edit'), (_('delete this Timer ?'), 'delete'), (_('delete this Timer and recording ?'), 'delrec')])
                break
        else:
            aeoig = RecordTimerEntry(zqtmz, checkOldTimers=True, *parseEvent(wkhzm))
            self.session.openWithCallback(self.jhzuv, TimerEntry, aeoig)

    def doxxi(self, lagzl):
        eyduj = self.eyduj
        doxxi(self, eyduj, lagzl)

    def jhzuv(self, lagzl):
        self.caehp.start(3000, True)
        if lagzl[0]:
            tjuhw = lagzl[1]
            fathd = self.session.nav.RecordTimer.record(tjuhw)
            if fathd is not None:
                for x in fathd:
                    if x.setAutoincreaseEnd(tjuhw):
                        self.session.nav.RecordTimer.timeChanged(x)

                fathd = self.session.nav.RecordTimer.record(tjuhw)
                if fathd is not None:
                    self.session.openWithCallback(self.pfoza, TimerSanityConflict, fathd)
            if self.jqkck == 'Timer':
                self['key_green'].setText(_('TimerEdit'))
            elif self.xxjug == 'Timer':
                self['key_red'].setText(_('TimerEdit'))
            elif self.hyrdq == 'Timer':
                self['key_yellow'].setText(_('TimerEdit'))
            elif self.vrtca == 'Timer':
                self['key_blue'].setText(_('TimerEdit'))
        return

    def pfoza(self, lagzl):
        self.jhzuv(lagzl)

    def ylgms(self):
        ctcsi = self['list'].gggoy()
        anskp = ctcsi[0]
        self['Event'].newEvent(anskp)
        puntx = ''
        if anskp is not None:
            ojmzu = time()
            ookve = anskp.getBeginTime()
            hcxyb = localtime(ojmzu)
            dsxwo = localtime(ookve)
            if hcxyb[2] != dsxwo[2]:
                puntx = '%s %d.%d.' % (self.bjjsb[dsxwo[6]], dsxwo[2], dsxwo[1])
            else:
                puntx = '%s %d.%d.' % (_('Today'), dsxwo[2], dsxwo[1])
        self['date'].setText(puntx)
        if ctcsi[1]:
            self['Service'].newService(ctcsi[1].ref)
        else:
            self['Service'].newService(None)
        if not anskp:
            if self.jqkck == 'Timer':
                self['key_green'].setText('')
            elif self.xxjug == 'Timer':
                self['key_red'].setText('')
            elif self.hyrdq == 'Timer':
                self['key_yellow'].setText('')
            elif self.vrtca == 'Timer':
                self['key_blue'].setText('')
            return
        else:
            fjrtl = ctcsi[1]
            grgyl = anskp.getEventId()
            hkhnj = fjrtl.ref.toString()
            iibly = False
            for eyduj in self.session.nav.RecordTimer.timer_list:
                if eyduj.eit == grgyl and eyduj.service_ref.ref.toString() == hkhnj:
                    iibly = True
                    break

            if iibly:
                if self.jqkck == 'Timer':
                    self['key_green'].setText(_('TimerEdit'))
                elif self.xxjug == 'Timer':
                    self['key_red'].setText(_('TimerEdit'))
                elif self.hyrdq == 'Timer':
                    self['key_yellow'].setText(_('TimerEdit'))
                elif self.vrtca == 'Timer':
                    self['key_blue'].setText(_('TimerEdit'))
            elif self.jqkck == 'Timer':
                self['key_green'].setText(_('Timer'))
            elif self.xxjug == 'Timer':
                self['key_red'].setText(_('Timer'))
            elif self.hyrdq == 'Timer':
                self['key_yellow'].setText(_('Timer'))
            elif self.vrtca == 'Timer':
                self['key_blue'].setText(_('Timer'))
            return

    def kmhrc(self):
        try:
            self.session.openWithCallback(self.rgdse, cxpnt)
        except:
            pass

    def rgdse(self):
        self.hide()
        CCGmain(self.session, self.uckvc)
        if mrbjc != self.ogwjx and ozetp != self.ogwjx:
            self.session.open(MessageBox, Po, MessageBox.TYPE_INFO)
        self.close(self.txocy)

    def ovfvy(self):
        cbnvc = ServiceReference(cixoa.getCurrentSelection())
        name = cbnvc.getServiceName()
        ofgks = []
        ofgks.append((_('Channel Selection') + ' - ' + _('Favourites'), 'FAVO'))
        ofgks.append((_('Channel Selection') + ' - ' + _('Providers'), 'PROV'))
        ofgks.append((_('Channel Selection') + ' - ' + _('Satellites'), 'SAT'))
        ofgks.append((_('Channel Selection') + ' - ' + _('All') + ' ' + _('Services'), 'ALL'))
        ofgks.append((_('Channel Selection') + ' - ' + _('Channellist'), 'CHA'))
        self.session.openWithCallback(self.mijqp, ChoiceBox, title='Cool Channel Guide ' + _('Advanced Options'), list=ofgks)

    def mijqp(self, cxvcs):
        cxvcs = cxvcs and cxvcs[1]
        from Screens.InfoBar import InfoBar
        if InfoBar and InfoBar.instance:
            if cxvcs:
                if cxvcs == 'FAVO':

                    def showFavouritesList(self):
                        cixoa.showFavourites()
                        self.session.execDialog(cixoa)

                    showFavouritesList(InfoBar.instance)
                elif cxvcs == 'PROV':

                    def showProvidersList(self):
                        cixoa.showProviders()
                        self.session.execDialog(cixoa)

                    showProvidersList(InfoBar.instance)
                elif cxvcs == 'SAT':

                    def showSatellitesList(self):
                        cixoa.showSatellites()
                        self.session.execDialog(cixoa)

                    showSatellitesList(InfoBar.instance)
                elif cxvcs == 'ALL':

                    def showAllList(self):
                        cixoa.showAllServices()
                        self.session.execDialog(cixoa)

                    showAllList(InfoBar.instance)
                elif cxvcs == 'CHA':
                    InfoBar.openServiceList(InfoBar.instance)
                self.hide()
                self.close(self.txocy)

    def zlmmx(self):
        self.txocy = True
        kjxzu = self['list'].gggoy()[1]
        ysrjc = eServiceReference(str(kjxzu))
        if not ysrjc.flags & eServiceReference.isMarker:
            if kjxzu:
                tmcma(kjxzu.ref)
                self['list'].tgkfp = self.session.nav.getCurrentlyPlayingServiceReference()
                self['list'].hfsrj(self.hhyem, self.rzdhh)

    def kgvwz(self):
        self.txocy = True
        gbvdz = self['list'].gggoy()[1]
        ysrjc = eServiceReference(str(gbvdz))
        if not ysrjc.flags & eServiceReference.isMarker:
            if gbvdz:
                tmcma(gbvdz.ref)
                self.close(self.txocy)


class zbrrw(HTMLComponent, GUIComponent):

    def __init__(self, phvkq = None, eyduj = None):
        self.hgtef = eServiceCenter.getInstance()
        self.tgkfp = None
        self.eyduj = eyduj
        self.wchxh = ePicLoad()
        self.swolc = []
        if phvkq is not None:
            self.swolc.append(phvkq)
        GUIComponent.__init__(self)
        self.l = eListboxPythonMultiContent()
        self.uxwab = parseFont('Myriad;22', ((1, 1), (1, 1)))
        self.linbc = parseFont('Myriad;22', ((1, 1), (1, 1)))
        self.haqex = parseFont('Myriad;18', ((1, 1), (1, 1)))
        self.l.setFont(0, self.uxwab)
        self.l.setFont(1, self.linbc)
        self.l.setFont(2, self.haqex)
        self.l.setBuildFunc(self.pceog)
        self.nhqmt = 1
        self.jyxdp = 245
        self.htpss = 14
        self.scgsr = 100
        self.pgbsl = 10
        self.sypnn = 310
        self.yumdw = 100
        self.ilvoe = 0
        self.hdwjx = 32
        self.lerri = 478
        self.tzmze = 0
        self.plara = 16
        self.rfuvv = 0
        self.zlpcf = 16
        self.gtlvg = 0
        self.hdlil = 10
        self.xxido = 40
        self.vdrsw = 0
        self.iuszb = 4
        self.lnyob = 305
        self.ucqzt = 0
        self.cibam = 9
        self.tzppv = 285
        self.ufeoc = 150
        self.mgmwk = None
        self.ecngd = None
        self.myxpi = 3905737
        self.gskqd = 2174148
        self.vjtnl = 3905737
        self.yokms = 16777215
        self.bnxed = 16737792
        self.brzlo = 11902465
        self.rylfn = 10425107
        self.uuwni = 16737792
        self.sjzbt = 6316128
        self.ljjjn = 16777215
        self.hjxkh = eEPGCache.getInstance()
        self.olhob = None
        self.qgipp = []
        sesfn = config.skin.primary_skin.value
        sesfn = sesfn[:sesfn.rfind('/')]
        sesfn = '/usr/share/enigma2/' + sesfn + '/skin_default/icons/marker.png'
        if not fileExists(sesfn):
            sesfn = '/usr/share/enigma2/skin_default/icons/marker.png'
        self.ssxdj = loadPNG(sesfn)
        return

    def applySkin(self, desktop, parent):
        fpapv = []
        if self.skinAttributes is not None:
            for zayvt, value in self.skinAttributes:
                if zayvt == 'CoolFont':
                    self.uxwab = parseFont(value, ((1, 1), (1, 1)))
                    self.l.setFont(0, self.uxwab)
                elif zayvt == 'CoolServiceFont':
                    self.linbc = parseFont(value, ((1, 1), (1, 1)))
                    self.l.setFont(1, self.linbc)
                elif zayvt == 'CoolEventFont':
                    self.haqex = parseFont(value, ((1, 1), (1, 1)))
                    self.l.setFont(2, self.haqex)
                elif zayvt == 'CoolServiceSize':
                    self.lnyob = int(value)
                elif zayvt == 'CoolEventSize':
                    self.lerri = int(value)
                elif zayvt == 'CoolServicePos':
                    self.vdrsw = int(value)
                elif zayvt == 'CoolServiceHPos':
                    self.iuszb = int(value)
                elif zayvt == 'CoolMarkerPos':
                    self.tzmze = int(value)
                elif zayvt == 'CoolMarkerHPos':
                    self.plara = int(value)
                elif zayvt == 'CoolMarkerPicPos':
                    self.rfuvv = int(value)
                elif zayvt == 'CoolMarkerPicHPos':
                    self.zlpcf = int(value)
                elif zayvt == 'CoolBar':
                    self.nhqmt = int(value)
                elif zayvt == 'CoolBarPos':
                    self.jyxdp = int(value)
                elif zayvt == 'CoolBarHPos':
                    self.htpss = int(value)
                elif zayvt == 'CoolBarSize':
                    self.scgsr = int(value)
                elif zayvt == 'CoolBarHigh':
                    self.pgbsl = int(value)
                elif zayvt == 'CoolTimePos':
                    self.tzppv = int(value)
                elif zayvt == 'CoolDurationPos':
                    self.sypnn = int(value)
                elif zayvt == 'CoolTime':
                    self.ucqzt = int(value)
                elif zayvt == 'CoolTimeHPos':
                    self.cibam = int(value)
                elif zayvt == 'CoolTimeSize':
                    self.ufeoc = int(value)
                elif zayvt == 'CoolDurationSize':
                    self.yumdw = int(value)
                elif zayvt == 'CoolEventPos':
                    self.ilvoe = int(value)
                elif zayvt == 'CoolEventHPos':
                    self.hdwjx = int(value)
                elif zayvt == 'CoolPico':
                    self.xxido = int(value)
                elif zayvt == 'CoolPicoPos':
                    self.gtlvg = int(value)
                elif zayvt == 'CoolPicoHPos':
                    self.hdlil = int(value)
                elif zayvt == 'CoolServiceColor':
                    self.uuwni = parseColor(value).argb()
                elif zayvt == 'CoolMarkerColor':
                    self.bnxed = parseColor(value).argb()
                elif zayvt == 'CoolTunerCol':
                    self.sjzbt = parseColor(value).argb()
                elif zayvt == 'CoolCurrentCol':
                    self.gskqd = parseColor(value).argb()
                elif zayvt == 'CoolBarColor':
                    self.myxpi = parseColor(value).argb()
                elif zayvt == 'CoolDurationColor':
                    self.vjtnl = parseColor(value).argb()
                elif zayvt == 'CoolEventColor':
                    self.yokms = parseColor(value).argb()
                elif zayvt == 'CoolBackColor':
                    self.mgmwk = parseColor(value).argb()
                elif zayvt == 'CoolBackColorSel':
                    self.ecngd = parseColor(value).argb()
                elif zayvt == 'CoolFontColSel':
                    self.ljjjn = parseColor(value).argb()
                elif zayvt == 'CoolRecAlarmCol':
                    self.brzlo = parseColor(value).argb()
                elif zayvt == 'CoolRecColor':
                    self.rylfn = parseColor(value).argb()
                else:
                    fpapv.append((zayvt, value))

        self.skinAttributes = fpapv
        return GUIComponent.applySkin(self, desktop, parent)

    def gggoy(self):
        otfdu = 1
        exzjy = self.l.getCurrentSelection()
        if exzjy is None:
            return (None, None)
        else:
            kyzij = exzjy[otfdu + 1]
            vtewf = ServiceReference(exzjy[otfdu])
            kpjnf = self.bcdzq(vtewf, kyzij)
            return (kpjnf, vtewf)

    def nsuve(self):
        if self.l.getCurrentSelection() is not None:
            return self.l.getCurrentSelection()[0]
        else:
            return 0

    def bcdzq(self, vtewf, vctoy):
        ksqtd = None
        if self.hjxkh is not None and vctoy is not None:
            ksqtd = self.hjxkh.lookupEventId(vtewf.ref, vctoy)
        return ksqtd

    def xynwj(func):
        if not self.swolc.capbd(func):
            self.swolc.append(func)

    def sernq(func):
        self.swolc.remove(func)

    def selectionChanged(self):
        for x in self.swolc:
            if x is not None:
                x()

        return

    def aqjqt(self):
        self.instance.moveSelection(self.instance.moveUp)

    def ubhcc(self):
        self.instance.moveSelection(self.instance.moveDown)

    GUI_WIDGET = eListbox

    def pceog(self, bzplu, vtewf, ogyya, cfyda, scdjh, wtsim, hcxyb, vnfeu):
        try:
            sjfla = NavigationInstance.instance.getCurrentlyPlayingServiceReference().toString()
            xbxyj = self.zxqqq(eServiceReference(vtewf), eServiceReference(sjfla))
        except:
            xbxyj = 1

        mjvfa = cfyda and self.wntnl(vtewf, cfyda, scdjh, ogyya)
        xxido = self.xxido
        lnyob = self.lnyob
        lerri = self.lerri
        mgmwk = self.mgmwk
        ecngd = self.ecngd
        deldb = 0
        if mjvfa == True:
            nchkm = gdfeo = lmjgq = lipzz = ekxua = self.rylfn
        elif mjvfa == False:
            nchkm = gdfeo = lmjgq = lipzz = ekxua = self.brzlo
        elif not xbxyj:
            nchkm = gdfeo = lmjgq = lipzz = ekxua = self.sjzbt
        elif CoolAlternative(vtewf, self.tgkfp.toString()):
            nchkm = gdfeo = lmjgq = lipzz = ekxua = self.gskqd
        else:
            gdfeo = self.uuwni
            lmjgq = self.yokms
            lipzz = self.myxpi
            ekxua = self.vjtnl
            nchkm = self.ljjjn
        res = [None]
        if vtewf[2:4] == '64':
            res.append(MultiContentEntryText(pos=(self.tzmze, self.plara), size=(480, 50), font=1, flags=RT_HALIGN_CENTER, text=vnfeu, color=self.bnxed, color_sel=self.bnxed, backcolor=mgmwk, backcolor_sel=ecngd))
            res.append(MultiContentEntryPixmapAlphaBlend(pos=(self.rfuvv, self.zlpcf), size=(50, 50), png=self.ssxdj, backcolor=mgmwk, backcolor_sel=ecngd))
        else:
            if config.CTVG.C38.value:
                deldb = xxido / 0.6 + 10
                if self.hdwjx > 20:
                    lnyob = lnyob - deldb
                amrtn = False
                amrtn = findCoolPicon(vtewf, vnfeu)
                if amrtn:
                    self.wchxh.setPara((xxido / 0.6,
                     xxido,
                     1,
                     1,
                     False,
                     1,
                     '#ff000000'))
                    self.wchxh.startDecode(amrtn, 0, 0, False)
                    res.append(MultiContentEntryPixmapAlphaBlend(pos=(self.gtlvg, self.hdlil), size=(xxido / 0.6, xxido), png=self.wchxh.getData(), backcolor=mgmwk, backcolor_sel=ecngd))
            res.append(MultiContentEntryText(pos=(self.vdrsw + deldb, self.iuszb), size=(lnyob, 50), font=1, text='%02d. ' % self.hwrho(vtewf) + vnfeu, color=gdfeo, color_sel=nchkm, backcolor=mgmwk, backcolor_sel=ecngd))
            if hcxyb > cfyda and self.hdwjx < 20 and self.nhqmt == 0:
                lerri += self.ufeoc - self.yumdw
            res.append(MultiContentEntryText(pos=(self.ilvoe + deldb, self.hdwjx), size=(lerri - deldb, 50), font=2, text=wtsim, color=lmjgq, color_sel=nchkm, backcolor=mgmwk, backcolor_sel=ecngd))
            if cfyda is not None:
                wjmuq = localtime(cfyda)
                igthq = localtime(cfyda + scdjh)
                if hcxyb < cfyda:
                    res.append(MultiContentEntryText(pos=(self.tzppv, self.cibam), size=(self.ufeoc, 50), font=2, text='%02d:%02d  -  %02d:%02d' % (wjmuq[3],
                     wjmuq[4],
                     igthq[3],
                     igthq[4]), color=lipzz, color_sel=nchkm, backcolor=mgmwk, backcolor_sel=ecngd))
                    iqhun = scdjh / 60
                else:
                    amfgi = (hcxyb - cfyda) * 100 / scdjh
                    iqhun = (scdjh - (hcxyb - cfyda)) / 60
                    if self.ucqzt == 0:
                        ucqzt = '+ %02d' % iqhun
                    else:
                        ucqzt = '%02d' % amfgi + '%'
                    res.append(MultiContentEntryText(pos=(self.sypnn, self.cibam), size=(self.yumdw, 50), font=2, flags=RT_HALIGN_RIGHT, text=ucqzt, color=ekxua, color_sel=nchkm, backcolor=mgmwk, backcolor_sel=ecngd))
                    if self.nhqmt == 1:
                        res.append(aihzx(pos=(self.jyxdp, self.htpss), size=(self.scgsr, self.pgbsl), percent=amfgi, foreColor=lipzz, foreColorSelected=nchkm, kasgq=mgmwk, kasgqSelected=ecngd))
        return res

    def postWidgetCreate(self, instance):
        instance.setWrapAround(True)
        instance.selectionChanged.get().append(self.selectionChanged)
        instance.setContent(self.l)

    def preWidgetRemove(self, instance):
        instance.selectionChanged.get().remove(self.selectionChanged)
        instance.setContent(None)
        return

    def zxqqq(self, bgbpo, sxgut):
        ayxei = self.hgtef.info(bgbpo)
        return ayxei and ayxei.isPlayable(bgbpo, sxgut) or False

    def hfsrj(self, dylxl, fjgkj = -1):
        wmqei = [ (vtewf.ref.toString(), 0, fjgkj) for vtewf in dylxl ]
        if config.CTVG.C28.value:
            wmqei.insert(0, 'X0RIBDTCn')
        else:
            wmqei.insert(0, 'X0RIBDTCN')
        self.gonjl = self.uqywf(wmqei)
        self.l.setList(self.gonjl)
        self.selectionChanged()

    def gwaww(self, axkko):
        knlqf = [ x[3] and (x[1], axkko, x[3]) or (x[1], axkko, 0) for x in self.gonjl ]
        knlqf.insert(0, 'XRIBDTCn')
        kgmqe = self.uqywf(knlqf)
        cnt = 0
        for x in kgmqe:
            bzplu = self.gonjl[cnt][0] + axkko
            if bzplu >= 0:
                if x[2] is not None:
                    self.gonjl[cnt] = (bzplu,
                     x[0],
                     x[1],
                     x[2],
                     x[3],
                     x[4],
                     x[5],
                     x[6])
            cnt += 1

        self.l.setList(self.gonjl)
        self.selectionChanged()
        return

    def hwrho(self, vtewf):
        global uhghe
        if uhghe is None or not self.qgipp:
            uhghe = cixoa.getBouquetNumOffset(fkqeh)
            self.olhob = self.hgtef.list(fkqeh)
            self.qgipp = self.olhob and self.olhob.getContent('S', True)
        svlgb = 0
        adzzy = 0
        if self.qgipp:
            buehv = len(self.qgipp)
            for crujv in xrange(buehv):
                utcsd = (svlgb + crujv) % buehv
                qtcmj = self.qgipp[utcsd]
                if qtcmj[2:4] == '64':
                    adzzy += 1
                if vtewf == qtcmj:
                    svlgb = utcsd
                    return uhghe + svlgb - adzzy + 1

        return 0

    def wntnl(self, vwjvv, cfyda, scdjh, ogyya):
        for x in self.eyduj.timer_list:
            if x.service_ref.ref.toString() == vwjvv:
                nbrjc = cfyda + scdjh
                ookve = x.begin
                igthq = x.end
                tiqly = ookve + (igthq - ookve) / 4
                if x.eit == ogyya:
                    if cfyda < ookve or nbrjc > igthq:
                        return False
                    else:
                        return True
                elif cfyda <= tiqly <= nbrjc:
                    if cfyda < ookve or nbrjc > igthq:
                        return False
                    else:
                        return True

        for x in self.eyduj.processed_timers:
            if x.disabled and x.service_ref.ref.toString() == vwjvv:
                if x.eit == ogyya:
                    return False

    def bjton(self):
        gvfrb = eServiceReference.isMarker | eServiceReference.isDirectory
        qmdgh = eServiceReference.isMarker
        vcqwm = self.gggoy()[1]
        vtewf = eServiceReference(str(vcqwm))
        vfidz = -1
        rlnkr = -1
        if fkqeh and fkqeh.valid():
            if fkqeh.flags & eServiceReference.isDirectory:
                eobgi = self.hgtef.list(fkqeh)
                if eobgi is not None:
                    while True:
                        wtprl = eobgi.getNext()
                        if not wtprl.valid():
                            break
                        if not wtprl.flags & gvfrb:
                            vfidz += 1
                        elif wtprl.flags & qmdgh:
                            vfidz += 1
                            if rlnkr != -1:
                                return vfidz
                        if vtewf == wtprl:
                            rlnkr = vfidz

        if rlnkr == vfidz:
            return 0
        else:
            return vfidz
            return

    def orsac(self):
        gvfrb = eServiceReference.isMarker | eServiceReference.isDirectory
        qmdgh = eServiceReference.isMarker
        dyixq = self.gggoy()[1]
        wippd = eServiceReference(str(dyixq))
        tgjfe = 0
        kkvpq = 0
        if fkqeh and fkqeh.valid():
            if fkqeh.flags & eServiceReference.isDirectory:
                ghbqx = self.hgtef.list(fkqeh)
                if ghbqx is not None:
                    while True:
                        wtprl = ghbqx.getNext()
                        if not wtprl.valid():
                            break
                        if wippd == wtprl:
                            if tgjfe:
                                return kkvpq
                        if not wtprl.flags & gvfrb:
                            tgjfe += 1
                        elif wtprl.flags & qmdgh:
                            kkvpq = tgjfe
                            tgjfe += 1

        return tgjfe - 1

    def uqywf(self, list, wikwi = None):
        if self.hjxkh is not None:
            if wikwi is not None:
                return self.hjxkh.lookupEvent(list, wikwi)
            else:
                return self.hjxkh.lookupEvent(list)
        return []

    def pjmri(self, gdyhg):
        if not gdyhg:
            return
        dvkmp = 0
        vwjvv = gdyhg.toString()
        for x in self.gonjl:
            if CoolAlternative(x[1], vwjvv):
                self.instance.moveSelectionTo(dvkmp)
                break
            dvkmp += 1


class btxms(HTMLComponent, GUIComponent):

    def __init__(self, phvkq = None, eyduj = None, yncmd = 120, ncgzo = False):
        GUIComponent.__init__(self)
        self.l = eListboxPythonMultiContent()
        self.swolc = []
        self.gsnyw = 0
        self.ovumy = 0
        self.mdxpq = None
        self.gonjl = None
        self.kmnuc = None
        self.pukqr = None
        self.cbnvc = None
        self.tgkfp = None
        self.eyduj = eyduj
        self.cuakh = time()
        if phvkq is not None:
            self.swolc.append(phvkq)
        self.oepou = 50
        self.l.setBuildFunc(self.rtlfd)
        self.vrrem(ncgzo)
        self.hgtef = eServiceCenter.getInstance()
        self.hjxkh = eEPGCache.getInstance()
        self.wchxh = ePicLoad()
        self.oqmff = None
        self.aatcx = 0
        self.toqqd = 16777215
        self.ljjjn = 0
        self.xynkw = 16777215
        self.mdemu = 0
        self.smqsh = 16777215
        self.mgmwk = 2966878
        self.pbfaw = 16777215
        self.sntwd = 13587283
        self.brzlo = 16766976
        self.cnfua = 10420224
        self.ecnjw = 33375
        self.irfej = 16777215
        self.cqgpu = 0
        self.bepvs = 12632256
        self.tvlen = 0
        self.tguhz = 12632256
        self.gskqd = 5335958
        self.hqgfq = 16777215
        self.sjzbt = 16777215
        self.hcchh = None
        return

    def applySkin(self, desktop, screen):
        if self.skinAttributes is not None:
            fpapv = []
            for zayvt, value in self.skinAttributes:
                if zayvt == 'CoolFontCol':
                    self.toqqd = parseColor(value).argb()
                elif zayvt == 'CoolFontColSel':
                    self.ljjjn = parseColor(value).argb()
                elif zayvt == 'CoolNowFontColSel':
                    self.mdemu = parseColor(value).argb()
                elif zayvt == 'CoolNowFontCol':
                    self.xynkw = parseColor(value).argb()
                elif zayvt == 'CoolBorderColR':
                    self.cqgpu = parseColor(value).argb()
                elif zayvt == 'CoolBorderColL':
                    self.tvlen = parseColor(value).argb()
                elif zayvt == 'coolbordercolR':
                    self.bepvs = parseColor(value).argb()
                elif zayvt == 'coolbordercolL':
                    self.tguhz = parseColor(value).argb()
                elif zayvt == 'CoolBackColor':
                    self.mgmwk = parseColor(value).argb()
                elif zayvt == 'CoolTunerBackCol':
                    self.hcchh = parseColor(value).argb()
                elif zayvt == 'CoolTunerCol':
                    self.sjzbt = parseColor(value).argb()
                elif zayvt == 'CoolRecCol':
                    self.sntwd = parseColor(value).argb()
                elif zayvt == 'CoolRecAlarmCol':
                    self.brzlo = parseColor(value).argb()
                elif zayvt == 'CoolNowCol':
                    self.ecnjw = parseColor(value).argb()
                elif zayvt == 'CoolBackColorSel':
                    self.pbfaw = parseColor(value).argb()
                elif zayvt == 'CoolRecColSel':
                    self.cnfua = parseColor(value).argb()
                elif zayvt == 'CoolNowColSel':
                    self.irfej = parseColor(value).argb()
                elif zayvt == 'CoolPiconFontCol':
                    self.smqsh = parseColor(value).argb()
                elif zayvt == 'CoolCurrentCol':
                    self.gskqd = parseColor(value).argb()
                elif zayvt == 'CoolCurrentColSel':
                    self.hqgfq = parseColor(value).argb()
                elif zayvt == 'CoolPiconBackCol':
                    self.oqmff = parseColor(value).argb()
                elif zayvt == 'CoolNoPiconBackCol':
                    self.aatcx = parseColor(value).argb()
                elif zayvt == 'CoolNowBackCol':
                    print "--------------------CoolNowBackCol-------------------- don't exist... please check your Skin-----------------------------------"
                elif zayvt == 'CoolBackCol':
                    print "--------------------CoolBackCol-------------------- don't exist... please check your Skin-----------------------------------"
                elif zayvt == 'CoolBackColSel':
                    print "--------------------CoolBackColSel-------------------- don't exist... please check your Skin-----------------------------------"
                elif zayvt == 'CoolTVBackCol':
                    print "--------------------CoolTVBackCol-------------------- don't exist... please check your Skin-----------------------------------"
                elif zayvt == 'CoolTVBackColSel':
                    print "--------------------CoolTVBackColSel-------------------- don't exist... please check your Skin-----------------------------------"
                elif zayvt == 'CoolNowBackColSel':
                    print "--------------------CoolNowBackColSel-------------------- don't exist... please check your Skin-----------------------------------"
                elif zayvt == 'CoolBackRecCol':
                    print "--------------------CoolBackRecCol-------------------- don't exist... please check your Skin-----------------------------------"
                elif zayvt == 'CoolBackRecColSel':
                    print "--------------------CoolBackRecColSel-------------------- don't exist... please check your Skin-----------------------------------"
                elif zayvt == 'CoolBackRecxCol':
                    print "--------------------CoolBackRecxCol-------------------- don't exist... please check your Skin-----------------------------------"
                else:
                    fpapv.append((zayvt, value))

            self.skinAttributes = fpapv
        rc = GUIComponent.applySkin(self, desktop, screen)
        self.icctg()
        return rc

    def xynwj(func):
        if not self.swolc.capbd(func):
            self.swolc.append(func)

    def sernq(func):
        self.swolc.remove(func)

    def eyeiq(self):
        kdivs = self.cbnvc
        cbnvc = self.cbnvc = self.l.getCurrentSelection()
        mdxpq = self.fncaa()
        ojmzu = time()
        if kdivs and self.pukqr is not None:
            aypjp = kdivs[2]
            pukqr = aypjp[self.pukqr]
            if self.cuakh < pukqr[2] or pukqr[2] + pukqr[3] < self.cuakh:
                self.cuakh = pukqr[2]
        if ojmzu > self.cuakh:
            self.cuakh = ojmzu
        if cbnvc:
            self.pukqr = None
            aypjp = cbnvc[2]
            if aypjp and len(aypjp):
                self.pukqr = idx = 0
                for efmxu in aypjp:
                    if efmxu[2] <= self.cuakh and efmxu[2] + efmxu[3] > self.cuakh:
                        self.pukqr = idx
                        break
                    idx += 1

        self.suewe(0)
        return

    def swucl(self):
        kdivs = self.cbnvc
        cbnvc = self.cbnvc = self.l.getCurrentSelection()
        mdxpq = self.fncaa()
        cuakh = time()
        if kdivs and self.pukqr is not None:
            bouhg = kdivs[2]
            pukqr = bouhg[self.pukqr]
            if pukqr[2] > cuakh:
                cuakh = pukqr[2]
        if cbnvc:
            self.pukqr = 0
            bouhg = cbnvc[2]
            smesp = None
            if bouhg and len(bouhg):
                oqcgh = 0
                ypsxy = 0
                for kpjnf in bouhg:
                    humyc = kpjnf[2]
                    if humyc < mdxpq:
                        humyc = mdxpq
                    mfizv = abs(humyc - cuakh)
                    if smesp is None or mfizv < oqcgh:
                        smesp = ypsxy
                        oqcgh = mfizv
                    if smesp is not None and humyc > cuakh:
                        break
                    ypsxy += 1

            self.pukqr = smesp
        self.suewe(0)
        return

    def gggoy(self):
        if self.cbnvc is None:
            return (None, None)
        else:
            bouhg = self.cbnvc[2]
            refstr = self.cbnvc[0]
            if self.pukqr is None or not bouhg or not len(bouhg):
                return (None, ServiceReference(refstr))
            efmxu = bouhg[self.pukqr]
            yeosz = efmxu[0]
            vtewf = ServiceReference(refstr)
            efmxu = self.bcdzq(vtewf, yeosz)
            return (efmxu, vtewf)

    def nsuve(self):
        if self.l.getCurrentSelection() is not None:
            return self.l.getCurrentSelection()[0]
        else:
            return 0

    def bcdzq(self, vtewf, kyzij):
        efmxu = None
        if self.hjxkh is not None and kyzij is not None:
            efmxu = self.hjxkh.lookupEventId(vtewf.ref, kyzij)
        return efmxu

    def srisk(self, zqtmz):
        if zqtmz is not None:
            for x in range(len(self.gonjl)):
                if CoolAlternative(self.gonjl[x][0], zqtmz.toString()):
                    return x

        return

    def pjmri(self, zqtmz):
        wnboe = self.srisk(zqtmz)
        if wnboe is None:
            wnboe = 0
        self.scbla(wnboe)
        return

    def selectionChanged(self):
        for selC in self.swolc:
            if selC is not None:
                selC()

        return

    def kctbn(self):
        mflyx = self.l.getCurrentSelection()
        if mflyx:
            self.eyeiq()

    def scbla(self, dvkmp):
        if self.instance is not None:
            self.instance.moveSelectionTo(dvkmp)
        return

    def vrrem(self, ncgzo):
        if ncgzo:
            self.l.setSelectableFunc(self.bfdgp)

    GUI_WIDGET = eListbox

    def bfdgp(self, vtewf, iqpdf, event_list):
        return event_list and len(event_list) and True or False

    def rtlfd(self, vtewf, vnfeu, bouhg):
        try:
            sjfla = NavigationInstance.instance.getCurrentlyPlayingServiceReference().toString()
            xbxyj = self.zxqqq(eServiceReference(vtewf), eServiceReference(sjfla))
        except:
            xbxyj = 1

        esnmc = self.tvnvk
        xovth = self.kmnuc
        xcixu = self.toqqd
        tolzc = self.ljjjn
        amrtn = False
        res = [None]
        if self.oepou <= 50:
            jtjrz = 2
            if config.CTVG.C38.value:
                amrtn = findCoolPicon(vtewf, vnfeu)
            if amrtn:
                self.wchxh.startDecode(amrtn, 0, 0, False)
                amrtn = self.wchxh.getData()
                twafr = (config.CTVG.C52.value - config.CTVG.C51.value) / 2
                res.append(MultiContentEntryPixmapAlphaBlend(pos=(0, 0 + twafr), size=(esnmc.w - 2, esnmc.h - 2), png=amrtn, backcolor=self.oqmff, backcolor_sel=0))
            elif not amrtn and config.CTVG.C29.value != 'No':
                if self.tgkfp.toString() == vtewf:
                    giofg = self.mpoaj
                    res.append(MultiContentEntryPixmapAlphaTest(pos=(esnmc.x + 1, esnmc.y + 1), size=(esnmc.w - 2, esnmc.h - 2), png=giofg))
                else:
                    giofg = self.kcedz
                    res.append(MultiContentEntryPixmapAlphaTest(pos=(esnmc.x + 1, esnmc.y + 1), size=(esnmc.w - 2, esnmc.h - 2), png=giofg))
                res.append(MultiContentEntryText(pos=(esnmc.x + 1, esnmc.y + 1), size=(esnmc.w - 2, esnmc.h - 2), font=0, flags=RT_HALIGN_CENTER | RT_VALIGN_CENTER, text=vnfeu, color=self.smqsh, border_width=1, border_color=self.tvlen))
            else:
                res.append(MultiContentEntryText(pos=(esnmc.x + 1, esnmc.y + 1), size=(esnmc.w - 2, esnmc.h - 2), font=0, flags=RT_HALIGN_CENTER | RT_VALIGN_CENTER, text=vnfeu, color=self.smqsh, border_width=1, border_color=self.tguhz, backcolor=self.aatcx, backcolor_sel=self.gskqd))
        elif self.oepou > 50:
            jtjrz = 1
            if config.CTVG.C37.value:
                amrtn = findCoolPicon(vtewf, vnfeu)
            if amrtn:
                self.wchxh.startDecode(amrtn, 0, 0, False)
                amrtn = self.wchxh.getData()
                fwhwu = (config.CTVG.C50.value - config.CTVG.C49.value) / 2
                res.append(MultiContentEntryPixmapAlphaBlend(pos=(esnmc.x + 1, esnmc.y + fwhwu), size=(esnmc.w - 2, esnmc.h - 2), png=amrtn, backcolor=self.oqmff, backcolor_sel=0))
            elif not amrtn and config.CTVG.C29.value != 'No':
                if self.tgkfp.toString() == vtewf:
                    giofg = self.mpoaj
                    res.append(MultiContentEntryPixmapAlphaTest(pos=(esnmc.x + 1, esnmc.y + 1), size=(esnmc.w - 2, esnmc.h - 2), png=giofg))
                else:
                    giofg = self.kcedz
                    res.append(MultiContentEntryPixmapAlphaTest(pos=(esnmc.x + 1, esnmc.y + 1), size=(esnmc.w - 2, esnmc.h - 2), png=giofg))
                res.append(MultiContentEntryText(pos=(esnmc.x + 1, esnmc.y + 1), size=(esnmc.w - 2, esnmc.h - 2), font=0, flags=RT_HALIGN_CENTER | RT_VALIGN_CENTER, text=vnfeu, color=self.smqsh, border_width=1, border_color=self.tvlen))
            else:
                res.append(MultiContentEntryText(pos=(esnmc.x + 1, esnmc.y + 1), size=(esnmc.w - 2, esnmc.h - 2), font=0, flags=RT_HALIGN_CENTER | RT_VALIGN_CENTER, text=vnfeu, color=self.smqsh, border_width=1, border_color=self.tguhz, backcolor=self.aatcx, backcolor_sel=self.gskqd))
        if bouhg:
            start = self.mdxpq + self.gsnyw * config.CTVG.C44.value * 60
            igthq = start + config.CTVG.C44.value * 60
            ojmzu = int(time())
            yohng = xovth.x
            zrvws = xovth.y
            rfpfl = xovth.w
            nkaal = xovth.h
            tixny = None
            mxhov = RT_HALIGN_LEFT | RT_VALIGN_CENTER
            fmbxp = '   '
            if self.oepou > 39:
                if config.CTVG.C56.value:
                    mxhov = RT_HALIGN_CENTER | RT_VALIGN_CENTER
                    fmbxp = ''
                else:
                    mxhov = RT_HALIGN_LEFT | RT_VALIGN_CENTER
                    fmbxp = ''
            for tixny in bouhg:
                fjgkj = tixny[2]
                scdjh = tixny[3]
                znxwf, fgzsy = self.cuntl(fjgkj, scdjh, start, igthq, rfpfl)
                mjvfa = self.wntnl(vtewf, fjgkj, scdjh, tixny[0])
                if mjvfa:
                    kasgq = self.sntwd
                    jtbpw = self.cnfua
                    paedo = self.sguke
                elif mjvfa == False:
                    kasgq = self.brzlo
                    jtbpw = self.brzlo
                    paedo = self.xgxoi
                elif not xbxyj and fjgkj <= self.ovumy and fjgkj + scdjh > ojmzu:
                    kasgq = self.hcchh
                    jtbpw = self.hqgfq
                    xcixu = self.sjzbt
                    tolzc = self.mdemu
                    paedo = self.uczyl
                elif CoolAlternative(vtewf, self.tgkfp.toString()):
                    kasgq = self.gskqd
                    jtbpw = self.hqgfq
                    paedo = self.eevsb
                elif fjgkj <= ojmzu and fjgkj + scdjh > ojmzu:
                    xcixu = self.xynkw
                    tolzc = self.mdemu
                    kasgq = self.ecnjw
                    jtbpw = self.irfej
                    paedo = self.zpuwf
                else:
                    kasgq = self.mgmwk
                    jtbpw = self.pbfaw
                    paedo = self.rbjco
                if config.CTVG.C29.value != 'No':
                    res.append(MultiContentEntryPixmapAlphaTest(pos=(yohng + znxwf, zrvws), size=(fgzsy, nkaal), png=paedo, backcolor=kasgq, backcolor_sel=jtbpw))
                    res.append(MultiContentEntryText(pos=(yohng + znxwf, zrvws), size=(fgzsy, nkaal), font=jtjrz, flags=mxhov, text=fmbxp + tixny[1], color=xcixu, color_sel=tolzc, backcolor_sel=jtbpw, border_width=2, border_color=self.cqgpu))
                else:
                    res.append(MultiContentEntryText(pos=(yohng + znxwf, zrvws), size=(fgzsy, nkaal), font=jtjrz, flags=mxhov, text=fmbxp + tixny[1], color=xcixu, color_sel=tolzc, backcolor=kasgq, backcolor_sel=jtbpw, border_width=1, border_color=self.bepvs))

        return res

    def gekys(self, kmnuc, mdxpq, yncmd, ev_start, ev_duration):
        znxwf, width = self.cuntl(ev_start, ev_duration, mdxpq, mdxpq + yncmd * 60, kmnuc.width())
        return (znxwf + kmnuc.left(), width)

    def cuntl(self, fjgkj, scdjh, start, igthq, width):
        znxwf = (fjgkj - start) * width / (igthq - start)
        fgzsy = (fjgkj + scdjh - start) * width / (igthq - start) + 1
        fgzsy -= znxwf
        if znxwf < 0:
            fgzsy += znxwf
            znxwf = 0
        if znxwf + fgzsy > width:
            fgzsy = width - znxwf
        return (znxwf, fgzsy)

    def wntnl(self, vwjvv, cfyda, scdjh, ogyya):
        for x in self.eyduj.timer_list:
            if x.service_ref.ref.toString() == vwjvv:
                nbrjc = cfyda + scdjh
                ookve = x.begin
                igthq = x.end
                if self.ovumy == 0 or self.ovumy > igthq:
                    self.ovumy = igthq
                tiqly = ookve + (igthq - ookve) / 4
                if x.eit == ogyya:
                    if cfyda < ookve or nbrjc > igthq:
                        return False
                    else:
                        return True
                elif cfyda <= tiqly <= nbrjc:
                    if cfyda < ookve or nbrjc > igthq:
                        return False
                    else:
                        return True

        for x in self.eyduj.processed_timers:
            if x.disabled and x.service_ref.ref.toString() == vwjvv:
                if x.eit == ogyya:
                    return False

    def eevey(self, dylxl, fjgkj = -1):
        if dylxl is None:
            mdxpq = self.mdxpq + self.gsnyw * config.CTVG.C44.value * 60
            wmqei = [ (vtewf[0],
             0,
             mdxpq,
             config.CTVG.C44.value) for vtewf in self.gonjl ]
        else:
            self.pukqr = None
            self.cbnvc = None
            self.mdxpq = int(fjgkj)
            wmqei = [ (vtewf.ref.toString(),
             0,
             self.mdxpq,
             config.CTVG.C44.value) for vtewf in dylxl ]
        if config.CTVG.C28.value:
            wmqei.insert(0, 'XRnITBD')
        else:
            wmqei.insert(0, 'XRNITBD')
        tsihr = self.uqywf(wmqei)
        self.gonjl = []
        jmola = None
        vtewf = ''
        iqpdf = ''
        vbliu = self.gonjl.append
        for x in tsihr:
            if vtewf != x[0]:
                if jmola is not None:
                    vbliu((vtewf, iqpdf, jmola[0][0] is not None and jmola or None))
                vtewf = x[0]
                iqpdf = x[1]
                jmola = []
            jmola.append((x[2],
             x[3],
             x[4],
             x[5]))

        if jmola and len(jmola):
            vbliu((vtewf, iqpdf, jmola[0][0] is not None and jmola or None))
        self.l.setList(self.gonjl)
        self.eyeiq()
        return

    def ghqiw(self):
        rc = self.kmnuc
        return norej(rc.x + (self.instance and self.instance.position().x() or 0), rc.top(), rc.w, rc.h)

    def fncaa(self):
        return self.mdxpq + self.gsnyw * config.CTVG.C44.value * 60

    def xamry(self):
        return config.CTVG.C44.value

    def zxqqq(self, bgbpo, sxgut):
        ayxei = self.hgtef.info(bgbpo)
        return ayxei and ayxei.isPlayable(bgbpo, sxgut) or False

    def postWidgetCreate(self, instance):
        instance.setWrapAround(True)
        instance.selectionChanged.get().append(self.kctbn)
        instance.setContent(self.l)
        self.l.setSelectionClip(eRect(0, 0, 0, 0), False)
        self.mjfgw()
        self.dsgiu()
        self.czyrr()

    def preWidgetRemove(self, instance):
        instance.selectionChanged.get().remove(self.kctbn)
        instance.setContent(None)
        return

    def uqywf(self, list, wikwi = None):
        if self.hjxkh is not None:
            if wikwi is not None:
                return self.hjxkh.lookupEvent(list, wikwi)
            else:
                return self.hjxkh.lookupEvent(list)
        return []

    def bnxvr(self):
        width = self.l.getItemSize().width()
        jabmd = self.l.getItemSize().height()
        znxwf = 0
        if self.oepou > 50:
            w = config.CTVG.C53.value
        elif self.oepou <= 50:
            w = config.CTVG.C54.value
        self.tvnvk = norej(znxwf, 0, w, jabmd)
        znxwf += w
        w = width - znxwf
        self.kmnuc = norej(znxwf, 0, w, jabmd)

    def tpwbg(self):
        self.gsnyw = 0

    def suewe(self, dir, visible = True):
        cbnvc = self.cbnvc
        self.bnxvr()
        wkubj = self.pukqr is not None
        if cbnvc:
            bpawp = True
            ptvgf = cbnvc[2]
            if dir == 0:
                bpawp = False
            elif dir == +1:
                if wkubj and self.pukqr + 1 < len(ptvgf):
                    self.pukqr += 1
                else:
                    self.gsnyw += 1
                    self.eevey(None)
                    return True
            elif dir == -1:
                if wkubj and self.pukqr - 1 >= 0:
                    self.pukqr -= 1
                else:
                    self.gsnyw -= 1
                    self.eevey(None)
                    return True
            else:
                if dir == +2:
                    self.gsnyw += 1
                    self.eevey(None)
                    return True
                if dir == -2:
                    if self.gsnyw > 0:
                        self.gsnyw -= 1
                        self.eevey(None)
                        return True
                else:
                    if dir == +3:
                        self.gsnyw += 1440 / config.CTVG.C44.value
                        self.eevey(None)
                        return True
                    if dir == -3:
                        self.gsnyw -= 1440 / config.CTVG.C44.value
                        if self.gsnyw < 0:
                            self.gsnyw = 0
                        self.eevey(None)
                        return True
                    if dir == +4:
                        njymg = self.mdxpq + self.gsnyw * config.CTVG.C44.value * 60
                        njymg = datetime.fromtimestamp(njymg)
                        noohi = njymg.replace(hour=config.CTVG.C30.value[0], minute=config.CTVG.C30.value[1])
                        if mktime(noohi.timetuple()) <= mktime(njymg.timetuple()):
                            noohi += timedelta(days=1)
                        njymg = int(mktime(njymg.timetuple()))
                        noohi = int(mktime(noohi.timetuple()))
                        self.gsnyw = self.gsnyw + int((noohi - njymg) / config.CTVG.C44.value * 60)
                        self.mdxpq = noohi - self.gsnyw * config.CTVG.C44.value * 60
                        self.eevey(None)
                        return True
                    if dir == -4:
                        njymg = self.mdxpq + self.gsnyw * config.CTVG.C44.value * 60
                        njymg = datetime.fromtimestamp(njymg)
                        noohi = njymg.replace(hour=config.CTVG.C30.value[0], minute=config.CTVG.C30.value[1])
                        if mktime(noohi.timetuple()) <= mktime(njymg.timetuple()):
                            noohi -= timedelta(days=1)
                        njymg = int(mktime(njymg.timetuple()))
                        noohi = int(mktime(noohi.timetuple()))
                        self.gsnyw = self.gsnyw + int((noohi - njymg) / config.CTVG.C44.value * 60)
                        self.mdxpq = noohi - self.gsnyw * config.CTVG.C44.value * 60
                        self.eevey(None)
                        return True
        if cbnvc and wkubj:
            tjuhw = ptvgf[self.pukqr]
            mdxpq = self.mdxpq + self.gsnyw * config.CTVG.C44.value * 60
            znxwf, width = self.gekys(self.kmnuc, mdxpq, config.CTVG.C44.value, tjuhw[2], tjuhw[3])
            self.auyxk = norej(znxwf, 0, width, self.kmnuc.height)
            self.l.setSelectionClip(eRect(znxwf, 0, width, self.kmnuc.h), visible and bpawp)
        else:
            self.auyxk = self.kmnuc
            self.l.setSelectionClip(eRect(self.kmnuc.x, self.kmnuc.y, self.kmnuc.w, self.kmnuc.h), False)
        self.selectionChanged()
        return False

    def icctg(self):
        weehg = localtime()
        if config.CTVG.C40.value == 1 or config.CTVG.C40.value == 3:
            self.oepou = config.CTVG.C50.value
            self.l.setItemHeight(config.CTVG.C50.value)
            if config.CTVG.C29.value == 'Standard':
                ludwm = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/Cool3D/Standard/'
            elif config.CTVG.C29.value == 'SkinDesign':
                sesfn = config.skin.primary_skin.value
                sesfn = sesfn[:sesfn.rfind('/')]
                ludwm = '/usr/share/enigma2/' + sesfn + '/SkinDesign/'
            else:
                ludwm = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/Cool3D/MyDesign/'
            if (weehg.tm_year, weehg.tm_mon) >= (int(xyaoy[4:8]), int(baaaj[2]) + 1):
                ludwm = 'usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/MyDesign/'
            self.sguke = loadPNG(ludwm + 'CoolRec.png')
            self.xgxoi = loadPNG(ludwm + 'CoolPreRec.png')
            self.uczyl = loadPNG(ludwm + 'CoolFreeTuner.png')
            self.eevsb = loadPNG(ludwm + 'CoolSelect.png')
            self.zpuwf = loadPNG(ludwm + 'CoolNow.png')
            self.rbjco = loadPNG(ludwm + 'CoolBack.png')
            self.kcedz = loadPNG(ludwm + 'CoolPicon.png')
            self.mpoaj = loadPNG(ludwm + 'CoolPiconSelect.png')
            self.wchxh.setPara((config.CTVG.C49.value / 0.6,
             config.CTVG.C49.value,
             1,
             1,
             1,
             1,
             '#ff000000'))
        else:
            self.oepou = config.CTVG.C52.value
            self.l.setItemHeight(config.CTVG.C52.value)
            if config.CTVG.C29.value == 'Standard':
                ludwm = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/Cool3D/Standard/'
            elif config.CTVG.C29.value == 'SkinDesign':
                sesfn = config.skin.primary_skin.value
                sesfn = sesfn[:sesfn.rfind('/')]
                ludwm = '/usr/share/enigma2/' + sesfn + '/SkinDesign/'
            else:
                ludwm = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/Cool3D/MyDesign/'
            if (weehg.tm_year, weehg.tm_mon) >= (int(xyaoy[4:8]), int(baaaj[2]) + 2):
                ludwm = 'usr/lib/enigma2/python/Plugin/Extensions/CoolTVGuide/MyDesign/'
            self.sguke = loadPNG(ludwm + 'CoolRecS.png')
            self.xgxoi = loadPNG(ludwm + 'CoolPreRecS.png')
            self.uczyl = loadPNG(ludwm + 'CoolFreeTunerS.png')
            self.eevsb = loadPNG(ludwm + 'CoolSelectS.png')
            self.zpuwf = loadPNG(ludwm + 'CoolNowS.png')
            self.rbjco = loadPNG(ludwm + 'CoolBackS.png')
            self.kcedz = loadPNG(ludwm + 'CoolPiconS.png')
            self.mpoaj = loadPNG(ludwm + 'CoolPiconSelectS.png')
            self.wchxh.setPara((config.CTVG.C51.value / 0.6,
             config.CTVG.C51.value,
             1,
             1,
             1,
             1,
             '#ff000000'))

    def mjfgw(self):
        self.l.setFont(0, gFont('Myriad', config.CTVG.C47.value))

    def dsgiu(self):
        self.l.setFont(1, gFont('Myriad', config.CTVG.C45.value))

    def czyrr(self):
        self.l.setFont(2, gFont('Myriad', config.CTVG.C46.value))


class mmtrp(Screen):

    def __init__(self, session, dylxl, qhcgc = None, sxowh = '', kzqib = None):
        Screen.__init__(self, session)
        if opspy == 720:
            if kzqib == shuhr:
                self.skinName = 'CoolInfoGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolInfoGuide_720.xml'
            elif kzqib == xxdtq:
                self.skinName = 'CoolSingleGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSingleGuide_720.xml'
            elif kzqib == baaaj:
                self.skinName = 'CoolEasyGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolEasyGuide_720.xml'
            elif kzqib == fqmck:
                self.skinName = 'CoolChannelGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolChannelGuide_720.xml'
            elif kzqib == yacuo:
                if config.CTVG.C40.value == 1:
                    self.skinName = 'CoolTVGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolTVGuide_720.xml'
                elif config.CTVG.C40.value == 2:
                    self.skinName = 'CoolTinyGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolTinyGuide_720.xml'
                elif config.CTVG.C40.value == 3:
                    self.skinName = 'CoolMultiGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolMultiGuide_720.xml'
                elif config.CTVG.C40.value == 4:
                    self.skinName = 'CoolNiceGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolNiceGuide_720.xml'
        elif opspy == 1024:
            if kzqib == shuhr:
                self.skinName = 'CoolInfoGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolInfoGuide_1024.xml'
            elif kzqib == xxdtq:
                if config.CTVG.C43.value == 1:
                    self.skinName = 'CoolSingleGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSingleGuide_1024.xml'
                elif config.CTVG.C43.value == 2:
                    self.skinName = 'CoolSingleGuide2'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSingleGuide2_1024.xml'
                elif config.CTVG.C43.value == 3:
                    self.skinName = 'CoolSingleGuide3'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSingleGuide3_1024.xml'
            elif kzqib == baaaj:
                if config.CTVG.C42.value == 1:
                    self.skinName = 'CoolEasyGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolEasyGuide_1024.xml'
                elif config.CTVG.C42.value == 2:
                    self.skinName = 'CoolEasyGuide2'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolEasyGuide2_1024.xml'
                elif config.CTVG.C42.value == 3:
                    self.skinName = 'CoolEasyGuide3'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolEasyGuide3_1024.xml'
            elif kzqib == fqmck:
                if config.CTVG.C41.value == 1:
                    self.skinName = 'CoolChannelGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolChannelGuide_1024.xml'
                elif config.CTVG.C41.value == 2:
                    self.skinName = 'CoolChannelGuide2'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolChannelGuide2_1024.xml'
                elif config.CTVG.C41.value == 3:
                    self.skinName = 'CoolChannelGuide3'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolChannelGuide3_1024.xml'
            elif kzqib == yacuo:
                if config.CTVG.C40.value == 1:
                    self.skinName = 'CoolTVGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolTVGuide_1024.xml'
                elif config.CTVG.C40.value == 2:
                    self.skinName = 'CoolTinyGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolTinyGuide_1024.xml'
                elif config.CTVG.C40.value == 3:
                    self.skinName = 'CoolMultiGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolMultiGuide_1024.xml'
                elif config.CTVG.C40.value == 4:
                    self.skinName = 'CoolNiceGuide'
                    iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolNiceGuide_1024.xml'
        elif kzqib == shuhr:
            self.skinName = 'CoolInfoGuide'
            iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolInfoGuide_1280.xml'
        elif kzqib == xxdtq:
            if config.CTVG.C43.value == 1:
                self.skinName = 'CoolSingleGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSingleGuide_1280.xml'
            elif config.CTVG.C43.value == 2:
                self.skinName = 'CoolSingleGuide2'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSingleGuide2_1280.xml'
            elif config.CTVG.C43.value == 3:
                self.skinName = 'CoolSingleGuide3'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSingleGuide3_1280.xml'
        elif kzqib == baaaj:
            if config.CTVG.C42.value == 1:
                self.skinName = 'CoolEasyGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolEasyGuide_1280.xml'
            elif config.CTVG.C42.value == 2:
                self.skinName = 'CoolEasyGuide2'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolEasyGuide2_1280.xml'
            elif config.CTVG.C42.value == 3:
                self.skinName = 'CoolEasyGuide3'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolEasyGuide3_1280.xml'
        elif kzqib == fqmck:
            if config.CTVG.C41.value == 1:
                self.skinName = 'CoolChannelGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolChannelGuide_1280.xml'
            elif config.CTVG.C41.value == 2:
                self.skinName = 'CoolChannelGuide2'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolChannelGuide2_1280.xml'
            elif config.CTVG.C41.value == 3:
                self.skinName = 'CoolChannelGuide3'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolChannelGuide3_1280.xml'
        elif kzqib == yacuo:
            if config.CTVG.C40.value == 1:
                self.skinName = 'CoolTVGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolTVGuide_1280.xml'
            elif config.CTVG.C40.value == 2:
                self.skinName = 'CoolTinyGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolTinyGuide_1280.xml'
            elif config.CTVG.C40.value == 3:
                self.skinName = 'CoolMultiGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolMultiGuide_1280.xml'
            elif config.CTVG.C40.value == 4:
                self.skinName = 'CoolNiceGuide'
                iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolNiceGuide_1280.xml'
        thhxl = open(iiive)
        self.skin = thhxl.read()
        thhxl.close()
        self.qivzv = mefvr
        self.qhcgc = qhcgc
        self.bjjsb = (_('Mon'),
         _('Tue'),
         _('Wed'),
         _('Thu'),
         _('Fri'),
         _('Sat'),
         _('Sun'))
        ojmzu = time()
        tmp = ojmzu % 900
        self.rzdhh = ojmzu - tmp
        self.txocy = False
        self['key_red'] = Button('')
        self['key_green'] = Button('')
        self['key_yellow'] = Button('')
        self['key_blue'] = Button('')
        self['Event'] = Event()
        self['Service'] = ServiceEvent()
        self['timeline_text'] = wdvoa()
        self.ujjia = []
        for x in (0, 1, 2, 3, 4, 5):
            pm = Pixmap()
            self.ujjia.append(pm)
            self['timeline%d' % x] = pm

        self['timeline_now'] = Pixmap()
        self.xxjju = dylxl
        if sxowh != '':
            Screen.setTitle(self, sxowh)
        self['list'] = btxms(phvkq=self.ylgms, eyduj=self.session.nav.RecordTimer, yncmd=config.CTVG.C44.value, ncgzo=config.CTVG.C55.value)
        self['Coolman'] = ActionMap(['CoolTVGuideActions'], {'CoolMenu': self.kmhrc,
         'CoolTime': self.ubkep,
         'CoolRed': self.bpknl,
         'CoolRedLong': self.yjzda,
         'CoolGreen': self.edjzc,
         'CoolGreenLong': self.blsge,
         'CoolYellow': self.ocpqd,
         'CoolYellowLong': self.opryi,
         'CoolBlue': self.mngvi,
         'CoolBlueLong': self.nfiwg,
         'CoolOK': self.qwbyt,
         'CoolOKLong': self.hnyen,
         'CoolInfo': self.ftntd,
         'CoolInfoLong': self.omgdq,
         'CoolRecord': self.acufl,
         'CoolVIDEO': qyjbi,
         'CoolAUDIO': self.rqmfo,
         'CoolPlay': self.hlueb,
         'CoolFastForward': self.nyfui,
         'CoolRewind': self.wljuu,
         'CoolKeyTV': self.zmhiy,
         'CoolPower': self.xljhj,
         'CoolCancel': self.obbbh,
         'CoolHelp': self.gzygd,
         'CoolChannelUP': self.ckerq,
         'CoolChannelDown': self.yithv,
         'CoolPREVIOUS': self.yiwix,
         'CoolNEXT': self.pjuah,
         'CoolLEFT': self.fovfn,
         'CoolRIGHT': self.mnusy,
         '1': self.zzfdp,
         '2': self.rttpr,
         '3': self.lngfo,
         '4': self.cgdbb,
         '5': self.ntxfu,
         '6': self.xhreu,
         '7': self.pvmae,
         '8': self.erano,
         '9': self.psqlx,
         '0': self.jpfrl}, -1)
        self['key_red'].setText(_(config.CTVG.C12.value))
        self['key_green'].setText(_(config.CTVG.C14.value))
        self['key_yellow'].setText(_(config.CTVG.C16.value))
        self['key_blue'].setText(_(config.CTVG.C18.value))
        self.dccbu = eTimer()
        self.dccbu.callback.append(self.ozwhd)
        self.dccbu.start(60000)
        self.onLayoutFinish.append(self.morod)
        self.yetxq = None
        self['date'] = Button()
        self.flgrm()
        self.onShow.append(self.voqqc)
        self.caehp = eTimer()
        self.caehp.callback.append(self.ujmyz)
        self.session.nav.RecordTimer.on_state_change.append(self.jysrb)
        self.session.nav.record_event.append(self.onptv)
        self.ljgfw = ServiceEventTracker(screen=self, eventmap={iPlayableService.evStart: self.osjpj,
         iPlayableService.evStopped: self.osjpj})
        return

    def osjpj(self):
        if hasattr(self, 'shown'):
            if self.shown:
                if self.caehp.isActive():
                    self.caehp.stop()
                self.caehp.start(3000, True)

    def onptv(self, vtewf, event):
        self.osjpj()

    def voqqc(self):
        self['list'].tgkfp = self.session.nav.getCurrentlyPlayingServiceReference()
        if self.yetxq:
            self.yetxq = None
            self['list'].pjmri(self.session.nav.getCurrentlyPlayingServiceReference())
        self['list'].l.invalidate()
        return

    def jysrb(self, tjuhw):
        self.osjpj()

    def hjxls(self):
        global aaqqx
        if aaqqx == 1:
            x = config.CTVG.C77.value
        elif aaqqx == 2:
            x = config.CTVG.C78.value
        elif aaqqx == 3:
            x = config.CTVG.C79.value
        elif aaqqx == 4:
            if mrbjc != self.qivzv and ozetp != self.qivzv:
                aaqqx = 1
                return self.close(False)
            x = config.CTVG.C80.value
        elif aaqqx == 5:
            x = config.CTVG.C81.value
        elif aaqqx == 6:
            x = config.CTVG.C82.value
        elif aaqqx == 7:
            x = config.CTVG.C83.value
        elif aaqqx == 8:
            x = config.CTVG.C84.value
        elif aaqqx == 9:
            x = config.CTVG.C85.value
        elif aaqqx == 10:
            x = config.CTVG.C86.value
        elif aaqqx == 11:
            x = config.CTVG.C87.value
        elif aaqqx == 12:
            x = config.CTVG.C88.value
        if x == '9':
            aaqqx += 1
            return self.psqlx()
        self.hide()
        if x == '1':
            self.khoww()
        elif x == '2':
            self.nsdpj()
        elif x == '3':
            CEGmain(self.session)
        elif x == '4':
            CCGmain(self.session)
        elif x == '5':
            config.CTVG.C40.value = 1
            juyho = cixoa.getRoot()
            fvrkm(juyho)
        elif x == '6':
            config.CTVG.C40.value = 2
            juyho = cixoa.getRoot()
            fvrkm(juyho)
        elif x == '7':
            config.CTVG.C40.value = 3
            juyho = cixoa.getRoot()
            fvrkm(juyho)
        elif x == '8':
            config.CTVG.C40.value = 4
            juyho = cixoa.getRoot()
            fvrkm(juyho)
        elif x == '10':
            self.xzceb()
        elif x == '11':
            aaqqx = 0
            self.session.open(TimerEditList)
        else:
            aaqqx = 0
        aaqqx += 1
        self.close(False)

    def flgrm(self):
        ojmzu = localtime()
        if (ojmzu.tm_year, ojmzu.tm_mon) >= (int(xyaoy[4:8]), int(baaaj[2])):
            self.syheu()

    def syheu(self):
        self.yvlvt()

    def changeServiceCB(self, axkko, epg):
        if self.serviceSel:
            if axkko > 0:
                self.serviceSel.nextService()
            else:
                self.serviceSel.prevService()
            epg.setService(self.serviceSel.currentService())

    def ujmyz(self):
        self['list'].tgkfp = self.session.nav.getCurrentlyPlayingServiceReference()
        self['list'].l.invalidate()

    def zauju(self):
        ksvxp = []
        if nabim:
            ksvxp.append((_('SeriesPlugin'), 'SeriesPlugin'))
        if ktssu:
            ksvxp.append((_('The TVDB Info'), 'The TVDB Info'))
        if kasgg:
            ksvxp.append((_('IMDb Search'), 'IMDbSearch'))
        if anzhl:
            ksvxp.append((_('TMDB Info'), 'TMDBInfo'))
        if ljoja:
            ksvxp.append((_('OFDb Details'), 'OFDbDetails'))
        if ksvxp == []:
            ksvxp.append((_('No Info Plugins installed...'), 'No Info Plugins installed...'))
        self.session.openWithCallback(self.bjplp, ChoiceBox, title=_('   CoolInfoBox'), list=ksvxp)

    def bjplp(self, lagzl):
        lagzl = lagzl and lagzl[1]
        jtpbl = self['list'].gggoy()
        efmxu = jtpbl[0]
        if not efmxu:
            return
        plfwt = efmxu and efmxu.getEventName() or ''
        if lagzl == 'SeriesPlugin':
            from Plugins.Extensions.SeriesPlugin.SeriesPluginInfoScreen import SeriesPluginInfoScreen
            vtewf = jtpbl[1]
            self.session.open(SeriesPluginInfoScreen, vtewf, efmxu)
        if lagzl == 'The TVDB Info':
            from Plugins.Extensions.TheTVDB.plugin import TheTVDBMain
            self.session.open(TheTVDBMain, plfwt)
        if lagzl == 'IMDbSearch':
            from Plugins.Extensions.IMDb.plugin import IMDB
            self.session.open(IMDB, plfwt)
        if lagzl == 'TMDBInfo':
            from Plugins.Extensions.TMDb.plugin import TMDbMain
            self.session.open(TMDbMain, plfwt)
        if lagzl == 'OFDbDetails':
            from Plugins.Extensions.OFDb.plugin import OFDB
            self.session.open(OFDB, plfwt)

    def krvdb(self):
        yoyqj = self['list'].gggoy()
        if not yoyqj:
            return
        try:
            from Plugins.Extensions.AutoTimer.AutoTimerEditor import addAutotimerFromEvent
            self.session.openWithCallback(self.vuzti, ChoiceBox, title=_('   check Autotimer ?'), list=[(_('Yes'), 'Yes'), (_('No'), 'No')])
            addAutotimerFromEvent(self.session, yoyqj[0], yoyqj[1])
        except:
            self.session.open(MessageBox, _('No AutoTimer seems to be installed. Please install it for this functionality.'), MessageBox.TYPE_ERROR)

    def vuzti(self, lagzl):
        lagzl = lagzl and lagzl[1]
        if lagzl == 'Yes':
            try:
                from Plugins.Extensions.AutoTimer.plugin import main as AutoTimerSafe
                AutoTimerSafe(self.session)
            except:
                self.session.open(MessageBox, _('No AutoTimer seems to be installed. Please install it for this functionality.'), MessageBox.TYPE_ERROR)

    def hlueb(self):
        xmvvd(xdooe)

    def xljhj(self):
        try:
            from Screens.SleepTimerEdit import SleepTimerEdit
            self.session.open(SleepTimerEdit)
        except:
            pass

    def acufl(self):
        oapoi = self['list'].gggoy()
        zqtmz = oapoi[1]
        gvrnr = oapoi[0]
        if not gvrnr:
            return
        else:
            grgyl = gvrnr.getEventId()
            vwjvv = zqtmz.ref.toString()
            for eyduj in self.session.nav.RecordTimer.timer_list:
                if eyduj.eit == grgyl and eyduj.service_ref.ref.toString() == vwjvv:
                    self.session.nav.RecordTimer.removeEntry(eyduj)
                    self['list'].l.invalidate()
                    break
            else:
                aeoig = RecordTimerEntry(zqtmz, checkOldTimers=True, *parseEvent(gvrnr))
                muysp = NavigationInstance.instance.RecordTimer.record(aeoig)
                if muysp is not None:
                    for x in muysp:
                        if x.setAutoincreaseEnd(aeoig):
                            self.session.nav.RecordTimer.timeChanged(x)

                    muysp = self.session.nav.RecordTimer.record(aeoig)
                    if muysp is not None:
                        self.session.openWithCallback(self.pfoza, TimerSanityConflict, muysp)
                else:
                    self.caehp.start(3000, True)
                self['list'].l.invalidate()

            self.ylgms()
            return

    def xzceb(self):
        try:
            khnnw = self['list'].gggoy()
            wlcgq = khnnw[0]
            if not wlcgq:
                return
            plfwt = wlcgq.getEventName() or ''
        except:
            plfwt = ''

        self.session.open(kpult, plfwt, False)

    def bvtqr(self, ret = False):
        if config.CTVG.C60.value:
            juyho = cixoa.getRoot()
            fvrkm(juyho)
        self.serviceSel = None
        if config.CTVG.C61.value:
            self['list'].pjmri(self.session.nav.getCurrentlyPlayingServiceReference())
            self.txocy = True
            bnthl = self['list'].gggoy()[1]
            self['list'].tgkfp = bnthl.ref
            self.zlmmx()
        return

    def subvo(self, ret = False):
        self.serviceSel = None
        if config.CTVG.C61.value:
            self['list'].pjmri(self.session.nav.getCurrentlyPlayingServiceReference())
            self.txocy = True
            dhzno = self['list'].gggoy()[1]
            self['list'].tgkfp = dhzno.ref
            self.zlmmx()
        return

    def khoww(self):
        config.CTVG.C61.value = False
        tqget = self['list'].gggoy()
        if not tqget:
            return
        crujv = eServiceReference(str(tqget[1]))
        if crujv:
            self.serviceSel = SimpleServicelist(self.xxjju)
            if self.serviceSel.selectService(crujv):
                self.session.openWithCallback(self.subvo, mlayh, tqget[0], tqget[1], crujv, cixoa, self.nwics, obyqg=self.changeServiceCB, kzqib=shuhr)

    def gzygd(self):
        self.session.open(HelpScreen)

    def rqmfo(self):
        config.CTVG.C60.value = False
        self.yetxq = True
        CEGmain(self.session)

    def nsdpj(self):
        config.CTVG.C61.value = False
        config.CTVG.C60.value = False
        fdqoy = self['list'].gggoy()
        refstr = fdqoy[1].ref
        if refstr:
            self.serviceSel = SimpleServicelist(self.xxjju)
            if self.serviceSel.selectService(refstr):
                self.session.openWithCallback(self.bvtqr, ynrgr, refstr, obyqg=self.changeServiceCB, cixoa=cixoa, kzqib=xxdtq)

    def nilhu(self):
        if config.CTVG.C40.value == 1:
            config.CTVG.C40.value = 2
        elif config.CTVG.C40.value == 2:
            config.CTVG.C40.value = 3
        elif config.CTVG.C40.value == 3:
            config.CTVG.C40.value = 4
        else:
            config.CTVG.C40.value = 1
        config.CTVG.save()
        self.hide()
        juyho = cixoa.getRoot()
        fvrkm(juyho)
        self.pjvmw()

    def mnusy(self):
        self.ixvvf(+1)

    def fovfn(self):
        self.ixvvf(-1)

    def pjuah(self):
        self.ixvvf(+3)

    def yiwix(self):
        self.ixvvf(-3)

    def ixvvf(self, dir, visible = True):
        ret = self['list'].suewe(dir, visible)
        if ret:
            self.ozwhd(True)

    def jpfrl(self):
        self['list'].instance.moveSelectionTo(0)
        ojmzu = time()
        tmp = ojmzu % 900
        iyoxb = ojmzu - tmp
        self['list'].tpwbg()
        self['list'].eevey(self.xxjju, iyoxb)
        self.ozwhd(True)

    def zzfdp(self):
        cbdog = config.CTVG.C44.value
        if cbdog > 60:
            cbdog = cbdog - 60
            config.CTVG.C44.value = cbdog
            self.ozwhd()
            self['list'].eevey(None)
        return

    def rttpr(self):
        self['list'].instance.moveSelection(self['list'].instance.pageUp)

    def lngfo(self):
        cbdog = config.CTVG.C44.value
        if cbdog < 300:
            cbdog = cbdog + 60
            config.CTVG.C44.value = cbdog
            self.ozwhd()
            self['list'].eevey(None)
        return

    def cgdbb(self):
        self.ixvvf(-2)

    def ntxfu(self):
        self['list'].pjmri(self.session.nav.getCurrentlyPlayingServiceReference())
        ojmzu = time()
        exzjy = ojmzu % 900
        iyoxb = ojmzu - exzjy
        self['list'].tpwbg()
        self['list'].eevey(self.xxjju, iyoxb)
        self.ozwhd(True)

    def xhreu(self):
        self.ixvvf(+2)

    def pvmae(self):
        self.nilhu()

    def erano(self):
        self['list'].instance.moveSelection(self['list'].instance.pageDown)

    def psqlx(self):
        self.ixvvf(+4)

    def bpknl(self):
        zkcgs = config.CTVG.C12.value
        if zkcgs == 'EPG Select':
            self.hjxls()
        elif zkcgs == 'Zap':
            self.zlmmx()
        elif zkcgs == 'Zap + Exit':
            self.kgvwz()
        elif zkcgs == 'CoolSearch':
            self.xzceb()
        elif zkcgs == 'CoolInfoBox':
            self.zauju()
        elif zkcgs == 'GuideSwitch':
            self.nilhu()
        elif zkcgs == 'Cool Info Guide':
            self.khoww()
        elif zkcgs == 'Timer':
            self.sotem()
        elif zkcgs == 'QuickRec':
            self.acufl()
        elif zkcgs == 'AutoTimer':
            self.krvdb()
        elif zkcgs == 'PrimeTime':
            self.psqlx()
        elif zkcgs == 'Bouquet +':
            self.nyfui()
        elif zkcgs == 'Bouquet -':
            self.wljuu()
        elif zkcgs == 'Bouquetlist':
            self.hlueb()
        else:
            self.hjxls()

    def yjzda(self):
        ogigl = config.CTVG.C13.value
        if ogigl == 'Zap':
            self.zlmmx()
        elif ogigl == 'Zap + Exit':
            self.kgvwz()
        elif ogigl == 'CoolSearch':
            self.xzceb()
        elif ogigl == 'CoolInfoBox':
            self.zauju()
        elif ogigl == 'GuideSwitch':
            self.nilhu()
        elif ogigl == 'Cool Info Guide':
            self.khoww()
        elif ogigl == 'Timer':
            self.sotem()
        elif ogigl == 'QuickRec':
            self.acufl()
        elif ogigl == 'AutoTimer':
            self.krvdb()
        elif ogigl == 'PrimeTime':
            self.psqlx()
        elif ogigl == 'EPG Select':
            self.hjxls()
        elif ogigl == 'Bouquet +':
            self.nyfui()
        elif ogigl == 'Bouquet -':
            self.wljuu()
        elif ogigl == 'Bouquetlist':
            self.hlueb()
        else:
            self.kgvwz()

    def edjzc(self):
        ascfa = config.CTVG.C14.value
        if ascfa == 'Zap':
            self.zlmmx()
        elif ascfa == 'Zap + Exit':
            self.kgvwz()
        elif ascfa == 'CoolSearch':
            self.xzceb()
        elif ascfa == 'CoolInfoBox':
            self.zauju()
        elif ascfa == 'GuideSwitch':
            self.nilhu()
        elif ascfa == 'Cool Info Guide':
            self.khoww()
        elif ascfa == 'Timer':
            self.sotem()
        elif ascfa == 'QuickRec':
            self.acufl()
        elif ascfa == 'AutoTimer':
            self.krvdb()
        elif ascfa == 'PrimeTime':
            self.psqlx()
        elif ascfa == 'EPG Select':
            self.hjxls()
        elif ascfa == 'Bouquet +':
            self.nyfui()
        elif ascfa == 'Bouquet -':
            self.wljuu()
        elif ascfa == 'Bouquetlist':
            self.hlueb()
        else:
            self.sotem()

    def blsge(self):
        zsbhk = config.CTVG.C15.value
        if zsbhk == 'Zap':
            self.zlmmx()
        elif zsbhk == 'Zap + Exit':
            self.kgvwz()
        elif zsbhk == 'CoolSearch':
            self.xzceb()
        elif zsbhk == 'CoolInfoBox':
            self.zauju()
        elif zsbhk == 'GuideSwitch':
            self.nilhu()
        elif zsbhk == 'Cool Info Guide':
            self.khoww()
        elif zsbhk == 'Timer':
            self.sotem()
        elif zsbhk == 'QuickRec':
            self.acufl()
        elif zsbhk == 'AutoTimer':
            self.krvdb()
        elif zsbhk == 'PrimeTime':
            self.psqlx()
        elif zsbhk == 'EPG Select':
            self.hjxls()
        elif zsbhk == 'Bouquet +':
            self.nyfui()
        elif zsbhk == 'Bouquet -':
            self.wljuu()
        elif zsbhk == 'Bouquetlist':
            self.hlueb()
        else:
            self.krvdb()

    def ocpqd(self):
        edzmi = config.CTVG.C16.value
        if edzmi == 'Zap':
            self.zlmmx()
        elif edzmi == 'Zap + Exit':
            self.kgvwz()
        elif edzmi == 'CoolSearch':
            self.xzceb()
        elif edzmi == 'CoolInfoBox':
            self.zauju()
        elif edzmi == 'GuideSwitch':
            self.nilhu()
        elif edzmi == 'Cool Info Guide':
            self.khoww()
        elif edzmi == 'Timer':
            self.sotem()
        elif edzmi == 'QuickRec':
            self.acufl()
        elif edzmi == 'AutoTimer':
            self.krvdb()
        elif edzmi == 'PrimeTime':
            self.psqlx()
        elif edzmi == 'EPG Select':
            self.hjxls()
        elif edzmi == 'Bouquet +':
            self.nyfui()
        elif edzmi == 'Bouquet -':
            self.wljuu()
        elif edzmi == 'Bouquetlist':
            self.hlueb()
        else:
            self.nilhu()

    def opryi(self):
        nbvxv = config.CTVG.C17.value
        if nbvxv == 'Zap':
            self.zlmmx()
        elif nbvxv == 'Zap + Exit':
            self.kgvwz()
        elif nbvxv == 'CoolSearch':
            self.xzceb()
        elif nbvxv == 'CoolInfoBox':
            self.zauju()
        elif nbvxv == 'GuideSwitch':
            self.nilhu()
        elif nbvxv == 'Cool Info Guide':
            self.khoww()
        elif nbvxv == 'Timer':
            self.sotem()
        elif nbvxv == 'QuickRec':
            self.acufl()
        elif nbvxv == 'AutoTimer':
            self.krvdb()
        elif nbvxv == 'PrimeTime':
            self.psqlx()
        elif nbvxv == 'EPG Select':
            self.hjxls()
        elif nbvxv == 'Bouquet +':
            self.nyfui()
        elif nbvxv == 'Bouquet -':
            self.wljuu()
        elif nbvxv == 'Bouquetlist':
            self.hlueb()
        else:
            self.hlueb()

    def mngvi(self):
        ocmvt = config.CTVG.C18.value
        if ocmvt == 'Zap':
            self.zlmmx()
        elif ocmvt == 'Zap + Exit':
            self.kgvwz()
        elif ocmvt == 'CoolSearch':
            self.xzceb()
        elif ocmvt == 'CoolInfoBox':
            self.zauju()
        elif ocmvt == 'GuideSwitch':
            self.nilhu()
        elif ocmvt == 'Cool Info Guide':
            self.khoww()
        elif ocmvt == 'Timer':
            self.sotem()
        elif ocmvt == 'QuickRec':
            self.acufl()
        elif ocmvt == 'AutoTimer':
            self.krvdb()
        elif ocmvt == 'PrimeTime':
            self.psqlx()
        elif ocmvt == 'EPG Select':
            self.hjxls()
        elif ocmvt == 'Bouquet +':
            self.nyfui()
        elif ocmvt == 'Bouquet -':
            self.wljuu()
        elif ocmvt == 'Bouquetlist':
            self.hlueb()
        else:
            self.xzceb()

    def nfiwg(self):
        jeqam = config.CTVG.C19.value
        if jeqam == 'Zap':
            self.zlmmx()
        elif jeqam == 'Zap + Exit':
            self.kgvwz()
        elif jeqam == 'CoolSearch':
            self.xzceb()
        elif jeqam == 'CoolInfoBox':
            self.zauju()
        elif jeqam == 'GuideSwitch':
            self.nilhu()
        elif jeqam == 'Cool Info Guide':
            self.khoww()
        elif jeqam == 'Timer':
            self.sotem()
        elif jeqam == 'QuickRec':
            self.acufl()
        elif jeqam == 'AutoTimer':
            self.krvdb()
        elif jeqam == 'PrimeTime':
            self.psqlx()
        elif jeqam == 'EPG Select':
            self.hjxls()
        elif jeqam == 'Bouquet +':
            self.nyfui()
        elif jeqam == 'Bouquet -':
            self.wljuu()
        elif jeqam == 'Bouquetlist':
            self.hlueb()
        else:
            self.zauju()

    def qwbyt(self):
        ynucx = config.CTVG.C20.value
        if ynucx == 'Zap':
            self.zlmmx()
        elif ynucx == 'Zap + Exit':
            self.kgvwz()
        elif ynucx == 'CoolSearch':
            self.xzceb()
        elif ynucx == 'CoolInfoBox':
            self.zauju()
        elif ynucx == 'GuideSwitch':
            self.nilhu()
        elif ynucx == 'Cool Info Guide':
            self.khoww()
        elif ynucx == 'Timer':
            self.sotem()
        elif ynucx == 'QuickRec':
            self.acufl()
        elif ynucx == 'AutoTimer':
            self.krvdb()
        elif ynucx == 'PrimeTime':
            self.psqlx()
        elif ynucx == 'Bouquet +':
            self.nyfui()
        elif ynucx == 'Bouquet -':
            self.wljuu()
        elif ynucx == 'Bouquetlist':
            self.hlueb()
        else:
            self.khoww()

    def hnyen(self):
        buehv = config.CTVG.C21.value
        if buehv == 'Zap':
            self.zlmmx()
        elif buehv == 'Zap + Exit':
            self.kgvwz()
        elif buehv == 'CoolSearch':
            self.xzceb()
        elif buehv == 'CoolInfoBox':
            self.zauju()
        elif buehv == 'GuideSwitch':
            self.nilhu()
        elif buehv == 'Cool Info Guide':
            self.khoww()
        elif buehv == 'Timer':
            self.sotem()
        elif buehv == 'QuickRec':
            self.acufl()
        elif buehv == 'AutoTimer':
            self.krvdb()
        elif buehv == 'PrimeTime':
            self.psqlx()
        elif buehv == 'Bouquet +':
            self.nyfui()
        elif buehv == 'Bouquet -':
            self.wljuu()
        elif buehv == 'Bouquetlist':
            self.hlueb()
        else:
            return

    def ftntd(self):
        jxgqg = config.CTVG.C22.value
        if jxgqg == '4':
            self.hjxls()
        elif jxgqg == '1':
            self.khoww()
        elif jxgqg == '2':
            self.nsdpj()
        elif jxgqg == '3':
            self.rqmfo()
        else:
            self.khoww()

    def omgdq(self):
        jsihv = config.CTVG.C23.value
        if jsihv == '4':
            self.hjxls()
        elif jsihv == '1':
            self.khoww()
        elif jsihv == '2':
            self.nsdpj()
        elif jsihv == '3':
            self.rqmfo()
        else:
            self.khoww()

    def ckerq(self):
        zagls = config.CTVG.C24.value
        if zagls == '1':
            self.nyfui()
        elif zagls == '2':
            self.wljuu()
        elif zagls == '3':
            self.rttpr()
        elif zagls == '4':
            self.erano()
        else:
            self.nyfui()

    def yithv(self):
        tkqsx = config.CTVG.C25.value
        if tkqsx == '1':
            self.nyfui()
        elif tkqsx == '2':
            self.wljuu()
        elif tkqsx == '3':
            self.rttpr()
        elif tkqsx == '4':
            self.erano()
        else:
            self.wljuu()

    def nyfui(self):
        ojmzu = self['list'].fncaa()
        exzjy = ojmzu % 900
        if self.qhcgc:
            self['list'].instance.moveSelectionTo(0)
            self.qhcgc(1, self)
            sxowh = ServiceReference(fkqeh).getServiceName()
            if sxowh != '':
                Screen.setTitle(self, sxowh)
        iyoxb = ojmzu - exzjy
        self['list'].tpwbg()
        self['list'].eevey(self.xxjju, iyoxb)
        self.ozwhd(True)

    def wljuu(self):
        ojmzu = self['list'].fncaa()
        exzjy = ojmzu % 900
        if self.qhcgc:
            self['list'].instance.moveSelectionTo(0)
            self.qhcgc(-1, self)
            sxowh = ServiceReference(fkqeh).getServiceName()
            if sxowh != '':
                Screen.setTitle(self, sxowh)
        iyoxb = ojmzu - exzjy
        self['list'].tpwbg()
        self['list'].eevey(self.xxjju, iyoxb)
        self.ozwhd(True)

    def ubkep(self):
        self.session.openWithCallback(self.voijy, TimeDateInput, config.CTVG.C27)

    def voijy(self, ret):
        if len(ret) > 1:
            if ret[0]:
                self.rzdhh = ret[1]
                l = self['list']
                l.tpwbg()
                l.eevey(self.xxjju, ret[1])
                self.ozwhd(True)

    def kmhrc(self):
        self.session.openWithCallback(self.rgdse, cxpnt)

    def rgdse(self):
        self.hide()
        main(self.session, cixoa)
        if mrbjc != self.qivzv and ozetp != self.qivzv:
            self.session.open(MessageBox, Po, MessageBox.TYPE_INFO)
        self.yvlvt()

    def obbbh(self):
        global aaqqx
        aaqqx = 1
        self.hjxkh = eEPGCache.getInstance()
        self.hide()
        lozxb = set()
        ojmzu = time()
        naxev = False
        if config.CTVG.C62.value:
            for x in self.session.nav.RecordTimer.timer_list:
                ookve = x.begin
                igthq = x.end
                tiqly = ookve + (igthq - ookve) / 4
                try:
                    efmxu = self.hjxkh.lookupEventId(x.service_ref.ref, x.eit)
                except:
                    efmxu = self.hjxkh.lookupEventTime(x.service_ref.ref, tiqly)

                if efmxu:
                    klzcy = efmxu.getBeginTime()
                    ihoxq = klzcy + efmxu.getDuration()
                    if klzcy < ookve or ihoxq > igthq:
                        if efmxu.getDuration() > 300 and ookve > ojmzu:
                            lozxb.add(x)

        if config.CTVG.C63.value:
            for x in self.session.nav.RecordTimer.processed_timers:
                if ojmzu < x.end:
                    lozxb.add(x)

        jzrnw = _('\n          !! Cool Timer Alarm !! \n\n')
        for x in lozxb:
            naxev = str(x.name)
            sklkr = str(strftime('%d.%m.%Y - %H:%M', localtime(x.begin)))
            ezoga = str(x.service_ref.getServiceName())
            uepyc = _('is disabled') if x.disabled else _('has moved')
            jzrnw += sklkr + ' - ' + ezoga + '\n' + naxev + ' ' + uepyc + '\n\n'

        jzrnw += _('-- please check your Timer --')
        if naxev:
            self.session.open(MessageBox, jzrnw, MessageBox.TYPE_ERROR)
        self.pjvmw()

    def gfxnd(self, dylxl):
        self.xxjju = dylxl
        self.morod()

    def ozwhd(self, ciwhf = False):
        self['list'].tgkfp = self.session.nav.getCurrentlyPlayingServiceReference()
        self.dccbu.start((60 - int(time()) % 60) * 1000)
        kmnuc = self['list'].ghqiw()
        yncmd = self['list'].xamry()
        mdxpq = self['list'].fncaa()
        if kmnuc is None or yncmd is None or mdxpq is None:
            self.dccbu.start(500)
        mexsi = yncmd > 180 and 60 or 30
        ihtfd = yncmd / mexsi
        nemem = kmnuc.width() / ihtfd
        pos = kmnuc.left()
        wwnqg = []
        x = 0
        bzplu = 0
        for line in self.ujjia:
            nwrom = line.position
            fuioc = (x == ihtfd and kmnuc.left() + kmnuc.width() or pos, nwrom[1])
            if not x or x >= ihtfd:
                line.visible = False
            else:
                if nwrom != fuioc:
                    line.setPosition(fuioc[0], fuioc[1])
                    bzplu += 1
                line.visible = True
            if not x or line.visible:
                wwnqg.append((mdxpq + x * mexsi * 60, fuioc[0]))
            x += 1
            pos += nemem

        if bzplu or ciwhf:
            self['timeline_text'].nbead(wwnqg)
        ojmzu = time()
        zrljk = self['timeline_now']
        if ojmzu >= mdxpq and ojmzu < mdxpq + yncmd * 60:
            znxwf = int((ojmzu - mdxpq) * kmnuc.width() / (yncmd * 60) - zrljk.instance.size().width() / 2)
            nwrom = zrljk.position
            fuioc = (znxwf + kmnuc.left(), nwrom[1])
            if nwrom != fuioc:
                zrljk.setPosition(fuioc[0], fuioc[1])
            zrljk.visible = True
        else:
            zrljk.visible = False
        self['list'].l.invalidate()
        return

    def morod(self):
        self['list'].eevey(self.xxjju, self.rzdhh)
        self['list'].pjmri(self.session.nav.getCurrentlyPlayingServiceReference())
        self.ozwhd()
        if config.CTVG.C39.value:
            self['list'].instance.moveSelectionTo(0)

    def nwics(self, ocdis, setService, val):
        sdasm = self['list'].gggoy()
        self.ixvvf(val, False)
        vunnx = self['list'].gggoy()
        if vunnx[0] is None and vunnx[1].ref != sdasm[1].ref:
            self.nwics(ocdis, setService, val)
        else:
            setService(vunnx[1])
            ocdis(vunnx[0])
        return

    def zmhiy(self):
        xdooe.open(TimerEditList)

    def sotem(self):
        bpyut = self['list'].gggoy()
        wkhzm = bpyut[0]
        zqtmz = bpyut[1]
        if not wkhzm:
            return
        grgyl = wkhzm.getEventId()
        vwjvv = zqtmz.ref.toString()
        for eyduj in self.session.nav.RecordTimer.timer_list:
            if eyduj.eit == grgyl and eyduj.service_ref.ref.toString() == vwjvv:
                self.eyduj = eyduj
                self.session.openWithCallback(self.doxxi, ChoiceBox, title=_('Cool Timer Edit :' + '\n\n%s') % wkhzm.getEventName(), list=[(_('edit this Timer ?'), 'edit'), (_('delete this Timer ?'), 'delete'), (_('delete this Timer and recording ?'), 'delrec')])
                break
        else:
            aeoig = RecordTimerEntry(zqtmz, checkOldTimers=True, *parseEvent(wkhzm))
            self.session.openWithCallback(self.jhzuv, TimerEntry, aeoig)

    def doxxi(self, lagzl):
        eyduj = self.eyduj
        doxxi(self, eyduj, lagzl)

    def jhzuv(self, lagzl):
        self.caehp.start(3000, True)
        if lagzl[0]:
            tjuhw = lagzl[1]
            fathd = self.session.nav.RecordTimer.record(tjuhw)
            if fathd is not None:
                for x in fathd:
                    if x.setAutoincreaseEnd(tjuhw):
                        self.session.nav.RecordTimer.timeChanged(x)

                fathd = self.session.nav.RecordTimer.record(tjuhw)
                if fathd is not None:
                    self.session.openWithCallback(self.pfoza, TimerSanityConflict, fathd)
            if config.CTVG.C14.value == 'Timer':
                self['key_green'].setText(_('TimerEdit'))
            elif config.CTVG.C12.value == 'Timer':
                self['key_red'].setText(_('TimerEdit'))
            elif config.CTVG.C16.value == 'Timer':
                self['key_yellow'].setText(_('TimerEdit'))
            elif config.CTVG.C18.value == 'Timer':
                self['key_blue'].setText(_('TimerEdit'))
        return

    def pfoza(self, lagzl):
        self.jhzuv(lagzl)

    def ylgms(self):
        vcqwm = self['list'].gggoy()
        jdqrk = vcqwm[0]
        self['Event'].newEvent(jdqrk)
        capbd = self['list'].nsuve()
        puntx = ''
        ojmzu = time()
        mdxpq = self['list'].fncaa()
        hcxyb = localtime(ojmzu)
        dsxwo = localtime(mdxpq)
        if hcxyb[2] != dsxwo[2]:
            puntx = '%s  %d.%d.' % (self.bjjsb[dsxwo[6]], dsxwo[2], dsxwo[1])
        else:
            puntx = '%s  %d.%d.' % (_('Today'), dsxwo[2], dsxwo[1])
        self['date'].setText(puntx)
        if vcqwm[1] is None:
            self['Service'].newService(None)
        else:
            self['Service'].newService(vcqwm[1].ref)
        if not jdqrk:
            if config.CTVG.C14.value == 'Timer':
                self['key_green'].setText('')
            elif config.CTVG.C12.value == 'Timer':
                self['key_red'].setText('')
            elif config.CTVG.C16.value == 'Timer':
                self['key_yellow'].setText('')
            elif config.CTVG.C18.value == 'Timer':
                self['key_blue'].setText('')
            return
        else:
            zqtmz = vcqwm[1]
            grgyl = jdqrk.getEventId()
            vwjvv = zqtmz.ref.toString()
            iibly = False
            for eyduj in self.session.nav.RecordTimer.timer_list:
                if eyduj.eit == grgyl and eyduj.service_ref.ref.toString() == vwjvv:
                    iibly = True
                    break

            if iibly:
                if config.CTVG.C14.value == 'Timer':
                    self['key_green'].setText(_('TimerEdit'))
                elif config.CTVG.C12.value == 'Timer':
                    self['key_red'].setText(_('TimerEdit'))
                elif config.CTVG.C16.value == 'Timer':
                    self['key_yellow'].setText(_('TimerEdit'))
                elif config.CTVG.C18.value == 'Timer':
                    self['key_blue'].setText(_('TimerEdit'))
            elif config.CTVG.C14.value == 'Timer':
                self['key_green'].setText(_('Timer'))
            elif config.CTVG.C12.value == 'Timer':
                self['key_red'].setText(_('Timer'))
            elif config.CTVG.C16.value == 'Timer':
                self['key_yellow'].setText(_('Timer'))
            elif config.CTVG.C18.value == 'Timer':
                self['key_blue'].setText(_('Timer'))
            return

    def pjvmw(self):
        self.txocy = True
        atnvd = self['list'].gggoy()[1]
        if atnvd:
            self.yvlvt()

    def yvlvt(self):
        self.close(self.txocy)

    def zlmmx(self):
        self.txocy = True
        kjxzu = self['list'].gggoy()[1]
        if kjxzu:
            tmcma(kjxzu.ref)
            self['list'].tgkfp = self.session.nav.getCurrentlyPlayingServiceReference()
            self['list'].eevey(None)
        return

    def kgvwz(self):
        self.txocy = True
        gdyhg = self['list'].gggoy()[1]
        if gdyhg:
            tmcma(gdyhg.ref)
            self.yvlvt()


class cxpnt(Screen, ConfigListScreen):

    def __init__(self, session, args = None):
        Screen.__init__(self, session)
        self.mffjn = _('Cool TV Guide Settings')
        self.skinName = 'CoolTVGuideSetup'
        iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolTVGuideSetup.xml'
        thhxl = open(iiive)
        self.skin = thhxl.read()
        thhxl.close()
        self['Coolman'] = ActionMap(['CoolTVGuideActions'], {'CoolOK': self.nrgaw,
         'CoolCancel': self.nrgaw,
         'CoolRed': self.xbqpy,
         'CoolGreen': self.wwhdc,
         'CoolYellow': self.ffcey,
         'CoolBlue': self.rctyu,
         'CoolHelp': self.gzygd,
         'CoolMenu': self.zqhgz}, -1)
        self['key_red'] = Button(_('Save'))
        self['key_green'] = Button(_('Cool'))
        self['key_yellow'] = Button(_('TV'))
        self['key_blue'] = Button(_('Guide'))
        self['CoolText1'] = Button(_('Standard for (HD), (XD), (SD) Skin'))
        self['CoolText2'] = Button(_('Press ( < OK > ) to change your Buttons !!!'))
        self.eyvbu = []
        self.quvtb = mefvr
        self.session = session
        self.gonjl = []
        ConfigListScreen.__init__(self, self.gonjl, session=self.session)
        self.rctyu()

    def zmtks(self, res):
        if res is not None:
            if res[-1:] == '/':
                res = res[:-1]
            if res[0] != '/':
                res = '/'
            self.gonjl[self['config'].getCurrentIndex()][1].value = res
        return

    def nrgaw(self):
        self.close()

    def zqhgz(self):
        try:
            self.gonjl[self['config'].getCurrentIndex()][3]()
        except:
            pass

    def xbqpy(self):
        config.CTVG.save()
        self.close()

    def gzygd(self):
        self.session.open(HelpScreen)

    def wwhdc(self):
        self.wwhdc = []
        self.wwhdc.append(getConfigListEntry(_('Red Button (EPG Select)'), config.CTVG.C12))
        self.wwhdc.append(getConfigListEntry(_('LongRed Button (ZAP+Exit)'), config.CTVG.C13))
        self.wwhdc.append(getConfigListEntry(_('Green Button (Timer)'), config.CTVG.C14))
        self.wwhdc.append(getConfigListEntry(_('LongGreen Button (Autotimer)'), config.CTVG.C15))
        self.wwhdc.append(getConfigListEntry(_('Yellow Button (GuideSwitch)'), config.CTVG.C16))
        self.wwhdc.append(getConfigListEntry(_('LongYellow Button (Bouquetlist)'), config.CTVG.C17))
        self.wwhdc.append(getConfigListEntry(_('Blue Button (CoolSearch)'), config.CTVG.C18))
        self.wwhdc.append(getConfigListEntry(_('LongBlue Button (CoolInfoBox)'), config.CTVG.C19))
        self.wwhdc.append(getConfigListEntry(_('OK Button (Zap)'), config.CTVG.C20))
        self.wwhdc.append(getConfigListEntry(_('LongOK Button'), config.CTVG.C21))
        self.wwhdc.append(getConfigListEntry(_('Info Button (Cool Info Guide)'), config.CTVG.C22))
        self.wwhdc.append(getConfigListEntry(_('LongInfo Button'), config.CTVG.C23))
        self.wwhdc.append(getConfigListEntry(_('Channel + (Bouquet +)'), config.CTVG.C24))
        self.wwhdc.append(getConfigListEntry(_('Channel - (Bouquet -)'), config.CTVG.C25))
        self['config'].list = self.wwhdc
        self['config'].l.setList(self.wwhdc)

    def ffcey(self):
        self.ffcey = []
        self.ffcey.append(getConfigListEntry(_('Cool PrimeTime (20:15)'), config.CTVG.C30))
        self.ffcey.append(getConfigListEntry(_('Cool TimerAlarm check if Timer has changed'), config.CTVG.C62))
        self.ffcey.append(getConfigListEntry(_('Cool TimerAlarm check if Timer is deaktivated'), config.CTVG.C63))
        self.ffcey.append(getConfigListEntry(_('----------'), config.CTVG.C26))
        self.ffcey.append(getConfigListEntry(_('Start Cool TV Guide with Red Button'), config.CTVG.C31))
        self.ffcey.append(getConfigListEntry(_('Start Cool Single Guide with Green Button'), config.CTVG.C32))
        self.ffcey.append(getConfigListEntry(_('Start Cool Easy Guide with Yellow Button'), config.CTVG.C33))
        self.ffcey.append(getConfigListEntry(_('Start Cool Info Guide with Info/EPG Button'), config.CTVG.C34))
        self.ffcey.append(getConfigListEntry(_('Start Cool Channel Guide with Down Button'), config.CTVG.C35))
        self.ffcey.append(getConfigListEntry(_('----------'), config.CTVG.C26))
        self.ffcey.append(getConfigListEntry(_('Event 60 Fontsize (18), (15), (15)'), config.CTVG.C45))
        self.ffcey.append(getConfigListEntry(_('Event 30 Fontsize (18), (15), (15)'), config.CTVG.C46))
        self.ffcey.append(getConfigListEntry(_('Left Fontsize (22), (18), (16) (need restart)'), config.CTVG.C47))
        self.ffcey.append(getConfigListEntry(_('Timeline Fontsize (20), (18), (16) (need restart)'), config.CTVG.C48))
        self.ffcey.append(getConfigListEntry(_('Right 60 Font Center (Yes)'), config.CTVG.C56))
        self.ffcey.append(getConfigListEntry(_('----------'), config.CTVG.C26))
        self.ffcey.append(getConfigListEntry(_('Time Scale (180)'), config.CTVG.C44))
        self.ffcey.append(getConfigListEntry(_('Bouquet at Start (No)'), config.CTVG.C36))
        self.ffcey.append(getConfigListEntry(_('Channel 1 at Start (No)'), config.CTVG.C39))
        self.ffcey.append(getConfigListEntry(_('Skip Empty Services (No) (need restart)'), config.CTVG.C55))
        self.ffcey.append(getConfigListEntry(_('----------'), config.CTVG.C26))
        self.ffcey.append(getConfigListEntry(_('Cool Easy Guide show Channel Number'), config.CTVG.C58))
        self.ffcey.append(getConfigListEntry(_('Cool Easy Guide use Yellow/Blue for Time -/+'), config.CTVG.C57))
        self.ffcey.append(getConfigListEntry(_('----------'), config.CTVG.C26))
        self['config'].list = self.ffcey
        self['config'].l.setList(self.ffcey)

    def rctyu(self):
        self.gonjl = []
        if mrbjc != self.quvtb and ozetp != self.quvtb:
            alrfu = int(os.popen(bwuke('CoolTVGUIDE', ohmxk)).read()[int(baaaj[7]):].replace(':', ''), int(fqmck[9:11]) + int(fqmck[2:4])) * (int(mohdd[3:5]) - int(mohdd[8:10])) + int(shuhr + xxdtq)
            self.gonjl.append(getConfigListEntry(_('Cool TV Guide ID ' + str(alrfu) + '              Cool TV Guide Key '), config.CTVG.Key))
            config.CTVG.save()
        else:
            self.gonjl.append(getConfigListEntry(_('Cool TV Guide ' + wjtzs), config.CTVG.C26))
            self.gonjl.append(getConfigListEntry(_('----------'), config.CTVG.C26))
            self.gonjl.append(getConfigListEntry(_('1 EPG Select (Cool Info Guide)'), config.CTVG.C77))
            self.gonjl.append(getConfigListEntry(_('2 EPG Select (Cool Single Guide)'), config.CTVG.C78))
            self.gonjl.append(getConfigListEntry(_('3 EPG Select (Cool Easy Guide)'), config.CTVG.C79))
            self.gonjl.append(getConfigListEntry(_('4 EPG Select ()'), config.CTVG.C80))
            self.gonjl.append(getConfigListEntry(_('5 EPG Select ()'), config.CTVG.C81))
            self.gonjl.append(getConfigListEntry(_('6 EPG Select ()'), config.CTVG.C82))
            self.gonjl.append(getConfigListEntry(_('7 EPG Select ()'), config.CTVG.C83))
            self.gonjl.append(getConfigListEntry(_('8 EPG Select ()'), config.CTVG.C84))
            self.gonjl.append(getConfigListEntry(_('9 EPG Select ()'), config.CTVG.C85))
            self.gonjl.append(getConfigListEntry(_('10 EPG Select ()'), config.CTVG.C86))
            self.gonjl.append(getConfigListEntry(_('11 EPG Select ()'), config.CTVG.C87))
            self.gonjl.append(getConfigListEntry(_('12 EPG Select ()'), config.CTVG.C88))
            self.gonjl.append(getConfigListEntry(_('----------'), config.CTVG.C26))
        self.gonjl.append(getConfigListEntry(_('Cool 3D'), config.CTVG.C29))
        self.gonjl.append(getConfigListEntry(_('Special Character (UTF-8) Fix (No)'), config.CTVG.C11))
        self.gonjl.append(getConfigListEntry(_('Short Service Name (No)'), config.CTVG.C28))
        self.gonjl.append(getConfigListEntry(_('----------'), config.CTVG.C26))
        self.gonjl.append(getConfigListEntry(_('Show Picon (Yes) (need restart)'), config.CTVG.C37))
        self.gonjl.append(getConfigListEntry(_('Picon Height (60), (54), (54)'), config.CTVG.C49))
        self.gonjl.append(getConfigListEntry(_('Picon Item Height (60), (54), (54)'), config.CTVG.C50))
        self.gonjl.append(getConfigListEntry(_('Left Section Width (110), (75), (75)'), config.CTVG.C53))
        self.gonjl.append(getConfigListEntry(_('----------'), config.CTVG.C26))
        self.gonjl.append(getConfigListEntry(_('Show CoolPico (Yes) (need restart)'), config.CTVG.C38))
        self.gonjl.append(getConfigListEntry(_('CoolPico Height (30), (27), (27)'), config.CTVG.C51))
        self.gonjl.append(getConfigListEntry(_('CoolPico Item Height (30), (27), (27)'), config.CTVG.C52))
        self.gonjl.append(getConfigListEntry(_('Left Section Width (190), (110), (110)'), config.CTVG.C54))
        self['config'].list = self.gonjl
        self['config'].l.setList(self.gonjl)


class HelpScreen(Screen):
    rbmoj = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/Cool3D/help.jpg'
    if opspy == 720:
        iiive = '\n\t\t\t<screen flags="wfNoBorder" position="0,0" size="720,576" title="..Help.." backgroundColor=\'#ffffffff\'>\n\t\t\t\t<widget name="Picture" position="0,0" size="720,576" zPosition="1"/>\n\t\t\t</screen>'
    elif opspy == 1024:
        iiive = '\n\t\t\t<screen flags="wfNoBorder" position="0,0" size="1024,576" title="..Help.." backgroundColor=\'#ffffffff\'>\n\t\t\t\t<widget name="Picture" position="0,0" size="1024,576" zPosition="1"/>\n\t\t\t</screen>'
    else:
        iiive = '\n\t\t\t<screen flags="wfNoBorder" position="0,0" size="1280,720" title="..Help.." backgroundColor=\'#ffffffff\'>\n\t\t\t\t<widget name="Picture" position="0,0" size="1280,720" zPosition="1"/>\n\t\t\t</screen>'

    def __init__(self, session):
        self.skin = HelpScreen.iiive
        Screen.__init__(self, session)
        self.hwayl = ePicLoad()
        self['Picture'] = Pixmap()
        self['Coolman'] = ActionMap(['CoolTVGuideActions'], {'CoolOK': self.close,
         'CoolCancel': self.close,
         'CoolRed': self.close,
         'CoolGreen': self.close}, -1)
        self['key_red'] = Button(_('Cancel'))
        self['key_green'] = Button(_('Save'))
        self.hwayl.PictureData.get().append(self.kplam)
        self.onLayoutFinish.append(self.ncliv)

    def kplam(self, aqndd = ' '):
        if self.rbmoj is not None:
            ptr = self.hwayl.getData()
            self['Picture'].instance.setPixmap(ptr)
        return

    def ncliv(self):
        if self.rbmoj is not None:
            self.hwayl.setPara([self['Picture'].instance.size().width(),
             self['Picture'].instance.size().height(),
             1,
             1,
             False,
             1,
             '#121214'])
            self.hwayl.startDecode(self.rbmoj)
        return


class xckks(Screen):
    iiive = '<screen name="CTVGB" position="center,center" size="400,400" title="Choose bouquet">\n              <widget name="menu" position="25,25" size="350,350" scrollbarMode="showOnDemand" />\n          </screen>'

    def __init__(self, session, hsqzq, pvuzi, sfbbe = False):
        from Components.MenuList import MenuList
        Screen.__init__(self, session)
        self.skin = xckks.iiive
        self.skinName = 'BouquetSelector'
        self.pvuzi = pvuzi
        self['Coolman'] = ActionMap(['CoolTVGuideActions'], {'CoolOK': self.kbblv,
         'CoolCancel': self.akgsj}, -1)
        ijhwf = [ (x[0], x[1]) for x in hsqzq ]
        self['menu'] = MenuList(ijhwf, sfbbe)

    def akgsj(self):
        self.close(False)

    def getCurrent(self):
        cur = self['menu'].getCurrent()
        return cur and cur[1]

    def up(self):
        self['menu'].up()

    def down(self):
        self['menu'].down()

    def kbblv(self):
        self.hide()
        self.pvuzi(self.getCurrent())
        self.close(True)


class dgxiw():

    def __init__(self, hsqzq, sfbbe = False, znfby = 0):
        self.hsqzq = [ b[1] for b in hsqzq ]
        self.pos = znfby
        self.capbd = len(hsqzq)
        self.sfbbe = sfbbe

    def getCurrent(self):
        return self.hsqzq[self.pos]

    def up(self):
        if self.pos > 0 or self.sfbbe:
            self.pos = (self.pos - 1) % self.capbd

    def down(self):
        if self.pos < self.capbd - 1 or self.sfbbe:
            self.pos = (self.pos + 1) % self.capbd


class ahqox(VirtualKeyBoard, NumericalTextInput):

    def __init__(self, session, **kwargs):
        VirtualKeyBoard.__init__(self, session, **kwargs)
        self.skinName = 'VirtualKeyBoard'
        try:
            print self.sms_txt
        except:
            NumericalTextInput.__init__(self, nextFunc=self.nextFunc)
            self['NumberActions'] = NumberActionMap(['NumberActions'], {'1': self.dbddx,
             '2': self.dbddx,
             '3': self.dbddx,
             '4': self.dbddx,
             '5': self.dbddx,
             '6': self.dbddx,
             '7': self.dbddx,
             '8': self.dbddx,
             '9': self.dbddx,
             '0': self.dbddx})
            self.xwtwr = False

    def dbddx(self, number):
        xehdr = self.getKey(number)
        if not self.xwtwr:
            self.fbzgn = self['text'].getText()
            self.xwtwr = True
            self['text'].setMarkedPos(len(self.fbzgn))
        self['text'].setText(self.fbzgn + xehdr.encode('utf-8', 'ignore'))

    def nextFunc(self):
        self.fbzgn = self['text'].getText()
        self.xwtwr = False
        self['text'].setMarkedPos(-1)


class obhoe(bbukb):

    def __init__(self, phvkq = None, eyduj = None):
        bbukb.__init__(self, phvkq, eyduj)
        self.eyduj = eyduj
        self.bjjsb = (_('Mon'),
         _('Tue'),
         _('Wed'),
         _('Thu'),
         _('Fri'),
         _('Sat'),
         _('Sun'))
        self.uxwab = parseFont('Myriad;22', ((1, 1), (1, 1)))
        self.linbc = parseFont('Myriad;22', ((1, 1), (1, 1)))
        self.haqex = parseFont('Myriad;22', ((1, 1), (1, 1)))
        self.l.setFont(0, self.uxwab)
        self.l.setFont(1, self.linbc)
        self.l.setFont(2, self.haqex)
        self.l.setBuildFunc(self.eypyr)
        self.ebuuh = 0
        self.xonvd = 2
        self.dpker = 50
        self.qoooc = 70
        self.bzqxi = 2
        self.qqdwq = 70
        self.ilvoe = 500
        self.hdwjx = 2
        self.lerri = 700
        self.vdrsw = 230
        self.iuszb = 2
        self.lnyob = 280
        self.tzppv = 150
        self.cibam = 2
        self.ufeoc = 70
        self.mgmwk = None
        self.xicqa = None
        self.kczza = 16737792
        self.qlexj = 16777215
        self.yokms = 16777215
        self.dlfyd = None
        self.prnnl = None
        self.rylfn = 10425107
        self.brzlo = 11902465
        self.uuwni = 16737792
        self.hinjj = 3905737
        self.ljjjn = 16777215
        return

    def applySkin(self, desktop, parent):
        fpapv = []
        if self.skinAttributes is not None:
            for zayvt, value in self.skinAttributes:
                if zayvt == 'CoolFont':
                    self.uxwab = parseFont(value, ((1, 1), (1, 1)))
                    self.l.setFont(0, self.uxwab)
                elif zayvt == 'CoolServiceFont':
                    self.linbc = parseFont(value, ((1, 1), (1, 1)))
                    self.l.setFont(1, self.linbc)
                elif zayvt == 'CoolEventFont':
                    self.haqex = parseFont(value, ((1, 1), (1, 1)))
                    self.l.setFont(2, self.haqex)
                elif zayvt == 'CoolDayPos':
                    self.ebuuh = int(value)
                elif zayvt == 'CoolDayHPos':
                    self.xonvd = int(value)
                elif zayvt == 'CoolDatePos':
                    self.qoooc = int(value)
                elif zayvt == 'CoolDateHPos':
                    self.bzqxi = int(value)
                elif zayvt == 'CoolTimePos':
                    self.tzppv = int(value)
                elif zayvt == 'CoolTimeHPos':
                    self.cibam = int(value)
                elif zayvt == 'CoolServicePos':
                    self.vdrsw = int(value)
                elif zayvt == 'CoolServiceHPos':
                    self.iuszb = int(value)
                elif zayvt == 'CoolEventPos':
                    self.ilvoe = int(value)
                elif zayvt == 'CoolEventHPos':
                    self.hdwjx = int(value)
                elif zayvt == 'CoolDaySize':
                    self.dpker = int(value)
                elif zayvt == 'CoolDateSize':
                    self.qqdwq = int(value)
                elif zayvt == 'CoolTimeSize':
                    self.ufeoc = int(value)
                elif zayvt == 'CoolServiceSize':
                    self.lnyob = int(value)
                elif zayvt == 'CoolEventSize':
                    self.lerri = int(value)
                elif zayvt == 'CoolDayColor':
                    self.kczza = parseColor(value).argb()
                elif zayvt == 'CoolDateColor':
                    self.qlexj = parseColor(value).argb()
                elif zayvt == 'CoolTimeColor':
                    self.hinjj = parseColor(value).argb()
                elif zayvt == 'CoolServiceColor':
                    self.uuwni = parseColor(value).argb()
                elif zayvt == 'CoolEventColor':
                    self.yokms = parseColor(value).argb()
                elif zayvt == 'CoolBackColor':
                    self.mgmwk = parseColor(value).argb()
                elif zayvt == 'CoolBackColorSel':
                    self.xicqa = parseColor(value).argb()
                elif zayvt == 'CoolFontColSel':
                    self.ljjjn = parseColor(value).argb()
                elif zayvt == 'CoolEventBackColor':
                    self.dlfyd = parseColor(value).argb()
                elif zayvt == 'CoolRecEventBackColor':
                    self.prnnl = parseColor(value).argb()
                elif zayvt == 'CoolRecAlarmCol':
                    self.brzlo = parseColor(value).argb()
                elif zayvt == 'CoolRecColor':
                    self.rylfn = parseColor(value).argb()
                else:
                    fpapv.append((zayvt, value))

        self.skinAttributes = fpapv
        return GUIComponent.applySkin(self, desktop, parent)

    def wntnl(self, vwjvv, cfyda, scdjh, ogyya):
        for x in self.eyduj.timer_list:
            if x.service_ref.ref.toString() == vwjvv:
                nbrjc = cfyda + scdjh
                ookve = x.begin
                igthq = x.end
                tiqly = ookve + (igthq - ookve) / 4
                if x.eit == ogyya:
                    if cfyda < ookve or nbrjc > igthq:
                        return False
                    else:
                        return True
                elif cfyda <= tiqly <= nbrjc:
                    if cfyda < ookve or nbrjc > igthq:
                        return False
                    else:
                        return True

        for x in self.eyduj.processed_timers:
            if x.disabled and x.service_ref.ref.toString() == vwjvv:
                if x.eit == ogyya:
                    return False

    def eypyr(self, vtewf, ogyya, cfyda, scdjh, wtsim):
        mjvfa = self.wntnl(vtewf, cfyda, scdjh, ogyya)
        t = localtime(cfyda)
        fupil = ServiceReference(vtewf)
        ncswo = wtsim
        qmwzm = self.gggoy()[0]
        if qmwzm is not None:
            jtzhd = qmwzm.getShortDescription()
            if jtzhd and jtzhd != wtsim:
                ncswo = wtsim + ' - ' + jtzhd
        if mjvfa == True:
            nchkm = gdfeo = lmjgq = vsdxy = gzgpa = jgzct = self.rylfn
            gqjxw = self.prnnl
        elif mjvfa == False:
            nchkm = gdfeo = lmjgq = vsdxy = gzgpa = jgzct = self.brzlo
            gqjxw = self.prnnl
        else:
            gdfeo = self.uuwni
            lmjgq = self.yokms
            vsdxy = self.kczza
            gzgpa = self.qlexj
            jgzct = self.hinjj
            gqjxw = self.dlfyd
            nchkm = self.ljjjn
        res = [None, (eListboxPythonMultiContent.TYPE_TEXT,
          self.ebuuh,
          self.xonvd,
          self.dpker,
          50,
          0,
          RT_HALIGN_RIGHT,
          self.bjjsb[t[6]],
          vsdxy,
          nchkm,
          self.mgmwk,
          self.xicqa)]
        res.append(MultiContentEntryText(pos=(self.qoooc, self.bzqxi), size=(self.qqdwq, 50), font=0, text='%02d.%02d' % (t[2], t[1]), color=gzgpa, color_sel=nchkm, backcolor=self.mgmwk, backcolor_sel=self.xicqa, border_width=0, border_color=self.mgmwk))
        res.append(MultiContentEntryText(pos=(self.tzppv, self.cibam), size=(self.ufeoc, 50), font=0, text='%02d:%02d' % (t[3], t[4]), color=jgzct, color_sel=nchkm, backcolor=self.mgmwk, backcolor_sel=self.xicqa, border_width=0, border_color=self.mgmwk))
        res.append(MultiContentEntryText(pos=(self.vdrsw, self.iuszb), size=(self.lnyob, 50), font=1, text=fupil.getServiceName(), color=gdfeo, color_sel=nchkm, backcolor=self.mgmwk, backcolor_sel=self.xicqa))
        res.append(MultiContentEntryText(pos=(self.ilvoe, self.hdwjx), size=(self.lerri, 50), font=2, text=ncswo, color=lmjgq, color_sel=nchkm, backcolor=gqjxw, backcolor_sel=self.xicqa))
        return res


class kpult(ynrgr):

    def __init__(self, session, *args):
        Screen.__init__(self, session)
        self.skinName = 'CoolSearch'
        if opspy == 720:
            iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSearch_720.xml'
        elif opspy == 1024:
            iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSearch_1024.xml'
        else:
            iiive = '/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/CoolSkin/CoolSearch_1280.xml'
        thhxl = open(iiive)
        self.skin = thhxl.read()
        thhxl.close()
        self['key_red'] = Button('')
        self['key_yellow'] = Button(_('New Search'))
        self['key_blue'] = Button(_('Last Search'))
        self['key_green'] = Button(_('Add Timer'))
        self.rzdhh = -1
        self.txocy = False
        self.zaauc = 0
        self.args = args
        self.bjjsb = (_('Mon'),
         _('Tue'),
         _('Wed'),
         _('Thu'),
         _('Fri'),
         _('Sat'),
         _('Sun'))
        self['date'] = Button()
        self['Event'] = Event()
        self['Service'] = ServiceEvent()
        self.quvtb = mefvr
        self.qhcgc = None
        self.njwlx = None
        self.fhxlg = None
        self.obyqg = None
        self.type = None
        self['list'] = obhoe(phvkq=self.ylgms, eyduj=session.nav.RecordTimer)
        self['Coolman'] = ActionMap(['CoolTVGuideActions'], {'CoolRed': self.bpknl,
         'CoolRecord': self.cbegh,
         'CoolGreen': self.sotem,
         'CoolGreenLong': self.krvdb,
         'CoolYellow': self.nrzcy,
         'CoolBlue': self.mngvi,
         'CoolOK': self.qwbyt,
         'CoolInfo': self.ftntd,
         'CoolInfoLong': self.omgdq,
         'CoolKeyTV': self.zmhiy,
         'CoolPower': self.xljhj,
         'CoolCancel': self.swxqt}, -1)
        self.onLayoutFinish.append(self.morod)
        self.brsbx()
        xxjug = config.CTVG.C12.value
        if xxjug == 'PrimeTime' or xxjug == 'Bouquet +' or xxjug == 'Bouquet -' or xxjug == 'Bouquetlist' or xxjug == 'Zap' or xxjug == 'Zap + Exit':
            xxjug = 'EPG Select'
        self['key_red'].setText(xxjug)
        return

    def hjxls(self):
        global aaqqx
        if aaqqx == 1:
            x = config.CTVG.C77.value
        elif aaqqx == 2:
            x = config.CTVG.C78.value
        elif aaqqx == 3:
            x = config.CTVG.C79.value
        elif aaqqx == 4:
            if mrbjc != self.quvtb and ozetp != self.quvtb:
                aaqqx = 1
                return self.close(False)
            x = config.CTVG.C80.value
        elif aaqqx == 5:
            x = config.CTVG.C81.value
        elif aaqqx == 6:
            x = config.CTVG.C82.value
        elif aaqqx == 7:
            x = config.CTVG.C83.value
        elif aaqqx == 8:
            x = config.CTVG.C84.value
        elif aaqqx == 9:
            x = config.CTVG.C85.value
        elif aaqqx == 10:
            x = config.CTVG.C86.value
        elif aaqqx == 11:
            x = config.CTVG.C87.value
        elif aaqqx == 12:
            x = config.CTVG.C88.value
        if x == '9':
            aaqqx += 1
            return self.hjxls()
        self.hide()
        if x == '1':
            self.khoww()
        elif x == '2':
            CSGmain(self.session, cixoa)
        elif x == '3':
            CEGmain(self.session, cixoa)
        elif x == '4':
            CCGmain(self.session, cixoa)
        elif x == '5':
            config.CTVG.C40.value = 1
            main(self.session, cixoa)
        elif x == '6':
            config.CTVG.C40.value = 2
            main(self.session, cixoa)
        elif x == '7':
            config.CTVG.C40.value = 3
            main(self.session, cixoa)
        elif x == '8':
            config.CTVG.C40.value = 4
            main(self.session, cixoa)
        else:
            if x == '10':
                aaqqx += 1
                return self.hjxls()
            if x == '11':
                aaqqx = 0
                self.session.open(TimerEditList)
            else:
                aaqqx = 0
        aaqqx += 1
        self.close(False)

    def brsbx(self):
        ojmzu = localtime()
        if (ojmzu.tm_year, ojmzu.tm_mon) >= (int(xyaoy[4:8]), int(baaaj[2])):
            self.swxqt()

    def mngvi(self):
        yyebq = [ (x, x) for x in config.CTVG.C10.value ]
        if yyebq:
            self.session.openWithCallback(self.jixef, ChoiceBox, title=_('Search for:'), list=yyebq)
        else:
            self.session.open(MessageBox, _('No history'), type=MessageBox.TYPE_INFO)

    def qwbyt(self):
        zplbd = config.CTVG.C20.value
        if zplbd == 'Zap':
            self.swxqt()
        elif zplbd == 'Zap + Exit':
            self.swxqt()
        elif zplbd == 'Cool Info Guide':
            self.khoww()
        elif zplbd == 'Timer':
            self.sotem()
        elif zplbd == 'QuickRec':
            self.cbegh()
        elif zplbd == 'AutoTimer':
            self.krvdb()
        else:
            self.khoww()

    def ftntd(self):
        jxgqg = config.CTVG.C22.value
        if jxgqg == '4':
            self.hjxls()
        elif jxgqg == '1':
            self.khoww()
        elif jxgqg == '2':
            self.nsdpj()
        elif jxgqg == '3':
            self.rqmfo()
        else:
            self.khoww()

    def omgdq(self):
        jsihv = config.CTVG.C23.value
        if jsihv == '4':
            self.hjxls()
        elif jsihv == '1':
            self.khoww()
        elif jsihv == '2':
            self.nsdpj()
        elif jsihv == '3':
            self.rqmfo()
        else:
            self.khoww()

    def bpknl(self):
        zkcgs = config.CTVG.C12.value
        if zkcgs == 'EPG Select':
            self.hjxls()
        elif zkcgs == 'Cool Info Guide':
            self.khoww()
        elif zkcgs == 'Timer':
            self.sotem()
        elif zkcgs == 'QuickRec':
            self.cbegh()
        elif zkcgs == 'AutoTimer':
            self.krvdb()
        else:
            self.hjxls()

    def morod(self):
        self.setTitle(_('Cool Search'))
        if self.args:
            self.aurie(*self.args)
        else:
            l = self['list']
            l.bnxvr()
            l.list = []
            l.l.setList(l.list)
        del self.args

    def ylgms(self):
        vunnx = self['list'].gggoy()
        qmwzm = vunnx[0]
        self['Event'].newEvent(qmwzm)
        puntx = ''
        if qmwzm is not None:
            ojmzu = time()
            ookve = qmwzm.getBeginTime()
            hcxyb = localtime(ojmzu)
            dsxwo = localtime(ookve)
            if hcxyb[2] != dsxwo[2]:
                puntx = '%s %d.%d.' % (self.bjjsb[dsxwo[6]], dsxwo[2], dsxwo[1])
            else:
                puntx = '%s %d.%d.' % (_('Today'), dsxwo[2], dsxwo[1])
        self['date'].setText(puntx)
        if vunnx[1] is None:
            self['Service'].newService(None)
        else:
            self['Service'].newService(vunnx[1].ref)
        if not qmwzm:
            self['key_green'].setText('')
            return
        else:
            gkpac = vunnx[1]
            argqx = qmwzm.getEventId()
            xudvj = gkpac.ref.toString()
            iibly = False
            for eyduj in self.session.nav.RecordTimer.timer_list:
                if eyduj.eit == argqx and eyduj.service_ref.ref.toString() == xudvj:
                    iibly = True
                    break

            if iibly:
                self['key_green'].setText(_('TimerEdit'))
            else:
                self['key_green'].setText(_('Timer'))
            return

    def nextService(self):
        if self.obyqg:
            self.obyqg(1, self)

    def prevService(self):
        if self.obyqg:
            self.obyqg(-1, self)

    def khoww(self):
        tqget = self['list'].gggoy()
        vtewf = tqget[1]
        kpjnf = tqget[0]
        if not kpjnf:
            return
        crujv = eServiceReference(str(vtewf))
        if crujv:
            self.session.open(mlayh, kpjnf, vtewf, crujv, self.nwics, kzqib=shuhr)

    def nsdpj(self):
        self.hide()
        CSGmain(self.session, cixoa)
        self.swxqt()

    def rqmfo(self):
        self.hide()
        CEGmain(self.session, cixoa)
        self.swxqt()

    def nwics(self, ocdis, setService, val):
        if val == -1:
            self.aqjqt()
        elif val == +1:
            self.ubhcc()
        fdqoy = self['list'].gggoy()
        setService(fdqoy[1])
        ocdis(fdqoy[0])

    def nrzcy(self):
        self.session.openWithCallback(self.aurie, ahqox, title=_('Search for:'))

    def xljhj(self):
        try:
            from Screens.SleepTimerEdit import SleepTimerEdit
            self.session.open(SleepTimerEdit)
        except:
            pass

    def krvdb(self):
        fdqoy = self['list'].gggoy()
        if not fdqoy:
            return
        try:
            from Plugins.Extensions.AutoTimer.AutoTimerEditor import addAutotimerFromEvent
            self.session.openWithCallback(self.vuzti, ChoiceBox, title=_('   check Autotimer ?'), list=[(_('Yes'), 'Yes'), (_('No'), 'No')])
            addAutotimerFromEvent(self.session, fdqoy[0], fdqoy[1])
        except:
            self.session.open(MessageBox, _('No AutoTimer seems to be installed. Please install it for this functionality.'), MessageBox.TYPE_ERROR)

    def vuzti(self, lagzl):
        lagzl = lagzl and lagzl[1]
        if lagzl == 'Yes':
            try:
                from Plugins.Extensions.AutoTimer.plugin import main as AutoTimerSafe
                AutoTimerSafe(self.session)
            except:
                self.session.open(MessageBox, _('No AutoTimer seems to be installed. Please install it for this functionality.'), MessageBox.TYPE_ERROR)

    def cbegh(self):
        bvxbx = self['list'].gggoy()
        vteiy = bvxbx[1]
        qmwzm = bvxbx[0]
        if not qmwzm:
            return
        else:
            argqx = qmwzm.getEventId()
            hjguy = vteiy.ref.toString()
            for eyduj in self.session.nav.RecordTimer.timer_list:
                if eyduj.eit == argqx and eyduj.service_ref.ref.toString() == hjguy:
                    self.session.nav.RecordTimer.removeEntry(eyduj)
                    self['list'].l.invalidate()
                    break
            else:
                aeoig = RecordTimerEntry(vteiy, checkOldTimers=True, *parseEvent(qmwzm))
                import NavigationInstance
                muysp = NavigationInstance.instance.RecordTimer.record(aeoig)
                if muysp is not None:
                    for x in muysp:
                        if x.setAutoincreaseEnd(aeoig):
                            self.session.nav.RecordTimer.timeChanged(x)

                    muysp = self.session.nav.RecordTimer.record(aeoig)
                    if muysp is not None:
                        self.session.openWithCallback(self.pfoza, TimerSanityConflict, muysp)
                self['list'].l.invalidate()

            self.ylgms()
            return

    def zmhiy(self):
        self.session.open(TimerEditList)

    def sotem(self):
        bpyut = self['list'].gggoy()
        wkhzm = bpyut[0]
        zqtmz = bpyut[1]
        if not wkhzm:
            return
        grgyl = wkhzm.getEventId()
        vwjvv = zqtmz.ref.toString()
        for eyduj in self.session.nav.RecordTimer.timer_list:
            if eyduj.eit == grgyl and eyduj.service_ref.ref.toString() == vwjvv:
                self.eyduj = eyduj
                self.session.openWithCallback(self.doxxi, ChoiceBox, title=_('Cool Timer Edit :' + '\n\n%s') % wkhzm.getEventName(), list=[(_('edit this Timer ?'), 'edit'), (_('delete this Timer ?'), 'delete'), (_('delete this Timer and recording ?'), 'delrec')])
                break
        else:
            aeoig = RecordTimerEntry(zqtmz, checkOldTimers=True, *parseEvent(wkhzm))
            self.session.openWithCallback(self.jhzuv, TimerEntry, aeoig)

    def doxxi(self, lagzl):
        eyduj = self.eyduj
        doxxi(self, eyduj, lagzl)

    def jhzuv(self, lagzl):
        if lagzl[0]:
            tjuhw = lagzl[1]
            fathd = self.session.nav.RecordTimer.record(tjuhw)
            if fathd is not None:
                for x in fathd:
                    if x.setAutoincreaseEnd(tjuhw):
                        self.session.nav.RecordTimer.timeChanged(x)

                fathd = self.session.nav.RecordTimer.record(tjuhw)
                if fathd is not None:
                    self.session.openWithCallback(self.pfoza, TimerSanityConflict, fathd)
            self['key_green'].setText(_('TimerEdit'))
        return

    def pfoza(self, lagzl):
        self.jhzuv(lagzl)

    def aurie(self, ihzdh = None, Save = True):
        if ihzdh:
            if Save:
                zltiu = config.CTVG.C10.value
                if ihzdh in zltiu:
                    zltiu.remove(ihzdh)
                    zltiu.insert(0, ihzdh)
                else:
                    zltiu.insert(0, ihzdh)
                    if len(zltiu) > 9:
                        zltiu.pop(9)
            if not config.CTVG.C11.value:
                try:
                    ihzdh = ihzdh.decode('UTF-8', 'replace').encode('ISO8859-15', 'replace')
                except (UnicodeDecodeError, UnicodeEncodeError):
                    pass

            epgcache = eEPGCache.getInstance()
            ret = epgcache.search(('RIBDT',
             500,
             eEPGCache.PARTIAL_TITLE_SEARCH,
             ihzdh,
             eEPGCache.NO_CASE_CHECK)) or []
            ret.sort(key=lambda x: x[2])
            l = self['list']
            l.bnxvr()
            l.list = ret
            l.l.setList(ret)

    def jixef(self, ret):
        if ret:
            self.aurie(ret[1])

    def swxqt(self):
        global aaqqx
        aaqqx = 1
        config.CTVG.save()
        self.close(self.txocy)


def doxxi(self, eyduj, lagzl):
    lagzl = lagzl and lagzl[1]
    if lagzl == 'delete':
        self.session.nav.RecordTimer.removeEntry(eyduj)
        return
    if lagzl == 'edit':
        self.session.open(TimerEntry, eyduj)
        return
    if lagzl == 'delrec':
        self.session.nav.RecordTimer.removeEntry(eyduj)
        from Tools.Directories import SCOPE_HDD
        from enigma import eBackgroundFileEraser
        vlvul = resolveFilename(SCOPE_HDD)
        vgcus = str(eyduj.service_ref.getServiceName())
        kulxj = '/.\\:*?<>|"'
        npqcx = ''
        for s in vgcus:
            if s in kulxj:
                s = '_'
            npqcx += s

        iuvap = strftime('%Y%m%d %H%M', localtime(eyduj.begin))
        npqcx = npqcx.replace('\xc2\x86', '').replace('\xc2\x87', '')
        npqcx = iuvap + ' - ' + npqcx
        brsxd = os.listdir(vlvul)
        for xfile in brsxd:
            if xfile.startswith(npqcx):
                eBackgroundFileEraser.getInstance().erase(os.path.realpath(vlvul + xfile))

        return


def qyjbi(yvnec = None):
    try:
        from Screens.InfoBar import InfoBar
        from Plugins.Extensions.EnhancedMovieCenter.plugin import showMoviesNew
        showMoviesNew(InfoBar.instance)
    except:
        from Screens.InfoBar import InfoBar
        InfoBar.showMovies(InfoBar.instance)


def CSmain(session, *args, **kwargs):
    xduyc = session.nav.getCurrentService()
    if xduyc:
        ayxei = xduyc.info()
        mrhyr = ayxei.getEvent(0)
        plfwt = mrhyr and mrhyr.getEventName() or ''
        session.open(kpult, plfwt, False)
    else:
        session.open(kpult)


def autostart(reason, **kwargs):
    global zgrqf
    if zgrqf is None:
        zgrqf = InfoBarPlugins.__init__
    InfoBarPlugins.__init__ = rixiq
    if config.CTVG.C31.value:
        InfoBarPlugins.bpknl = bpknl
    if config.CTVG.C32.value:
        InfoBarPlugins.edjzc = edjzc
    if config.CTVG.C33.value:
        InfoBarPlugins.ocpqd = ocpqd
    if config.CTVG.C34.value:
        InfoBarPlugins.ftntd = ftntd
    if config.CTVG.C35.value:
        InfoBarPlugins.ewqsm = ewqsm
    return


def rixiq(self):
    global vtwsp
    global yltlg
    if not vtwsp:
        vtwsp = True
        yltlg = self
        try:
            self['Red'] = ActionMap(['CoolTVGuide'], {'CoolRed': self.bpknl}, -1000)
        except:
            pass

        try:
            self['Green'] = ActionMap(['CoolTVGuide'], {'CoolGreen': self.edjzc}, -1000)
        except:
            pass

        try:
            self['Yellow'] = ActionMap(['CoolTVGuide'], {'CoolYellow': self.ocpqd}, -1000)
        except:
            pass

        try:
            self['Info'] = ActionMap(['CoolTVGuide'], {'CoolInfo': self.ftntd}, -1000)
        except:
            pass

        try:
            self['Down'] = ActionMap(['CoolTVGuide'], {'CoolDown': self.ewqsm}, -1000)
        except:
            pass

    else:
        InfoBarPlugins.__init__ = InfoBarPlugins.__init__
        InfoBarPlugins.bpknl = None
        InfoBarPlugins.edjzc = None
        InfoBarPlugins.ocpqd = None
        InfoBarPlugins.ftntd = None
        InfoBarPlugins.ewqsm = None
    zgrqf(self)
    return


def bpknl(self):
    main(self.session)


def edjzc(self):
    CSGmain(self.session)


def ocpqd(self):
    CEGmain(self.session)


def ftntd(self):
    CIGmain(self.session)


def ewqsm(self):
    CCGmain(self.session)


def CIGmain(session, servicelist = None, vtewf = None, **kwargs):
    global cixoa
    global xdooe
    if servicelist == None:
        from Screens.InfoBar import InfoBar
        if InfoBar and InfoBar.instance:
            servicelist = InfoBar.instance.servicelist
        else:
            session.open(MessageBox, _(' No function with your Image'), MessageBox.TYPE_ERROR)
            return
    xdooe = session
    cixoa = servicelist
    from Screens.InfoBar import InfoBar
    if InfoBar and InfoBar.instance:
        myiof(InfoBar.instance, vtewf)
    return


def changeServiceCB(self, axkko, epg):
    if self.serviceSel:
        if axkko > 0:
            self.serviceSel.nextService()
        else:
            self.serviceSel.prevService()
        epg.setService(self.serviceSel.currentService())


def myiof(self, vtewf = None):
    afvdb = self.session.nav.getCurrentlyPlayingServiceReference()
    self.luoih = eEPGCache.getInstance()
    zchmt = afvdb and afvdb.valid() and self.luoih.lookupEventTime(afvdb, -1)
    if afvdb:
        wgupq = cixoa.getRoot()
        jfqok = self.getBouquetServices(wgupq)
        self.serviceSel = SimpleServicelist(jfqok)
        if self.serviceSel.selectService(afvdb):
            self.session.openWithCallback(None, mlayh, zchmt, vtewf, afvdb, obyqg=self.changeServiceCB, cixoa=cixoa, kzqib=shuhr)
        else:
            afvdb = self.session.nav.getCurrentlyPlayingServiceReference()
            if self.serviceSel.selectService(afvdb):
                self.session.openWithCallback(None, mlayh, None, None, afvdb, obyqg=self.changeServiceCB, cixoa=cixoa, kzqib=shuhr)
    return


def bdohi(self):
    ymxsj = self.session.nav.getCurrentlyPlayingServiceReference()
    if ymxsj:
        wgupq = cixoa.getRoot()
        jfqok = self.getBouquetServices(wgupq)
        self.serviceSel = SimpleServicelist(jfqok)
        if self.serviceSel.selectService(ymxsj):
            self.session.open(ynrgr, ymxsj, obyqg=self.changeServiceCB, cixoa=cixoa, kzqib=xxdtq)
        else:
            ymxsj = self.session.nav.getCurrentlyPlayingServiceReference()
            if self.serviceSel.selectService(ymxsj):
                self.session.open(ynrgr, ymxsj, obyqg=self.changeServiceCB, cixoa=cixoa, kzqib=xxdtq)


def CSGmain(session, servicelist = None, **kwargs):
    global cixoa
    if servicelist == None:
        from Screens.InfoBar import InfoBar
        if InfoBar and InfoBar.instance:
            servicelist = InfoBar.instance.servicelist
        else:
            session.open(MessageBox, _(' No function with your Image'), MessageBox.TYPE_ERROR)
            return
    cixoa = servicelist
    from Screens.InfoBar import InfoBar
    if InfoBar and InfoBar.instance:
        bdohi(InfoBar.instance)
    return


def vrfrz(hjwwl):
    global fkqeh
    dylxl = getBouquetServices(hjwwl)
    if len(dylxl):
        fkqeh = hjwwl
        cefiv.append(xdooe.openWithCallback(rlaga, txjto, dylxl, wxzan, cixoa, ServiceReference(fkqeh).getServiceName(), kzqib=baaaj))
        return True
    return False


def blrrj(xdooe):
    global hsqzq
    global suphf
    hsqzq = cixoa.getBouquetList()
    if hsqzq is None:
        cnt = 0
    else:
        cnt = len(hsqzq)
    if cnt > 1:
        suphf = xdooe.openWithCallback(rlaga, xckks, hsqzq, vrfrz, sfbbe=True)
        cefiv.append(suphf)
    elif cnt == 1:
        if not vrfrz(hsqzq[0][1]):
            qcjah()
    return


def pqcof():
    global hsqzq
    global suphf
    hsqzq = cixoa.getBouquetList()
    if hsqzq is None:
        cnt = 0
    else:
        cnt = len(hsqzq)
    juyho = cixoa.getRoot()
    if cnt > 1:
        znfby = 0
        mbtuk = juyho.toCompareString()
        for x in hsqzq:
            if x[1].toCompareString() == mbtuk:
                break
            znfby += 1

        if znfby >= cnt:
            znfby = 0
        suphf = dgxiw(hsqzq, True, znfby)
    if cnt >= 1:
        if not vrfrz(juyho):
            qcjah()
    return


def CEGmain(session, servicelist = None, **kwargs):
    global cixoa
    global xdooe
    if servicelist is None:
        from Screens.InfoBar import InfoBar
        if InfoBar and InfoBar.instance:
            servicelist = InfoBar.instance.servicelist
        else:
            session.open(MessageBox, _(' No function with your Image'), MessageBox.TYPE_ERROR)
            return
    xdooe = session
    cixoa = servicelist
    pqcof()
    return


def lnwxj(hjwwl):
    dylxl = []
    oskhu = eServiceCenter.getInstance().list(hjwwl)
    if oskhu is not None:
        while True:
            vtewf = oskhu.getNext()
            if not vtewf.valid():
                break
            if vtewf.flags & eServiceReference.isDirectory:
                continue
            dylxl.append(ServiceReference(vtewf))

    return dylxl


def bichs(hjwwl):
    global fkqeh
    dylxl = lnwxj(hjwwl)
    if len(dylxl):
        fkqeh = hjwwl
        cefiv.append(xdooe.openWithCallback(rlaga, wqaie, dylxl, tynnj, cixoa, ServiceReference(fkqeh).getServiceName(), kzqib=fqmck))
        return True
    return False


def tynnj(axkko, epg):
    global uhghe
    global fkqeh
    uhghe = None
    if suphf:
        if axkko > 0:
            suphf.down()
        else:
            suphf.up()
        hjwwl = suphf.getCurrent()
        dylxl = lnwxj(hjwwl)
        if len(dylxl):
            fkqeh = hjwwl
            epg.gfxnd(dylxl)
            epg.setTitle(ServiceReference(hjwwl).getServiceName())
    return


def avgbr(xdooe):
    global hsqzq
    global suphf
    hsqzq = cixoa.getBouquetList()
    if hsqzq is None:
        cnt = 0
    else:
        cnt = len(hsqzq)
    if cnt > 1:
        suphf = xdooe.openWithCallback(rlaga, xckks, hsqzq, bichs, sfbbe=True)
        cefiv.append(suphf)
    elif cnt == 1:
        if not bichs(hsqzq[0][1]):
            qcjah()
    return


def jvdsv():
    global hsqzq
    global suphf
    hsqzq = cixoa.getBouquetList()
    if hsqzq is None:
        cnt = 0
    else:
        cnt = len(hsqzq)
    juyho = cixoa.getRoot()
    if cnt > 1:
        znfby = 0
        mbtuk = juyho.toCompareString()
        for xbouquet in hsqzq:
            if xbouquet[1].toCompareString() == mbtuk:
                break
            znfby += 1

        if znfby >= cnt:
            znfby = 0
        suphf = dgxiw(hsqzq, True, znfby)
    if cnt >= 1:
        if not bichs(juyho):
            qcjah()
    return


def CCGmain(session, servicelist = None, **kwargs):
    global cixoa
    global xdooe
    if servicelist is None:
        from Screens.InfoBar import InfoBar
        if InfoBar and InfoBar.instance:
            servicelist = InfoBar.instance.servicelist
        else:
            session.open(MessageBox, _(' No function with your Image'), MessageBox.TYPE_ERROR)
            return
    xdooe = session
    cixoa = servicelist
    jvdsv()
    return


def tmcma(vtewf):
    if vtewf is not None:
        if cixoa.getRoot() != fkqeh:
            cixoa.clearPath()
            if cixoa.bouquet_root != fkqeh:
                cixoa.enterPath(cixoa.bouquet_root)
            cixoa.enterPath(fkqeh)
        cixoa.setCurrentSelection(vtewf)
        cixoa.zap()
    return


def getBouquetServices(hjwwl):
    dylxl = []
    zqjrb = eServiceCenter.getInstance().list(hjwwl)
    if zqjrb is not None:
        while True:
            vtewf = zqjrb.getNext()
            if not vtewf.valid():
                break
            if vtewf.flags & (eServiceReference.isDirectory | eServiceReference.isMarker):
                continue
            dylxl.append(ServiceReference(vtewf))

    return dylxl


def qcjah():
    global cixoa
    global xdooe
    global uhghe
    xdooe = None
    cixoa = None
    uhghe = None
    return


def rlaga(ret = False):
    global suphf
    sppgf = cefiv.pop()
    if suphf and sppgf == suphf:
        suphf = None
    hpigo = len(cefiv)
    if ret and hpigo > 0:
        cefiv[hpigo - 1].close(hpigo > 1)
    if hpigo <= 0:
        qcjah()
    return


def fvrkm(hjwwl):
    global fkqeh
    dylxl = getBouquetServices(hjwwl)
    if len(dylxl):
        fkqeh = hjwwl
        cefiv.append(xdooe.openWithCallback(rlaga, mmtrp, dylxl, wxzan, ServiceReference(fkqeh).getServiceName(), kzqib=yacuo))
        return True
    return False


def wxzan(axkko, epg):
    global uhghe
    global fkqeh
    uhghe = None
    if suphf:
        if axkko > 0:
            suphf.down()
        else:
            suphf.up()
        hjwwl = suphf.getCurrent()
        jfqok = getBouquetServices(hjwwl)
        if len(jfqok):
            fkqeh = hjwwl
            epg.gfxnd(jfqok)
            epg.setTitle(ServiceReference(hjwwl).getServiceName())
    return


def xmvvd(xdooe):
    global hsqzq
    global suphf
    hsqzq = cixoa.getBouquetList()
    if hsqzq is None:
        cnt = 0
    else:
        cnt = len(hsqzq)
    if cnt > 1:
        suphf = xdooe.openWithCallback(rlaga, xckks, hsqzq, fvrkm, sfbbe=True)
        cefiv.append(suphf)
    elif cnt == 1:
        if not fvrkm(hsqzq[0][1]):
            qcjah()
    return


def kxwwl():
    global hsqzq
    global suphf
    hsqzq = cixoa.getBouquetList()
    if hsqzq is None:
        cnt = 0
    else:
        cnt = len(hsqzq)
    xudjz = cixoa.getRoot()
    if cnt > 1:
        znfby = 0
        mbtuk = xudjz.toCompareString()
        for hjwwl in hsqzq:
            if hjwwl[1].toCompareString() == mbtuk:
                break
            znfby += 1

        if znfby >= cnt:
            znfby = 0
        suphf = dgxiw(hsqzq, True, znfby)
    if cnt >= 1:
        if not fvrkm(xudjz):
            qcjah()
    return


def main(session, servicelist = None, **kwargs):
    global cixoa
    global xdooe
    if (localtime().tm_year, localtime().tm_mon) >= (2019, 12):
        session.open(MessageBox, ktyve, MessageBox.TYPE_INFO)
    if servicelist == None:
        from Screens.InfoBar import InfoBar
        if InfoBar and InfoBar.instance:
            servicelist = InfoBar.instance.servicelist
        else:
            session.open(MessageBox, _(' No function with your Image'), MessageBox.TYPE_ERROR)
            return
    xdooe = session
    cixoa = servicelist
    if config.CTVG.C36.value:
        xmvvd(xdooe)
    else:
        kxwwl()
    return


def OpenSetup(session, **kwargs):
    try:
        session.openWithCallback(rgdse(session), cxpnt)
    except:
        pass


def rgdse(session):
    if mrbjc != config.CTVG.Key.value and ozetp != config.CTVG.Key.value:
        session.open(MessageBox, Po, MessageBox.TYPE_INFO)


def Plugins(**kwargs):
    des = _('Cool TV Guide 3D EPG with switchable 5-24 TV-Lines and changeable Buttons with Setup')
    return [PluginDescriptor(name='Cool TV Guide', description=des, where=PluginDescriptor.WHERE_EVENTINFO, needsRestart=False, fnc=main),
     PluginDescriptor(name='Cool Easy Guide', description=des, where=PluginDescriptor.WHERE_EVENTINFO, needsRestart=False, fnc=CEGmain),
     PluginDescriptor(name='Cool Single Guide', description=des, where=PluginDescriptor.WHERE_EVENTINFO, needsRestart=False, fnc=CSGmain),
     PluginDescriptor(name='Cool Info Guide', description=des, where=PluginDescriptor.WHERE_EVENTINFO, needsRestart=False, fnc=CIGmain),
     PluginDescriptor(name='Cool Channel Guide', description=des, where=PluginDescriptor.WHERE_EVENTINFO, needsRestart=False, fnc=CCGmain),
     PluginDescriptor(where=PluginDescriptor.WHERE_SESSIONSTART, fnc=autostart),
     PluginDescriptor(name='Cool TV Guide ' + wjtzs + ' (Setup)', description=_('configuration of all Guides for your special wishes'), where=PluginDescriptor.WHERE_PLUGINMENU, icon='CoolTVGuide.png', fnc=OpenSetup),
     PluginDescriptor(name='Cool TV Guide', description=des, where=PluginDescriptor.WHERE_EXTENSIONSMENU, needsRestart=False, fnc=main),
     PluginDescriptor(name='Cool Easy Guide', description=des, where=PluginDescriptor.WHERE_EXTENSIONSMENU, needsRestart=False, fnc=CEGmain),
     PluginDescriptor(name='Cool Single Guide', description=des, where=PluginDescriptor.WHERE_EXTENSIONSMENU, needsRestart=False, fnc=CSGmain),
     PluginDescriptor(name='Cool Info Guide', description=des, where=PluginDescriptor.WHERE_EXTENSIONSMENU, needsRestart=False, fnc=CIGmain),
     PluginDescriptor(name='Cool Channel Guide', description=des, where=PluginDescriptor.WHERE_EXTENSIONSMENU, needsRestart=False, fnc=CCGmain)]